'From Squeak2.8 of 13 June 2000 [latest update: #2359] on 22 April 2001 at 8:08:17 pm'!
"Change Set:		Comanche45
Date:			19 February 2000
Author:			Bolot Kerimbaev

Comanche 4.5

Changes since Comanche 4.0:
4.1 + 4.2
- index files (now can serve index.html/default.html)
-- controlled from ComanchePreferences
- more solid HttpAdaptor pvtDestroy
- HTTP/0.9 requests (GET /path)

4.3
- remove some obsolete methods
- remove classes: PingModule, HttpConnectionQueue
- HttpRedirect, HttpBadRequest
- fix to HttpRequest>>decodeUrlEncodedForm: (return empty dictionary on no data, rather than self)

4.4
- upload: no longer force lower-case filename
- upload: delete file if it already exists (to remedy the problem with garbage at end of file on repeated uploads)
- SSP (Squeak Server Pages): 'my name is SSP' (rephrased from Matrix, the movie
- SSP: start some major refactoring, added compiler and parser
- SSP: page now can directly access request
- Comanche class: remove unused methods and class vars
- Debugging: #suppressErrors preference
- Form: knows how to serve itself as GIF (depth <= 8) or JPEG
- RemoteDisplayModule: serve the current screen

4.5
"!

Object subclass: #AccessControlList
	instanceVariableNames: 'allowed denied defaultPermissions '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-Access Control'!

!AccessControlList commentStamp: '<historical>' prior: 0!
AccessControlList
3 Dictionaries

allowed = user->Set (actions)
denied = user->Set (actions)
defaultPermissions = action->boolean

by default HttpRequest's operation is nil
defaultPermissions at: nil is true
thus, an operation that's not defined is allowed unless denied!
Object subclass: #AsyncFile
	instanceVariableNames: 'name writeable semaphore fileHandle size position '
	classVariableNames: 'Busy Error '
	poolDictionaries: ''
	category: 'System-Files'!
Object subclass: #Comanche
	instanceVariableNames: ''
	classVariableNames: 'ComanchePreferences '
	poolDictionaries: ''
	category: 'Comanche-Server'!

!Comanche commentStamp: '<historical>' prior: 0!
Comanche

a new web server for Squeak

The simultaneous connections are handled by HttpConnectionQueue
Comanche is not instantiated, but used for Server management and accounting
All processing happens inside ComancheModule (and subclasses) instances

HttpStream and HttpRequest handle incoming HTTP data
HttpResponse is used for outgoing HTTP data

When a connection is initiated, the root module is started with httpStartOnSocket:
which in turn produces an HttpRequest from the socket and calls process:

Module process: attempts to convert the HttpRequest to its "native" request format
If it fails, the request cannot be handled by the module
If a module handles the request, the request is processed as follows:
- module performs preprocessing
- each of its children modules do process: (see above - recursive)
- module performs postprocessing

A module may determine that its handling takes care of the request
and no further processing is needed

This component-based model allows easy combination of simple modules
into a powerful super-module (as in super-man)
- case study: a Swiki
  - Swiki = as parent
    - bare bones (search is outsourced)
  - FileServer
    - mini-FTP
    - provides uploads
  - SearchEngine
    - search the index and return a results page
    - using the parent's index
  - SpellChecking

Each module optionally supports persistence.

Big TODO list
- make pluggable:
  - formatters - HTML, VRML, email, etc.
  - templates - regular, rendering, cached, etc.
  - spellers - to select languages, professions
  - externalizers/persistence - to choose among formats - XML, RefStream, etc.
!
]style[(8 1610)bcblue;f2,f1!
Object subclass: #ComancheModule
	instanceVariableNames: 'name tempDir workDir logfile '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-Server'!

!ComancheModule commentStamp: '<historical>' prior: 0!
ComancheModule

a module is a component that can be part of another module

each module can have peer modules and children modules

peer modules can be shared among modules
- for things like authorization, accounting, logging
- they can influence the way a module processes the request
  - e.g., authorization module returns an error, thus terminate

children modules provide value added services
- e.g., formatting, spell checking!
]style[(14 417)f2cblue;b,f1!
ComancheModule subclass: #AccessControlModule
	instanceVariableNames: 'accessControlList '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-Access Control'!

!AccessControlModule commentStamp: '<historical>' prior: 0!
AccessControlModule
- implements access control lists (not yet!!)
- to be effective, must be used before data serving modules
  (say right after DomainFilterModule)
- realm is name (e.g. AccessControlModule newModuleNamed: 'squeak/myswiki')!
ComancheModule subclass: #ComancheCompositeModule
	instanceVariableNames: 'modules '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-Server'!
Object subclass: #ComancheServer
	instanceVariableNames: 'connectionHandler serviceProvider '
	classVariableNames: 'Servers '
	poolDictionaries: ''
	category: 'Comanche-Server'!

!ComancheServer commentStamp: '<historical>' prior: 0!
ComancheServer

This class has not yet been commented.!
]style[(14 40)f4bcblue;,f1!
ComancheServer class
	instanceVariableNames: ''!
Object subclass: #ComancheService
	instanceVariableNames: 'autoStart log '
	classVariableNames: 'Services '
	poolDictionaries: ''
	category: 'Comanche-Service Framework'!

!ComancheService commentStamp: '<historical>' prior: 0!
ComancheServer

I am an abstract superclass.  My subclasses are services that can be established on any port.  For example, to start a Swiki service, one might evaluate:

!
]style[(14 158)f4bcblue;,f1!
ComancheService subclass: #ComancheNetService
	instanceVariableNames: 'comancheServer protocolAdaptor module '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-Service Framework'!

!ComancheNetService commentStamp: '<historical>' prior: 0!
ComancheNetService

I'm a service that sets up a ComancheServer to listen on a given port.  I use a protocol adaptor to adapts TCP/IP based protocol conversations into message based conversations.

protocolAdaptor - an object that supports the NetworkProtocolAdaptor class interface (specifically, I send it #processSocket:target:).
comancheServer - an instance of a ComancheServer that handles all the details of setting up to listen for sockets on a given port.

!
]style[(18 447)f4bcblue;,f1!
ComancheService class
	instanceVariableNames: ''!
ComancheNetService class
	instanceVariableNames: ''!
Object subclass: #ConnectionHandler
	instanceVariableNames: 'portNumber socketClass process priority handlerBlock lastError socketsToDestroy '
	classVariableNames: 'Registry '
	poolDictionaries: ''
	category: 'Comanche-Server'!
ConnectionHandler class
	instanceVariableNames: ''!
ComancheModule subclass: #DomainFilterModule
	instanceVariableNames: 'allowedDomains deniedDomains '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-Server'!

!DomainFilterModule commentStamp: '<historical>' prior: 0!
DomainFilterModule
	allow: ip-pattern, domain-pattern
	deny: ip-pattern, domain-pattern

- to be effective, must be used before any modules
  that write back to the client

- as other service modules, over-rides process:
  thus disabling any use of submodules!
Object subclass: #DummyService
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-Server'!
Error subclass: #FileDoesNotExist
	instanceVariableNames: 'fileName fileStreamClass '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-Exceptions'!
ComancheModule subclass: #FileServerModule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-Server'!
Object subclass: #GenericLog
	instanceVariableNames: 'fileNameTemplate logDirectory writingProcess chunkQueue '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-Logging'!
Error subclass: #HttpBadRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-Exceptions'!
Object subclass: #HttpCookie
	instanceVariableNames: 'name value expires path domain '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-HTTP Support'!

!HttpCookie commentStamp: '<historical>' prior: 0!
HttpCookie

This class has not yet been commented.!
]style[(10 40)f4cblue;b,f1!
HttpCookie class
	instanceVariableNames: ''!
GenericLog subclass: #HttpLog
	instanceVariableNames: 'currentSegment oldSegments '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-Logging'!
Object subclass: #HttpLogEntry
	instanceVariableNames: 'date time cIp csUserName sSiteName sComputerName sIp csMethod csUriStem csUriQuery scStatus scBytes csBytes timeTaken sPort csVersion csUserAgent csReferer '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-Logging'!
Object subclass: #HttpLogSegment
	instanceVariableNames: 'entries time date '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-Logging'!
Error subclass: #HttpRedirect
	instanceVariableNames: 'location '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-Exceptions'!
Object subclass: #HttpResponse
	instanceVariableNames: 'contents contentType status request fields '
	classVariableNames: 'StatusCodes '
	poolDictionaries: ''
	category: 'Comanche-HTTP Support'!

!HttpResponse commentStamp: '<historical>' prior: 0!
HttpResponse

I am a response to an HttpRequest.  I can formulate an HTTP response and send it out over a socket.  An HttpAdapter will accept an HttpRequest, dispatch a method call to an HttpPlug (which will result in a stream or an error), and then formulat an instance of me to deliver the response to the client.!
]style[(12 303)f4cblue;b,f1!
HttpResponse class
	instanceVariableNames: ''!
Object subclass: #JdmColumn
	instanceVariableNames: 'table name size type flags decimalPlaces '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mysql-Driver'!
JdmColumn class
	instanceVariableNames: ''!
Object subclass: #JdmConnection
	instanceVariableNames: 'socket readStream writeStream serverInfo hashesByProtocol responsePacket clientCapabilities connectionSpec packetClass '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mysql-Driver'!
JdmConnection class
	instanceVariableNames: ''!
Object subclass: #JdmConnectionSpec
	instanceVariableNames: 'database host port user password '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mysql-Driver'!
Object subclass: #JdmDateHolder
	instanceVariableNames: 'date '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mysql-Driver'!
JdmDateHolder class
	instanceVariableNames: ''!
Object subclass: #JdmDateTime
	instanceVariableNames: 'date time '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mysql-Driver'!
JdmDateTime class
	instanceVariableNames: ''!
Object subclass: #JdmDoubleHolder
	instanceVariableNames: 'double '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mysql-Driver'!
JdmDoubleHolder class
	instanceVariableNames: ''!
Object subclass: #JdmErrorTable
	instanceVariableNames: 'errors '
	classVariableNames: 'ErrorTable '
	poolDictionaries: ''
	category: 'Mysql-Driver'!
JdmErrorTable class
	instanceVariableNames: ''!
Object subclass: #JdmFieldConverter
	instanceVariableNames: 'types '
	classVariableNames: 'Instance '
	poolDictionaries: ''
	category: 'Mysql-Driver'!
JdmFieldConverter class
	instanceVariableNames: ''!
Object subclass: #JdmFloatHolder
	instanceVariableNames: 'float '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mysql-Driver'!
JdmFloatHolder class
	instanceVariableNames: ''!
Object subclass: #JdmMysqlCommand
	instanceVariableNames: 'command message '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mysql-Driver'!
JdmMysqlCommand class
	instanceVariableNames: ''!
Object subclass: #JdmPacket
	instanceVariableNames: 'packetNumber size buffer stream '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mysql-Driver'!
JdmPacket subclass: #JdmInputPacket
	instanceVariableNames: 'readStream '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mysql-Driver'!
JdmInputPacket subclass: #JdmLargeSizeInputPacket
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mysql-Driver'!

!JdmLargeSizeInputPacket commentStamp: '<historical>' prior: 0!
JdmLargeSizeInputPacket was created instead of created for performance reasons.
JdmInputPacket could do a comparison on versions every time it is created, but
I thought it better to let the connection do it once and then create the appropriate
InputPacket class.

!
JdmPacket subclass: #JdmOutputPacket
	instanceVariableNames: 'writeStream '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mysql-Driver'!
JdmPacket class
	instanceVariableNames: ''!
Object subclass: #JdmResult
	instanceVariableNames: 'value type '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mysql-Driver'!
Object subclass: #JdmResultSet
	instanceVariableNames: 'columns connection columnsByName currentRow '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mysql-Driver'!
JdmResultSet class
	instanceVariableNames: ''!
Object subclass: #JdmRow
	instanceVariableNames: 'numColumns values isEmpty '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mysql-Driver'!
JdmRow class
	instanceVariableNames: ''!
Object subclass: #JdmServerInfo
	instanceVariableNames: 'protocol serverVersion serverThread hashSeed options '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mysql-Driver'!
JdmServerInfo class
	instanceVariableNames: ''!
Magnitude subclass: #JdmServerVersion
	instanceVariableNames: 'fileFormat release version '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mysql-Driver'!
JdmServerVersion class
	instanceVariableNames: ''!
Object subclass: #JdmStatement
	instanceVariableNames: 'connection '
	classVariableNames: 'MysqlQueries '
	poolDictionaries: ''
	category: 'Mysql-Driver'!
JdmStatement class
	instanceVariableNames: ''!
Object subclass: #JdmTimeHolder
	instanceVariableNames: 'time '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mysql-Driver'!
JdmTimeHolder class
	instanceVariableNames: ''!
Object subclass: #JdmTimestampHolder
	instanceVariableNames: 'timestamp '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mysql-Driver'!
JdmTimestampHolder class
	instanceVariableNames: ''!
Object subclass: #JdmTimestampPrintPolicy
	instanceVariableNames: ''
	classVariableNames: 'Instance '
	poolDictionaries: ''
	category: 'Mysql-Driver'!
JdmTimestampPrintPolicy class
	instanceVariableNames: ''!
Object subclass: #JdmTimestampReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mysql-Driver'!
ComancheModule subclass: #MultipartPostModule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-Server'!

!MultipartPostModule commentStamp: '<historical>' prior: 0!
MultipartPostModule
helper module
not a standalone module

sole purpose is to
- read the multipart form
- save results in files

PRE:
- http request with header completed

POST:
- http request with body completed

IMPLEMENTATION NOTES:
IE4 for Mac appends 128 bytes of Mac file system info
this fix assumes that the first chunk (body) is at least 128 bytes
(the below info could be used for setting type/creator)
	bytes	content
	0		0
	1		file name length
	2..N		file name
	66..69	file type
	70..73	file creator
!
Object subclass: #NetworkDialog
	instanceVariableNames: 'lifespan data answer lastRequest '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-Protocol Support'!
NetworkDialog class
	instanceVariableNames: ''!
Object subclass: #NetworkHost
	instanceVariableNames: 'fullName port name type '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-Protocol Support'!
NetworkHost class
	instanceVariableNames: ''!
Object subclass: #NetworkProtocolAdaptor
	instanceVariableNames: 'readStream writeStream target log '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-Protocol Support'!

!NetworkProtocolAdaptor commentStamp: '<historical>' prior: 0!
NetworkProtocolAdaptor

I represent an adaptor that adapts a network protocol into a message based dialog between me and my target.  Thus, I must have knowledge of the underlying network protocol.  My target must implement a protocol designed to work with a specific subclass.

*NOTE* At the moment, this class and subclasses only work as servers.  A small amount of additional work is needed to get them functioning as clients.

My subclasses should only be concerned with specializing for a particular network protocol.

Instance variables:

readStream - The stream to read requests or responses from.
writeStream - The stream to write requests or responses to.
target - The target object with which I will converse.
!
]style[(22 256 7 143 122 10 50 11 50 6 50)dNetworkProtocolAdaptor browse;;f4b,f1,f1cred;,f1cblack;,f1,f1cblue;,f1,cblue;f1,f1,f1cblue;,f1!
NetworkProtocolAdaptor subclass: #HttpAdaptor
	instanceVariableNames: 'request response startTime '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-HTTP Support'!

!HttpAdaptor commentStamp: '<historical>' prior: 0!
HTTPAdaptor

I encapsulate the HTTP protocol from my clients (who must support the HttpPlug interface).  I use an HttpRequest to pick apart a request and I use an HttpResponse to formulate a response.  Mainly, I broker the conversation, turning a request into a message send (to an HttpPlug) and converting the answer to an HttpResponse.  Thus, my clients must simply implement a message based protocol (eliminating the need for them to be concerned with HTTP syntax).!
]style[(11 457)f4cblue;b,f1!
NetworkProtocolAdaptor class
	instanceVariableNames: ''!
Object subclass: #NetworkRequest
	instanceVariableNames: 'properties session '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-Protocol Support'!

!NetworkRequest commentStamp: '<historical>' prior: 0!
NetworkRequest

This class has not yet been commented.!
NetworkRequest subclass: #HttpRequest
	instanceVariableNames: 'url postFields stream responseHeader operation header '
	classVariableNames: 'EndOfRequestMarker HttpStatusCodeDict '
	poolDictionaries: ''
	category: 'Comanche-HTTP Support'!

!HttpRequest commentStamp: '<historical>' prior: 0!
HttpRequest
	basic request

supports:
- authentication (basic)
- logging (printLogOn: printFullLogOn:)
- status!
NetworkRequest class
	instanceVariableNames: ''!
ComancheModule subclass: #ObjectServerModule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-ORB'!
HttpRequest subclass: #ObjectServerRequest
	instanceVariableNames: 'query uid '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-ORB'!
Link subclass: #Process
	instanceVariableNames: 'suspendedContext priority myList errorHandler context '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Processes'!
FileServerModule subclass: #PwsModule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-PWS interface'!

!PwsModule commentStamp: '<historical>' prior: 0!
Compatibility module for running PWS actions
PWS actions are set up in the regular manner
(PWS actions at: 'key' put: anAction, or use linkTo, etc.)
Then PwsModule uses PWS actions table!
HttpRequest subclass: #PwsRequest
	instanceVariableNames: 'peerName userId message fields log action '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-PWS interface'!
ComancheModule subclass: #RedirectModule
	instanceVariableNames: 'redirectMap '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-Server'!

!RedirectModule commentStamp: '<historical>' prior: 0!
RedirectModule

use a redirectMap to forward GET requests to their new location
currently, assume PWS-style Swiki redirects
i.e., /myswiki.N -> http://newplace/myswiki.N

redirModule addMappingFrom: 'cnn' to: 'http://cnn.com/'
!
ComancheModule subclass: #RemoteDisplayModule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-Demo'!

!RemoteDisplayModule commentStamp: '<historical>' prior: 0!
RemoteDisplayModule

Usage
http://.../remoteDisplay?project=projectName
by default, project is the default project!
Compiler subclass: #SSPCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-SSP'!
FileServerModule subclass: #SSPModule
	instanceVariableNames: 'compiledPagesCache '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-SSP'!

!SSPModule commentStamp: '<historical>' prior: 0!
SSPModule
functionality similar to ASP, ColdFusion, and PHP

TODO: come up with file extension convension
currently using .phd (huh, go figure!!)

rule 1: all code inside <? and ?> is copied as-is, and compiled
rule 2: all code outside is output using page stream nextPutAll:


<body>hello
<? stream nextPutAll: Time now printString ?>
bye</body>

is translated into:

stream nextPutAll: '<body>hello'.
stream nextPutAll: Time now printString.
stream nextPutAll: 'bye</body>'.
!
Object subclass: #SSPPage
	instanceVariableNames: 'request '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-SSP'!

!SSPPage commentStamp: '<historical>' prior: 0!
SSPPage
(this is a bit tauthological: Squeak Server Pages Page"

proxy for SSPModule's execution context
- this is the context within which the execution occurs
- used to limit access to only what we allow
!
Parser subclass: #SSPParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-SSP'!
Stream subclass: #BufferStream
	instanceVariableNames: 'buffer startPos endPos '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-Network'!

!BufferStream commentStamp: '<historical>' prior: 0!
BufferStream
- is-a ReadWriteStream on a String
- like a queue
  removeNext:/nextPutAll: protocol!
ReadStream subclass: #JdmLargeSizeReadStream
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mysql-Driver'!
ReadStream subclass: #JdmReadStream
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mysql-Driver'!
JdmReadStream class
	instanceVariableNames: ''!
Stream subclass: #SocketStream
	instanceVariableNames: 'socket inStream outStream header status '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-Network'!

!SocketStream commentStamp: '<historical>' prior: 0!
SocketStream
- stream interface to Socket
- HttpRequest (and other users) don't know anything about sockets

bolot 12/16/1999 15:01
- re-doing the interface
  - inStream will replace buffer
  - outStream will be the buffer for sending data
  - nextPut:/nextPutAll: will write to outStream
  - flush will be required to send data
- TODO
  - stop using buffer, eventually remove it
!
Object subclass: #TerminalObject
	instanceVariableNames: 'id lastAccess lifespan '
	classVariableNames: 'Instances Mutex RandomGenerator Undertaker '
	poolDictionaries: ''
	category: 'Comanche-HTTP Support'!
TerminalObject subclass: #NetworkDialogInterface
	instanceVariableNames: 'session step dialogStack process requestQueue responseQueue branchProcesses handlerBlock '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-Protocol Support'!
TerminalObject subclass: #NetworkSession
	instanceVariableNames: 'data dialogs '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-Protocol Support'!

!NetworkSession commentStamp: '<historical>' prior: 0!
NetworkSession

A Session can provide server-side storage of state/data between HTML pages. After creating a new session (which can be manipulated using at: and at:put:), it can be saved on the Sessions list by asking the Session class to store: the session. A random integer is returned as a key to the session, and the key can be stored in an HTML page in a hidden field.

A session can be retrieved by ID by asking Session to recall: an ID. A session can be retired when it is no longer useful.

Each recall: or use at:/at:put: "touches" (updates) the Session's last use time. A Session that is older than a certain period (default 30 minutes, in viableTime instance method) will generate an error. Every hour, the PWS, as part of its backup procedures, will clear out old sessions.
!
]style[(14 772)f4cblue;b,f1!
NetworkSession subclass: #HttpSession
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-HTTP Support'!

!HttpSession commentStamp: '<historical>' prior: 0!
HttpSession

No comment.!
]style[(11 1 12)f4cblue;b,f4cblue;,f1cblack;!
TerminalObject class
	instanceVariableNames: ''!
NetworkDialogInterface class
	instanceVariableNames: ''!
NetworkSession class
	instanceVariableNames: ''!
HttpSession class
	instanceVariableNames: ''!
Magnitude subclass: #TimeStamp
	instanceVariableNames: 'date time '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Magnitudes'!

!TimeStamp commentStamp: '<historical>' prior: 0!
An instance of this class serves as a container for a Date and a Time.  Because TimeStamp is a subclass of Magnitude, you can do lots of interesting comparisons and arithmetic operations with TimeStamps.

Structure:
	date	 --> a Date - The day on which the TimeStamp occurs.
	time --> a Time - The time at which the TimeStamp occurs.

Examples:
	TimeStamp current
	TimeStamp date: Date today time: Time now
	TimeStamp fromString: '1-10-2000 11:55:00 am'   "MM-DD-YYYY HH:MM:SS AM"
	TimeStamp current < TimeStamp noon
!
Error subclass: #Unauthorized
	instanceVariableNames: 'realm '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-Exceptions'!
Object subclass: #WebBrowser
	instanceVariableNames: 'headerString '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-Browsers'!
WebBrowser subclass: #InternetExplorer
	instanceVariableNames: 'majorVersion minorVersion '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-Browsers'!
WebBrowser subclass: #Netscape
	instanceVariableNames: 'majorVersion minorVersion '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-Browsers'!
WebBrowser class
	instanceVariableNames: ''!
InternetExplorer class
	instanceVariableNames: ''!
Netscape class
	instanceVariableNames: ''!
WriteStream subclass: #JdmWriteStream
	instanceVariableNames: 'outputPacket '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mysql-Driver'!
JdmWriteStream class
	instanceVariableNames: ''!
Object subclass: #XMLdocument
	instanceVariableNames: 'type implementation root '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Network-XML Parser'!

!XMLdocument commentStamp: '<historical>' prior: 0!
XMLdocument

bolot@cc.gatech.edu

the document that contains all nodes (elements)
the front-end for application developers
app devs should use XMLdocument and nodes hierarchy!
XMLdocument class
	instanceVariableNames: ''!
Object subclass: #XMLnode
	instanceVariableNames: 'name value type parent children attributes document '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Network-XML Parser'!

!XMLnode commentStamp: '<historical>' prior: 0!
XMLnode

bolot@cc.gatech.edu

it's an abstract node.
technically, should not be instantiated
however, has almost all functionality!
XMLnode subclass: #XMLcomment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Network-XML Parser'!

!XMLcomment commentStamp: '<historical>' prior: 0!
XMLcomment

bolot@cc.gatech.edu

just a comment

currently, does not strip starting and ending '--'
also, parser does not correctly handle embedded '<' and '>'!
XMLnode subclass: #XMLelement
	instanceVariableNames: 'specialHandlingType '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Network-XML Parser'!

!XMLelement commentStamp: '<historical>' prior: 0!
XMLelement

bolot@cc.gatech.edu

an element node
initialized from a tag
must either have a matching end tag or be an empty tag!
XMLnode class
	instanceVariableNames: ''!
XMLcomment class
	instanceVariableNames: ''!
XMLelement class
	instanceVariableNames: ''!
Object subclass: #XMLparser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Network-XML Parser'!

!XMLparser commentStamp: '<historical>' prior: 0!
XMLparser

bolot@cc.gatech.edu

Known issues
This is a simple parser, as such...
- it does not handle CDATA (yet), i.e., '<' and '>'
  embedded in the tags (comments or elements)
- some more go here...

Algorithm description

uses XMLtokenizer's token stream

ignores the first tokens until the first element node

- set the first element node to be the documentElement
- put the first element to the stack
- loop:
  - retrieve token
  - if it's an element token
    - if an end tag
      then
      - if start tag and this token nodeName differ
        then flag error
    - if not an end tag,
      then
      - add it to list of children
      - if not empty then put it to stack
  - if it's a text token and is not all separators
    then make it the value of the item on top of stack
  - if any other token, ignore (comments, commands, etc)
!
XMLparser class
	instanceVariableNames: ''!
XMLnode subclass: #XMLtext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Network-XML Parser'!

!XMLtext commentStamp: '<historical>' prior: 0!
XMLtext

bolot@cc.gatech.edu

in this implementation, just a temporary storage for strings
the parser only cares about its nodeValue!
XMLtext class
	instanceVariableNames: ''!
Object subclass: #XMLtoHTMLconverter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Network-XML Parser'!

!XMLtoHTMLconverter commentStamp: '<historical>' prior: 0!
XMLtoHTMLconverter

bolot@cc.gatech.edu

can do something like
XMLtoHTMLconverter browseFile: 'filename.xml'

it uses XMLparser to generate an XMLdocument out of the file
then it prints the HTML-ified document onto a stream

each XMLnode knows how to printHtmlOn:
and can do so recursively for each child

hopefully, nobody deliberately broke the parse tree
- e.g., if you make it cyclic... ha!! bad things happen
- or insert an item that can't printHtmlOn:!
XMLtoHTMLconverter class
	instanceVariableNames: ''!
Stream subclass: #XMLtokenizer
	instanceVariableNames: 'inputStream '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Network-XML Parser'!

!XMLtokenizer commentStamp: '<historical>' prior: 0!
XMLtokenizer

bolot@cc.gatech.edu

breaks the stream of characters into a stream of XMLnodes (aka token stream)
token stream is used by XMLparser to generate XMLdocument tree!
ComancheModule subclass: #XmlRpcModule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Comanche-XML RPC'!

!Object methodsFor: 'converting' stamp: 'SVP 8/23/1999 19:17'!
asHtmlDocumentForRequest: aNetworkRequest

	self error: 
		('The requested object (', 
		self asString, 
		'), could not be converted into HTML for your browser.')! !

!Object methodsFor: 'converting' stamp: 'SVP 8/23/1999 19:23'!
asHttpResponseTo: anHttpRequest

	^(self asHtmlDocumentForRequest: anHttpRequest) 
		asHttpResponseTo: anHttpRequest
! !

!Object methodsFor: 'as yet unclassified' stamp: 'SVP 7/28/1999 12:18'!
out

	Transcript show: self asString; cr; endEntry.! !

!Object methodsFor: 'MIME' stamp: 'SVP 8/17/1999 17:51'!
mimeType

	^MIMEDocument defaultContentType! !


!AccessControlList methodsFor: 'accessing' stamp: 'bolot 9/11/1999 16:25'!
allow: user toDo: action
	(denied includesKey: user)
		ifTrue: [(denied at: user) remove: action ifAbsent: []].

	(allowed at: user ifAbsent: [allowed at: user put: Bag new]) add: action! !

!AccessControlList methodsFor: 'accessing' stamp: 'bolot 8/18/1999 15:36'!
allowAllToDo: action
	denied do: [:user |
		user remove: action ifAbsent: []].

	defaultPermissions at: action put: false! !

!AccessControlList methodsFor: 'accessing' stamp: 'bolot 9/11/1999 16:25'!
deny: user toDo: action
	(allowed includesKey: user)
		ifTrue: [(allowed at: user) remove: action ifAbsent: []].

	(denied at: user ifAbsent: [denied at: user put: Bag new]) add: action! !

!AccessControlList methodsFor: 'accessing' stamp: 'bolot 8/18/1999 15:35'!
denyAllToDo: action
	allowed do: [:user |
		user remove: action ifAbsent: []].

	defaultPermissions at: action put: false! !

!AccessControlList methodsFor: 'accessing' stamp: 'bolot 8/18/1999 18:37'!
initialize
	allowed _ Dictionary new.
	denied _ Dictionary new.
	defaultPermissions _ Dictionary new.
	defaultPermissions at: nil put: true! !

!AccessControlList methodsFor: 'accessing' stamp: 'bolot 8/18/1999 15:32'!
is: user authorizedToDo: action
	((allowed at: user ifAbsent: ['']) includes: action)
		ifTrue: [^true].

	((denied at: user ifAbsent: ['']) includes: action)
		ifTrue: [^false].

	^(defaultPermissions at: action ifAbsent: [nil]) = true! !

!AccessControlList methodsFor: 'persistence' stamp: 'bolot 8/18/1999 15:28'!
saveTo: filename
	| f |
	f _ ReferenceStream fileNamed: filename.
	f nextPut: self.
	f close.! !


!AccessControlList class methodsFor: 'instance creation' stamp: 'bolot 9/11/1999 16:38'!
readProtectedFrom: aCollection
	"create an instance of me where users in aCollection
	are allowed to do the default operation, but nobody else"
	| acl |
	acl _ self new initialize.
	acl denyAllToDo: nil. "default permission for default operation is denied"
	aCollection do: [:aUser |
		acl allow: (self encode: aUser password: '') toDo: nil].
	^acl! !

!AccessControlList class methodsFor: 'instance creation' stamp: 'bolot 8/18/1999 15:27'!
restoreFrom: filename
	| f acl |
	f _ ReferenceStream fileNamed: filename.
	acl _ f next.
	f close.
	^acl! !

!AccessControlList class methodsFor: 'utilities' stamp: 'bolot 9/11/1999 16:38'!
encode: nameString password: pwdString
	"Encode per RFC1421 of the username:password combination."

	| clear code clearSize idx map |
	clear := (nameString, ':', pwdString) asByteArray.
	clearSize := clear size.
	[ clear size \\ 3 ~= 0 ] whileTrue: [ clear := clear, #(0) ].
	idx := 1.
	map := 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/'.
	code := WriteStream on: ''.
	[ idx < clear size ] whileTrue: [ code 
		nextPut: (map at: (clear at: idx) // 4 + 1);
		nextPut: (map at: (clear at: idx) \\ 4 * 16 + ((clear at: idx + 1) // 16) + 1);
   		nextPut: (map at: (clear at: idx + 1) \\ 16 * 4 + ((clear at: idx + 2) // 64) + 1);
   		nextPut: (map at: (clear at: idx + 2) \\ 64 + 1).
		idx := idx + 3 ].
	code := code contents.
	idx := code size.
	clear size - clearSize timesRepeat: [ code at: idx put: $=. idx := idx - 1].
	^code! !


!AsyncFile methodsFor: 'accessing' stamp: 'SVP 8/29/1999 16:35'!
atEnd

	^position > size! !

!AsyncFile methodsFor: 'accessing' stamp: 'SVP 8/29/1999 16:30'!
next: count
	| data sem |
	sem _ Semaphore new.
	self readByteCount: count fromFilePosition: position onCompletionDo: [ :buf |
		data _ buf.
		sem signal.
	].
	position _ position + count.
	sem wait.
	^data
	! !

!AsyncFile methodsFor: 'accessing' stamp: 'SVP 8/29/1999 16:15'!
position

	^position! !

!AsyncFile methodsFor: 'accessing' stamp: 'SVP 8/29/1999 16:33'!
size

	^size! !

!AsyncFile methodsFor: 'accessing' stamp: 'SVP 8/29/1999 16:33'!
size: count

	size _ count! !

!AsyncFile methodsFor: 'initialization' stamp: 'SVP 8/29/1999 16:23'!
initialize

	position _ 0.! !


!AsyncFile class methodsFor: 'instance creation' stamp: 'SVP 8/29/1999 16:33'!
from: aFileStream

	^self new
		size: aFileStream size;
		open: aFileStream name forWrite: aFileStream isReadOnly not;
		yourself
		! !

!AsyncFile class methodsFor: 'instance creation' stamp: 'SVP 8/29/1999 16:23'!
new

	^super new initialize! !


!Collection methodsFor: 'testing' stamp: 'SVP 8/3/1999 15:59'!
notEmpty
	"Answer whether the receiver contains any elements."

	^self isEmpty not! !


!Comanche class methodsFor: 'initialize-release' stamp: 'bolot 2/19/2000 16:15'!
initialize
	ComanchePreferences _ Dictionary new.
	ComanchePreferences
		at: #allowUploads put: true;
		at: #indexFileNames put: #('index.html' 'default.htm')! !

!Comanche class methodsFor: 'version' stamp: 'bolot 12/17/1999 01:54'!
ancientVersion
	"version that first introduced version numbering"
	^'1.0.1 beta 3.3'! !

!Comanche class methodsFor: 'version' stamp: 'bolot 12/17/1999 01:54'!
serverName
	^'Comanche ', self version! !

!Comanche class methodsFor: 'version' stamp: 'bolot 12/17/1999 01:49'!
setVersion: versionString
	self setPreference: #version toValue: versionString! !

!Comanche class methodsFor: 'version' stamp: 'bolot 12/17/1999 01:54'!
version
	^self preferenceAt: #version ifAbsent: [self ancientVersion]! !

!Comanche class methodsFor: 'preferences' stamp: 'bolot 9/11/1999 15:35'!
allowUploads
	^ComanchePreferences at: #allowUploads ifAbsent: [false]! !

!Comanche class methodsFor: 'preferences' stamp: 'bolot 2/20/2000 11:45'!
caseSensitiveFilenames
	^ComanchePreferences at: #caseSensitiveFilenames ifAbsent: [true]! !

!Comanche class methodsFor: 'preferences' stamp: 'bolot 1/21/2000 16:48'!
indexFileNames
	^ComanchePreferences at: #indexFileNames ifAbsent: [nil]! !

!Comanche class methodsFor: 'preferences' stamp: 'bolot 12/17/1999 01:53'!
preferenceAt: prefSymbol ifAbsent: aBlock
	^ComanchePreferences at: prefSymbol ifAbsent: [aBlock value]! !

!Comanche class methodsFor: 'preferences' stamp: 'bolot 9/11/1999 15:33'!
preferences
	^ComanchePreferences! !

!Comanche class methodsFor: 'preferences' stamp: 'bolot 12/17/1999 01:48'!
setPreference: prefSymbol toValue: aValue
	ComanchePreferences at: prefSymbol put: aValue! !

!Comanche class methodsFor: 'debugging' stamp: 'bolot 2/19/2000 16:22'!
suppressErrors
	^self preferenceAt: #suppressErrors ifAbsent: [true]! !


!ComancheModule methodsFor: 'accessing' stamp: 'bolot 7/16/1999 11:59'!
directory
	^workDir! !

!ComancheModule methodsFor: 'accessing' stamp: 'bolot 5/16/1999 15:58'!
name
	^name! !

!ComancheModule methodsFor: 'private' stamp: 'bolot 5/16/1999 15:58'!
privName: str
	name _ str! !

!ComancheModule methodsFor: 'private' stamp: 'bolot 5/19/1999 00:02'!
privTempDirNamed: path
	tempDir _ FileDirectory on: path! !

!ComancheModule methodsFor: 'private' stamp: 'bolot 7/16/1999 11:59'!
privWorkDirNamed: path
	workDir _ FileDirectory on: path! !

!ComancheModule methodsFor: 'private' stamp: 'bolot 5/19/1999 00:02'!
tempDir
	^tempDir! !

!ComancheModule methodsFor: 'initialization' stamp: 'bolot 1/5/2000 12:15'!
initialize
	self logToStream: (DummyStream on: '')! !

!ComancheModule methodsFor: 'initialization' stamp: 'bolot 1/5/2000 12:14'!
logToStream: stream
	logfile _ stream.
	logfile
		ifNotNil: [logfile setToEnd]
		ifNil: [logfile _ DummyStream on: '']! !

!ComancheModule methodsFor: 'processing' stamp: 'bolot 5/21/1999 02:02'!
filter: request
	" determine if this module handles request "
	^request! !

!ComancheModule methodsFor: 'processing' stamp: 'bolot 1/5/2000 20:31'!
logRequest: request
	"hack!!!!"
	"we defer logging until later..."
	"HttpAdaptor is responsible for actually writing the stuff out to the log file"
	Processor activeProcess contextAt: #log put: logfile.
	"logfile nextPutAll: (String streamContents: [:stream |
		request printLogOn: stream])"! !

!ComancheModule methodsFor: 'processing' stamp: 'bolot 1/5/2000 12:10'!
process: rawRequest
	self subclassResponsibility! !

!ComancheModule methodsFor: 'permissions' stamp: 'bolot 5/16/1999 17:16'!
checkAuthorization: request
	" return the access control "
	" including user (if any), permissions "
	^true! !

!ComancheModule methodsFor: 'permissions' stamp: 'bolot 5/15/1999 16:38'!
isAuthorized: request toDo: action
	" check authorization for a particular action "
	^false! !

!ComancheModule methodsFor: 'persistence' stamp: 'bolot 5/20/1999 01:18'!
readFrom: aStream
	" implement persistence "! !

!ComancheModule methodsFor: 'persistence' stamp: 'bolot 5/20/1999 01:18'!
writeOn: aStream
	" implement persistence "! !

!ComancheModule methodsFor: 'debugging' stamp: 'bolot 1/5/2000 12:18'!
printDebugOn: stream
	| specialVars |
	specialVars _ #(name parent).

	self class name printOn: stream.
	stream nextPutAll: ' ''', self name, ''' ('.

	(self class allInstVarNames select: [:string | (specialVars includes: string) not])
		do: [:string | stream nextPutAll: string, '=', (self instVarNamed: string) printString]
		separatedBy: [stream nextPutAll: '; '].
	stream nextPutAll: ')'! !


!AccessControlModule methodsFor: 'processing' stamp: 'bolot 8/18/1999 18:56'!
filter: request
	"always return a request"
	"but also add an operation(s) to it"

	"request privOperation: 'somehow decoded from request'."
	"e.g.: post and multipart => multipartPost"
	"post and form => write/edit/etc."
	"otherwise, just nil <=> read"

	^request! !

!AccessControlModule methodsFor: 'processing' stamp: 'bolot 8/9/1999 21:47'!
initialize
	super initialize.
	accessControlList _ AccessControlList new initialize! !

!AccessControlModule methodsFor: 'processing' stamp: 'bolot 8/9/1999 21:47'!
privAccessControlList: newList
	accessControlList _ newList! !

!AccessControlModule methodsFor: 'processing' stamp: 'bolot 1/5/2000 12:57'!
process: rawRequest
	" check if request action and user are allowed by accessControlList "
	| request |
	request _ self filter: rawRequest.
	(accessControlList is: request user authorizedToDo: request operation)
		ifFalse: [request unauthorizedFor: name].
	^true "done"! !


!ComancheCompositeModule methodsFor: 'processing' stamp: 'bolot 1/5/2000 12:08'!
filter: request
	" determine if this module handles request "
	^request! !

!ComancheCompositeModule methodsFor: 'processing' stamp: 'bolot 1/5/2000 12:09'!
logRequest: request
	logfile nextPutAll: (String streamContents: [:stream |
		request printLogOn: stream])! !

!ComancheCompositeModule methodsFor: 'processing' stamp: 'bolot 2/20/2000 11:47'!
process: rawRequest
	" standard module processing "
	" PRE: rawRequest is-a HttpRequest "
	" POST: returns nil if wants processing to continue, not-nil if done "
	| request answer |
	" check if I handle this rawRequest "
	(request _ self filter: rawRequest)
		ifNil: [^nil].

" DEBUG "
	"request asString displayAt: 10@50."
	"request method asString displayAt: 10@70."

	self processBeforeModules: request.
	answer _ self processModules: request.
	self processAfterModules: request.
	self logRequest: request.

" TODO: Processor yield - to let others run "

	^answer! !

!ComancheCompositeModule methodsFor: 'processing' stamp: 'bolot 1/5/2000 12:07'!
processAfterModules: request
	^request! !

!ComancheCompositeModule methodsFor: 'processing' stamp: 'bolot 1/5/2000 12:07'!
processBeforeModules: request
	^request! !

!ComancheCompositeModule methodsFor: 'processing' stamp: 'bolot 1/5/2000 12:52'!
processModules: request
	| answer |
	self modules do: [ :m | 
		(answer _ m process: request)
			ifNotNil: [ ^answer ]].
	^nil! !

!ComancheCompositeModule methodsFor: 'initialization' stamp: 'bolot 1/5/2000 12:15'!
initialize
	modules _ OrderedCollection new.
	self logToStream: (DummyStream on: '')! !

!ComancheCompositeModule methodsFor: 'accessing' stamp: 'bolot 1/5/2000 12:12'!
modules
	^modules! !

!ComancheCompositeModule methodsFor: 'debugging' stamp: 'bolot 1/5/2000 12:17'!
printDebugOn: stream
	| specialVars |
	specialVars _ #(name parent modules).

	self class name printOn: stream.
	stream nextPutAll: ' ''', self name, ''' ('.

	(self class allInstVarNames select: [:string | (specialVars includes: string) not])
		do: [:string | stream nextPutAll: string, '=', (self instVarNamed: string) printString]
		separatedBy: [stream nextPutAll: '; '].
	stream nextPutAll: ')'.

	stream nextPutAll: '; modules=('.
	modules do: [:m | m printDebugOn: stream]
		separatedBy: [stream nextPutAll: '; '].

	stream nextPutAll: ')'.! !


!ComancheModule class methodsFor: 'instance creation' stamp: 'bolot 8/10/1999 15:35'!
defaultDirectory
	| delim |
	delim _ FileDirectory slash.
	^FileDirectory default pathName , delim , 'www', delim! !

!ComancheModule class methodsFor: 'instance creation' stamp: 'bolot 8/11/1999 22:38'!
defaultTempDirectory
	| delim |
	delim _ FileDirectory slash.
	^FileDirectory default pathName , delim , 'temp', delim! !

!ComancheModule class methodsFor: 'instance creation' stamp: 'bolot 8/11/1999 22:38'!
newModuleNamed: str
	^self newModuleNamed: str
		workDir: self defaultDirectory
		tempDir: self defaultTempDirectory! !

!ComancheModule class methodsFor: 'instance creation' stamp: 'bolot 7/16/1999 12:01'!
newModuleNamed: str workDir: workDirPath tempDir: tempDirPath
	^self new initialize;
		privName: str;
		privWorkDirNamed: workDirPath;
		privTempDirNamed: tempDirPath! !

!ComancheModule class methodsFor: 'web server packages'!
package: packageSelector
	| module |
	(self respondsTo: packageSelector)
		ifTrue: [module _ self]
		ifFalse: [module _ self allSubclasses
				detect: [:m | m respondsTo: packageSelector]
				ifNone: []].

	module ifNotNil: [^module perform: packageSelector].
	^nil! !


!ComancheCompositeModule class methodsFor: 'instance creation' stamp: 'bolot 1/5/2000 12:27'!
basicWebServer
	" create a set of modules that collectively provide
	  a basic set of web services "

	| webServer fileServer uploadServer logFile |
	logFile _ FileStream fileNamed: 'comanche.log'.
	webServer _ self newModuleNamed: 'comanche'.
" add file server - aka plain vanilla web server "
	fileServer _ FileServerModule newModuleNamed: 'www'.
	fileServer logToStream: logFile.
	uploadServer _ MultipartPostModule newModuleNamed: 'upload'.
	webServer modules
		add: uploadServer;
		add: fileServer.

	^webServer! !

!ComancheCompositeModule class methodsFor: 'instance creation' stamp: 'bolot 1/5/2000 16:13'!
protectedWebServer
	"a standardWebServer with required log on"

	| webServer authorizer authorizationModule |
	webServer _ self standardWebServer.

	authorizer _ AccessControlList readProtectedFrom: #('guest').
	authorizationModule _ AccessControlModule newModuleNamed: 'squeak/aloha'.
	authorizationModule privAccessControlList: authorizer.
	webServer modules
		addFirst: authorizationModule.

	^webServer! !

!ComancheCompositeModule class methodsFor: 'instance creation' stamp: 'bolot 2/19/2000 16:02'!
sqiniWebServer
	" create a set of modules that collectively provide
	  a Sqini server, a-la Jini "

	| webServer fileServer uploadServer |
	webServer _ self newModuleNamed: 'comanche'.
	"active scripting server"
	webServer modules add: (SSPModule newModuleNamed: 'SSP').

	"Sqini server"
	webServer modules add: (ObjectServerModule newModuleNamed: 'SQINI').

	"file server - aka plain vanilla web server "
	fileServer _ FileServerModule newModuleNamed: 'www'.
	uploadServer _ MultipartPostModule newModuleNamed: 'upload'.
	fileServer modules add: uploadServer.
	webServer modules add: fileServer.

" add swiki server "
" add admin server "

	^webServer! !

!ComancheCompositeModule class methodsFor: 'instance creation' stamp: 'bolot 2/19/2000 16:02'!
standardWebServer
	" create a set of modules that collectively provide
	  a standard set of web services "

	| webServer fileServer uploadServer logFile |
	logFile _ FileStream fileNamed: ('comanche.', (Date today yyyymmdd), '.log').
	webServer _ self newModuleNamed: 'comanche'.
	"active scripting server"

	"file server - aka plain vanilla web server "
	fileServer _ FileServerModule newModuleNamed: 'www'.
	fileServer logToStream: logFile.
	uploadServer _ MultipartPostModule newModuleNamed: 'upload'.

	webServer modules
		add: (SSPModule newModuleNamed: 'SSP');
		add: uploadServer;
		add: fileServer.

" add swiki server "
" add admin server "

	^webServer! !


!ComancheServer methodsFor: 'printing' stamp: 'SVP 7/28/1999 17:37'!
printOn: aStream

	aStream nextPutAll: ('ComancheServer port: ', self portNumber asString).
	self isRunning ifTrue: [
		aStream nextPutAll: ' [running]'
	] ifFalse:[
		aStream nextPutAll: ' [stopped]'
	].! !

!ComancheServer methodsFor: 'starting and stopping' stamp: 'svp 12/1/1999 17:53'!
start

	self register.
	self connectionHandler start.
! !

!ComancheServer methodsFor: 'starting and stopping' stamp: 'svp 12/1/1999 17:53'!
stop

	self connectionHandler stop.
	self unregister.! !

!ComancheServer methodsFor: 'defaults' stamp: 'SVP 8/16/1999 11:22'!
defaultSocketClass

	^self class defaultSocketClass! !

!ComancheServer methodsFor: 'accessing' stamp: 'SVP 7/26/1999 21:48'!
connectionHandler

	^connectionHandler! !

!ComancheServer methodsFor: 'accessing' stamp: 'SVP 7/28/1999 12:52'!
portNumber

	^self connectionHandler portNumber! !

!ComancheServer methodsFor: 'accessing' stamp: 'SVP 8/27/1999 13:50'!
priority

	^self connectionHandler priority! !

!ComancheServer methodsFor: 'accessing' stamp: 'SVP 8/27/1999 13:50'!
priority: priorityLevel

	self connectionHandler priority: priorityLevel! !

!ComancheServer methodsFor: 'accessing' stamp: 'SVP 7/29/1999 18:49'!
serviceProvider

	^serviceProvider! !

!ComancheServer methodsFor: 'accessing' stamp: 'SVP 8/3/1999 08:52'!
socketClass

	^self connectionHandler socketClass! !

!ComancheServer methodsFor: 'accessing' stamp: 'SVP 8/3/1999 08:52'!
socketClass: aSocketClass

	self connectionHandler socketClass: aSocketClass! !

!ComancheServer methodsFor: 'private' stamp: 'SVP 9/14/1999 14:44'!
pvtHandlerBlock

	^[ :socket | [ self serviceProvider serve: socket ] forkAt: Processor timingPriority ]! !

!ComancheServer methodsFor: 'private' stamp: 'SVP 7/28/1999 17:47'!
register

	(self class portTaken: self portNumber) ifFalse: [
		self class register: self.
		^self
	].

	self error: ('There is already an active server on port ', self portNumber asString)! !

!ComancheServer methodsFor: 'private' stamp: 'SVP 7/28/1999 17:14'!
unregister

	self class unregister: self! !

!ComancheServer methodsFor: 'private' stamp: 'svp 12/1/1999 20:40'!
value: aSocket

	[ self serviceProvider serve: aSocket ] fork! !

!ComancheServer methodsFor: 'initialize-release' stamp: 'SVP 9/16/1999 19:53'!
initializeOnPort: aNumber priority: pNum serviceProvider: sp

	connectionHandler ifNotNil: [ connectionHandler stop ].
	connectionHandler _ ConnectionHandler
		onPort: aNumber
		handler: self
		priority: pNum.
	connectionHandler socketClass: self defaultSocketClass.
	serviceProvider _ sp.

	! !

!ComancheServer methodsFor: 'queries' stamp: 'svp 12/1/1999 17:53'!
isRunning

	^self connectionHandler isRunning
	! !


!ComancheServer class methodsFor: 'instance creation' stamp: 'SVP 7/26/1999 18:30'!
onPort: aNumber

	^self onPort: aNumber priority: self defaultPriority

	! !

!ComancheServer class methodsFor: 'instance creation' stamp: 'SVP 7/28/1999 12:24'!
onPort: aNumber priority: pNum

	^self onPort: aNumber priority: pNum serviceProvider: self defaultServiceProvider

	! !

!ComancheServer class methodsFor: 'instance creation' stamp: 'SVP 7/28/1999 17:09'!
onPort: aNumber priority: pNum serviceProvider: sp

	^super new initializeOnPort: aNumber priority: pNum serviceProvider: sp



	! !

!ComancheServer class methodsFor: 'instance creation' stamp: 'SVP 7/28/1999 12:44'!
onPort: aNumber serviceProvider: sp

	^self onPort: aNumber priority: self defaultPriority serviceProvider: sp

	! !

!ComancheServer class methodsFor: 'instance creation' stamp: 'SVP 7/26/1999 21:49'!
serveOnPort: aNumber

	^self serveOnPort: aNumber priority: self defaultPriority

	! !

!ComancheServer class methodsFor: 'instance creation' stamp: 'SVP 7/28/1999 12:27'!
serveOnPort: aNumber priority: pNum

	^self 
		serveOnPort: aNumber 
		priority: pNum 
		serviceProvider: self defaultServiceProvider

	! !

!ComancheServer class methodsFor: 'instance creation' stamp: 'SVP 7/28/1999 12:26'!
serveOnPort: aNumber priority: pNum serviceProvider: sp

	^(self onPort: aNumber priority: pNum serviceProvider: sp) start; yourself

	! !

!ComancheServer class methodsFor: 'instance creation' stamp: 'SVP 7/28/1999 12:43'!
serveOnPort: aNumber serviceProvider: sp

	^self serveOnPort: aNumber priority: self defaultPriority serviceProvider: sp

	! !

!ComancheServer class methodsFor: 'defaults' stamp: 'SVP 9/20/1999 16:34'!
defaultPriority

	^Processor timingPriority! !

!ComancheServer class methodsFor: 'defaults' stamp: 'svp 12/1/1999 16:37'!
defaultServiceProvider

	^DummyService new! !

!ComancheServer class methodsFor: 'defaults' stamp: 'SVP 8/16/1999 11:23'!
defaultSocketClass

	^Socket! !

!ComancheServer class methodsFor: 'accessing' stamp: 'SVP 7/28/1999 15:54'!
serverOnPort: portNumber ifAbsent: absentBlock 

	^self servers at: portNumber ifAbsent: absentBlock! !

!ComancheServer class methodsFor: 'initialization' stamp: 'SVP 7/26/1999 15:39'!
initialize
	"  ComancheServer initialize  "

	Servers _ Dictionary new.! !

!ComancheServer class methodsFor: 'registration' stamp: 'SVP 7/28/1999 17:28'!
portTaken: portNumber

	self servers at: portNumber ifAbsent: [ ^false ].
	^true! !

!ComancheServer class methodsFor: 'registration' stamp: 'SVP 7/28/1999 17:15'!
register: aComancheServer

	self servers at: aComancheServer portNumber ifAbsent: [
		^self servers at: aComancheServer portNumber put: aComancheServer.
	].
	self error: ('A server is already registered on port ', aComancheServer portNumber).! !

!ComancheServer class methodsFor: 'registration' stamp: 'SVP 7/28/1999 17:15'!
servers

	^Servers! !

!ComancheServer class methodsFor: 'registration' stamp: 'SVP 7/28/1999 17:48'!
unregister: aComancheServer

	self servers removeKey: 
		(self servers keyAtIdentityValue: aComancheServer ifAbsent: [ ^self ]).! !


!ComancheService methodsFor: 'startup and shutdown' stamp: 'SVP 7/28/1999 14:59'!
prepareForShutdown
	"The squeak system is about to shutdown"! !

!ComancheService methodsFor: 'startup and shutdown' stamp: 'SVP 7/28/1999 14:59'!
prepareForStartup
	"The squeak system just started up"! !

!ComancheService methodsFor: 'printing' stamp: 'SVP 7/28/1999 16:30'!
printOn: aStream

	aStream nextPutAll: ('Service: ', self name).
	self isRunning ifTrue: [ 
		aStream nextPutAll: '[running]'.
	] ifFalse: [
		aStream nextPutAll: '[stopped]'.
	].! !

!ComancheService methodsFor: 'accessing' stamp: 'SVP 7/28/1999 13:09'!
autoStart

	^autoStart == true! !

!ComancheService methodsFor: 'accessing' stamp: 'SVP 7/28/1999 13:09'!
autoStart: aBoolean

	autoStart _ aBoolean! !

!ComancheService methodsFor: 'accessing' stamp: 'svp 11/18/1999 11:42'!
log

	^log! !

!ComancheService methodsFor: 'accessing' stamp: 'svp 11/18/1999 11:42'!
log: aLog

	log _ aLog! !

!ComancheService methodsFor: 'accessing' stamp: 'SVP 7/28/1999 15:09'!
name

	^self class nameForService: self! !

!ComancheService methodsFor: 'initialization' stamp: 'SVP 7/28/1999 14:04'!
initialize

	autoStart _ false.
! !

!ComancheService methodsFor: 'registration' stamp: 'SVP 7/28/1999 15:01'!
registerAs: aString

	self unregister.
	self class addService: self named: aString! !

!ComancheService methodsFor: 'registration' stamp: 'SVP 7/28/1999 16:44'!
unregister

	self stop.
	self class removeService: self! !

!ComancheService methodsFor: 'queries' stamp: 'SVP 7/28/1999 14:46'!
isRunning

	self subclassResponsibility! !

!ComancheService methodsFor: 'starting and stopping' stamp: 'SVP 8/30/1999 23:17'!
start
	"Subclasses should override this method to take whatever
	is necessary to start this service"

	"self subclassResponsibility"! !

!ComancheService methodsFor: 'starting and stopping' stamp: 'SVP 8/30/1999 23:17'!
stop
	"Subclasses should override this method to take whatever
	is necessary to start this service"

	"self subclassResponsibility"! !


!ComancheNetService methodsFor: 'accessing' stamp: 'SVP 7/28/1999 15:31'!
comancheServer

	^comancheServer! !

!ComancheNetService methodsFor: 'accessing' stamp: 'SVP 8/16/1999 11:25'!
module
	"Answer a ComancheModule that will process network
	requests for this ComancheNetService"

	^module! !

!ComancheNetService methodsFor: 'accessing' stamp: 'SVP 8/16/1999 11:30'!
module: aComancheModule

	module _ aComancheModule! !

!ComancheNetService methodsFor: 'accessing' stamp: 'SVP 7/28/1999 15:30'!
portNumber

	^self comancheServer portNumber! !

!ComancheNetService methodsFor: 'accessing' stamp: 'SVP 8/27/1999 13:20'!
portNumber: portNumber

	| running priority |
	running _ self isRunning.
	priority _ self class defaultPriority.

	comancheServer ifNotNil: [ 
		priority _ comancheServer priority.
		comancheServer stop 
	].
	
	comancheServer _ ComancheServer 
		onPort: portNumber 
		priority: priority
		serviceProvider: self.

	running ifTrue: [ comancheServer start ].
! !

!ComancheNetService methodsFor: 'accessing' stamp: 'SVP 8/27/1999 13:50'!
priority

	^self comancheServer priority! !

!ComancheNetService methodsFor: 'accessing' stamp: 'SVP 8/27/1999 13:50'!
priority: pLevel

	self comancheServer priority: pLevel! !

!ComancheNetService methodsFor: 'accessing' stamp: 'SVP 8/16/1999 11:13'!
protocolAdaptor
	"Answer the NetworkProtocolAdaptor that is being used to
	translate Socket based conversations into message based ones."
	"HttpAdaptor is the default protocol adaptor."

	^protocolAdaptor! !

!ComancheNetService methodsFor: 'accessing' stamp: 'SVP 8/13/1999 11:46'!
protocolAdaptor: aProtocolAdaptor

	protocolAdaptor _ aProtocolAdaptor! !

!ComancheNetService methodsFor: 'printing' stamp: 'SVP 7/28/1999 15:18'!
printOn: aStream

	super printOn: aStream.
	aStream nextPutAll: ' port: ', self portNumber asString.! !

!ComancheNetService methodsFor: 'queries' stamp: 'SVP 7/28/1999 16:58'!
isRunning

	self comancheServer ifNotNil: [ 
		^self comancheServer isRunning
	].
	^false! !

!ComancheNetService methodsFor: 'conversation' stamp: 'SVP 8/16/1999 13:42'!
processNetworkRequest: aNetworkRequest

	^self module process: aNetworkRequest! !

!ComancheNetService methodsFor: 'conversation' stamp: 'svp 11/18/1999 13:36'!
serve: aSocket
	"Provided for TCP/IP conversations.  Works in conjunction with 
	a ComancheServer.  Services that do not serve TCP/IP connections
	do not need to implement this method."

	self protocolAdaptor 
		readAndWriteTo: (SocketStream on: aSocket)
		target: self
		logTo: log.
! !

!ComancheNetService methodsFor: 'starting and stopping' stamp: 'SVP 7/28/1999 16:45'!
start

	self comancheServer ifNotNil: [
		self comancheServer start
	].! !

!ComancheNetService methodsFor: 'starting and stopping' stamp: 'SVP 7/28/1999 16:45'!
stop

	self comancheServer ifNotNil: [
		self comancheServer stop
	].! !

!ComancheNetService methodsFor: 'initialization' stamp: 'SVP 8/13/1999 11:47'!
initializeOnPort: portNum priority: priorityLevel protocolAdaptor: aPA

	comancheServer _ ComancheServer 
		onPort: portNum 
		priority: priorityLevel 
		serviceProvider: self.
	
	protocolAdaptor _ aPA.

! !

!ComancheNetService methodsFor: 'defaults' stamp: 'SVP 8/13/1999 14:13'!
defaultProtocolAdaptor

	^self class defaultProtocolAdaptor! !


!ComancheService class methodsFor: 'instance creation' stamp: 'SVP 7/28/1999 16:09'!
named: aString

	^self new registerAs: aString! !

!ComancheService class methodsFor: 'instance creation' stamp: 'SVP 7/28/1999 13:05'!
new

	^super new initialize! !

!ComancheService class methodsFor: 'registration' stamp: 'SVP 7/28/1999 14:25'!
addService: aComancheService named: aString

	| tmp |
	tmp _ self services.
	(tmp includesKey: aString) ifTrue: [ ^self error: 'A service by the same name already exists' ].
	tmp at: aString put: aComancheService.
! !

!ComancheService class methodsFor: 'registration' stamp: 'SVP 7/28/1999 15:13'!
nameForService: aComancheService

	^self services 
		keyAtIdentityValue: aComancheService 
		ifAbsent: [ '(unregisterd service)' ].! !

!ComancheService class methodsFor: 'registration' stamp: 'SVP 7/28/1999 14:22'!
removeService: aComancheService

	| tmp |
	tmp _ self services.
	tmp removeKey: 
		(tmp keyAtIdentityValue: aComancheService ifAbsent: [ ^self ]).! !

!ComancheService class methodsFor: 'registration' stamp: 'SVP 7/28/1999 14:07'!
removeServiceNamed: aString

	self services removeKey: aString ifAbsent: []! !

!ComancheService class methodsFor: 'registration' stamp: 'SVP 7/28/1999 14:30'!
replaceServiceNamed: aString with: aComancheService

	self services at: aString put: aComancheService.

! !

!ComancheService class methodsFor: 'registration' stamp: 'SVP 7/28/1999 13:55'!
services

	^Services! !

!ComancheService class methodsFor: 'snapshots' stamp: 'SVP 7/28/1999 15:00'!
shutDown

	self services do: [ :ea |
		ea prepareForShutdown
	].

	! !

!ComancheService class methodsFor: 'snapshots' stamp: 'SVP 7/28/1999 14:58'!
startUp

	self services do: [ :ea |
		ea prepareForStartup.
	].

	self services do: [ :ea |
		ea autoStart ifTrue: [ ea start ].
	].! !

!ComancheService class methodsFor: 'accessing' stamp: 'SVP 7/28/1999 15:59'!
defaultPriority

	^Processor highIOPriority! !

!ComancheService class methodsFor: 'initialization' stamp: 'SVP 7/28/1999 15:01'!
initialize
	"  ComancheService initialize  "

	Services _ Dictionary new.
	Smalltalk addToStartUpList: self.
	Smalltalk addToShutDownList: self.! !


!ComancheNetService class methodsFor: 'instance creation' stamp: 'SVP 7/28/1999 16:05'!
named: aString onPort: portNumber

	^self named: aString onPort: portNumber priority: self defaultPriority! !

!ComancheNetService class methodsFor: 'instance creation' stamp: 'SVP 8/13/1999 12:04'!
named: aString onPort: portNumber priority: priorityNum

	^self 
		named: aString 
		onPort: portNumber 
		priority: priorityNum 
		protocolAdaptor: self defaultProtocolAdaptor! !

!ComancheNetService class methodsFor: 'instance creation' stamp: 'SVP 8/13/1999 12:03'!
named: aString onPort: portNumber priority: priorityNum protocolAdaptor: aPA

	^(super named: aString) 
		initializeOnPort: portNumber priority: priorityNum protocolAdaptor: aPA! !

!ComancheNetService class methodsFor: 'instance creation' stamp: 'SVP 8/13/1999 12:06'!
named: aString serveOnPort: pNumber

	^(self named: aString onPort: pNumber)
		start;
		yourself.

! !

!ComancheNetService class methodsFor: 'instance creation' stamp: 'SVP 7/28/1999 16:08'!
named: aString serveOnPort: pNumber priority: priority

	^(self named: aString onPort: pNumber priority: priority) 
		start; 
		yourself.
! !

!ComancheNetService class methodsFor: 'instance creation' stamp: 'SVP 8/13/1999 12:04'!
named: aString serveOnPort: pNumber priority: priority protocolAdaptor: aPA

	^(self named: aString onPort: pNumber priority: priority protocolAdaptor: aPA) 
		start; 
		yourself.
! !

!ComancheNetService class methodsFor: 'defaults' stamp: 'SVP 8/13/1999 14:13'!
defaultProtocolAdaptor

	^HttpAdaptor! !


!ConnectionHandler methodsFor: 'starting and stopping' stamp: 'svp 12/1/1999 18:51'!
start

	self stop.
	lastError _ nil.
	socketClass _ socketClass concreteClass.
	self process resume.
	self register.! !

!ConnectionHandler methodsFor: 'starting and stopping' stamp: 'svp 12/1/1999 18:52'!
stop

	self unregister.
	process ~~ nil ifTrue: [
		process terminate.
	].
	process _ nil.

	"We do the following in a timely manner instead of relying on
	finalization because we may want to turn right around and start
	listening again.  If an old socket is still around an listening, it may
	interfere with a new one's ability to hear."

	self destroySockets.

	! !

!ConnectionHandler methodsFor: 'accessing' stamp: 'SVP 7/26/1999 18:34'!
defaultPriority

	^self class defaultPriority! !

!ConnectionHandler methodsFor: 'accessing' stamp: 'svp 12/1/1999 18:00'!
destroySockets

	socketsToDestroy ~~ nil ifTrue: [ 
		socketsToDestroy do: [ :ea | ea destroy ].
	].
	socketsToDestroy _ OrderedCollection new.! !

!ConnectionHandler methodsFor: 'accessing' stamp: 'SVP 7/26/1999 17:55'!
handlerBlock

	^handlerBlock! !

!ConnectionHandler methodsFor: 'accessing' stamp: 'svp 12/1/1999 17:47'!
lastError

	^lastError! !

!ConnectionHandler methodsFor: 'accessing' stamp: 'SVP 7/26/1999 17:51'!
portNumber

	^portNumber! !

!ConnectionHandler methodsFor: 'accessing' stamp: 'svp 12/1/1999 17:41'!
priority

	^priority! !

!ConnectionHandler methodsFor: 'accessing' stamp: 'svp 12/1/1999 17:41'!
priority: pNum

	priority _ pNum.
	process ~~ nil ifTrue: [
		process priority: priority
	].! !

!ConnectionHandler methodsFor: 'accessing' stamp: 'svp 12/1/1999 17:41'!
process

	process == nil ifTrue: [
		self initializeProcessAtPriority: self priority.
	].

	^process! !

!ConnectionHandler methodsFor: 'accessing' stamp: 'SVP 8/2/1999 18:34'!
socketClass

	^socketClass! !

!ConnectionHandler methodsFor: 'accessing' stamp: 'SVP 8/3/1999 08:50'!
socketClass: aSocketClass

	socketClass _ aSocketClass! !

!ConnectionHandler methodsFor: 'accessing' stamp: 'svp 12/1/1999 17:58'!
socketsToDestroy

	socketsToDestroy == nil ifTrue: [
		socketsToDestroy _ OrderedCollection new.
	].
	^socketsToDestroy! !

!ConnectionHandler methodsFor: 'private' stamp: 'bolot 1/4/2000 22:59'!
newListener
	| listener |

	listener _ self socketClass newTCP.
	
	"We'll accept four simultanous connections at the same time"
	listener listenOn: portNumber backlogSize: 4.
	^listener! !

!ConnectionHandler methodsFor: 'private' stamp: 'bolot 1/3/2000 23:57'!
pvtListenLoop

	[
		(self socketClass name = #XSocket) ifTrue: [
			self pvtNTListenLoop
		] ifFalse: [
			self pvtNewListenLoop
		]
	] on: Error do: [ :ex |
		lastError _ ex messageText.
		process _ nil.
		self destroySockets.
	].! !

!ConnectionHandler methodsFor: 'private' stamp: 'svp 12/1/1999 22:04'!
pvtNTListenLoop
	| socket listener |

	listener _ self socketClass newTCP.
	listener isValid ifFalse: [ ^self error: 'Could not create listener socket' ].
	self socketsToDestroy add: listener.
	listener listenOn: portNumber backlogSize: 20.

	[ true ] whileTrue: [
		socket _ listener accept.
		(socket notNil and: [ socket isConnected ]) ifTrue: [
			handlerBlock value: socket.
			socket _ nil
		].
	].! !

!ConnectionHandler methodsFor: 'private' stamp: 'bolot 1/4/2000 23:01'!
pvtNewListenLoop
	| socket listener |

	listener _ self newListener.
	self socketsToDestroy add: listener.	

	"If the listener is not valid then the we cannot use the
	BSD style accept() mechanism."
	listener isValid ifFalse: [^self pvtOldListenLoop].
	[ true ] whileTrue: [
		socket _ listener waitForAcceptUntil: (Socket deadlineSecs: 10).
		(socket notNil and: [ socket isConnected ])
			ifTrue: [
				handlerBlock value: socket.
				socket _ nil]
			ifFalse: [
				listener isValid
					ifFalse: [(Delay forMilliseconds: 100) wait.
						listener _ self newListener].
			].
	].! !

!ConnectionHandler methodsFor: 'private' stamp: 'bolot 1/4/2000 22:54'!
pvtOldListenLoop

	"see comment on ConnectionQueue>>oldStyleListenLoop"
	| socket |


	[ true ] whileTrue: [
		(socket == nil) ifTrue: [
			"try to create a new socket for listening"
			socket _ socketClass createIfFail: [ nil ]].

		(socket == nil)
		ifTrue: [(Delay forMilliseconds: 100) wait]
		ifFalse: [
			socket isUnconnected ifTrue: [ socket listenOn: portNumber ].
			socket waitForConnectionUntil: (Socket deadlineSecs: 10).
			socket isConnected
				ifTrue: ["connection established"
					"mutex critical: [" handlerBlock value: socket "]".
					socket _ nil]
				ifFalse: [
					socket isWaitingForConnection
						ifFalse: [socket destroy. socket _ nil]].
		].
	]! !

!ConnectionHandler methodsFor: 'printing' stamp: 'svp 12/1/1999 17:52'!
printOn: aStream

	aStream nextPutAll: (self class name asString, ' port: ', self portNumber asString).
	self isRunning ifTrue: [
		aStream nextPutAll: ' [running]'
	] ifFalse:[
		aStream nextPutAll: ' [stopped]'
	].! !

!ConnectionHandler methodsFor: 'queries' stamp: 'svp 12/1/1999 17:51'!
isRunning

	^process ~~ nil! !

!ConnectionHandler methodsFor: 'initialize-release' stamp: 'svp 12/1/1999 18:52'!
finalize

	"Like #stop, but without the #unregister"

	process ~~ nil ifTrue: [
		process terminate.
	].
	process _ nil.
	self destroySockets.


! !

!ConnectionHandler methodsFor: 'initialize-release' stamp: 'svp 12/1/1999 17:57'!
initializeOnPort: aNumber handler: aBlock priority: pNumber socketClass: aSocketClass

	socketClass _ aSocketClass.
	portNumber _ aNumber.
	handlerBlock _ aBlock.
	priority _ pNumber.
	socketsToDestroy _ OrderedCollection new.





! !

!ConnectionHandler methodsFor: 'initialize-release' stamp: 'svp 12/1/1999 17:40'!
initializeProcessAtPriority: pNumber

	process _ [ self pvtListenLoop ] newProcess.
	process priority: pNumber.



! !

!ConnectionHandler methodsFor: 'registry' stamp: 'svp 12/1/1999 18:46'!
register

	^self class register: self! !

!ConnectionHandler methodsFor: 'registry' stamp: 'svp 12/1/1999 18:46'!
unregister

	^self class unregister: self! !


!ConnectionHandler class methodsFor: 'accessing' stamp: 'SVP 7/26/1999 18:16'!
defaultPriority

	^Processor highIOPriority! !

!ConnectionHandler class methodsFor: 'accessing' stamp: 'bolot 1/3/2000 23:49'!
defaultSocketClass

	^Socket
	"^Socket newSocketsSupported ifTrue: [
	
	XSocket
	] ifFalse: [
		Socket
	]"! !

!ConnectionHandler class methodsFor: 'instance creation' stamp: 'SVP 8/2/1999 18:39'!
onPort: aNumber handler: aBlock

	^self 
		onPort: aNumber 
		handler: aBlock 
		priority: self defaultPriority! !

!ConnectionHandler class methodsFor: 'instance creation' stamp: 'SVP 8/2/1999 18:39'!
onPort: aNumber handler: aBlock priority: pNum

	^self 
		onPort: aNumber 
		handler: aBlock 
		priority: pNum 
		socketClass: self defaultSocketClass! !

!ConnectionHandler class methodsFor: 'instance creation' stamp: 'SVP 8/2/1999 18:35'!
onPort: aNumber handler: aBlock priority: pNum socketClass: aSocketClass

	^self new 
		initializeOnPort: aNumber 
		handler: aBlock 
		priority: pNum 
		socketClass: aSocketClass! !

!ConnectionHandler class methodsFor: 'instance creation' stamp: 'SVP 8/2/1999 18:38'!
onPort: aNumber handler: aBlock socketClass: aSocketClass

	^self 
		onPort: aNumber 
		handler: aBlock 
		priority: self defaultPriority 
		socketClass: aSocketClass! !

!ConnectionHandler class methodsFor: 'registry' stamp: 'svp 12/1/1999 18:49'!
register: anObject

	self registry add: anObject! !

!ConnectionHandler class methodsFor: 'registry' stamp: 'svp 12/1/1999 18:49'!
registry

	Registry == nil ifTrue: [
		Registry := WeakRegistry new
	].
	^Registry! !

!ConnectionHandler class methodsFor: 'registry' stamp: 'svp 12/1/1999 18:50'!
unregister: anObject

	self registry remove: anObject ifAbsent: [ ]! !


!Date methodsFor: 'converting' stamp: 'ccn 10/6/2000 23:32'!
asTimeStamp
	"Answer the receiver as a TimeStamp at midnight."

	^TimeStamp date: self time: (Time fromSeconds: 0)! !

!Date methodsFor: 'printing' stamp: 'svp 11/19/1999 09:19'!
yymmdd
	"Answer the receiver rendered in standard fmt mm/dd/yyyy.  Good for avoiding year 2000 bugs.  Note that the name here is slightly misleading -- the month and day numbers don't show leading zeros, so that for example feb 1 1996 is 2/1/96"

	"Date today yymmdd"

	^ self printFormat: #(3 2 1 0 1 2 2)! !

!Date methodsFor: 'printing' stamp: 'bolot 8/18/1999 17:22'!
yyyymmdd
	"no delimiters"

	"Date today yyyymmdd"

	^ self printFormat: #(3 2 1 $- 1 1 2)! !


!Dictionary methodsFor: 'adding' stamp: 'SVP 9/3/1999 11:23'!
addAll: aCollection 
	"Include all the elements of aCollection as the receiver's elements. Answer 
	aCollection."

	aCollection associationsDo: [:each | self add: each].
	^aCollection! !


!DomainFilterModule methodsFor: 'processing' stamp: 'bolot 7/16/1999 12:48'!
allow: domainPattern
	(allowedDomains includes: domainPattern)
		ifFalse: [allowedDomains add: domainPattern]! !

!DomainFilterModule methodsFor: 'processing' stamp: 'bolot 7/16/1999 12:48'!
deny: domainPattern
	(deniedDomains includes: domainPattern)
		ifFalse: [deniedDomains add: domainPattern]! !

!DomainFilterModule methodsFor: 'processing' stamp: 'bolot 1/5/2000 13:00'!
process: request
	deniedDomains anySatisfy: [:domainPattern |
		(domainPattern match: request remoteAddress)
			ifTrue: [^request abort]].
	^nil "continue processing"! !


!DummyService methodsFor: 'as yet unclassified' stamp: 'svp 12/1/1999 16:36'!
serve: aSocket

	aSocket inspect! !


!ExceptionSet methodsFor: 'exceptionSelector' stamp: 'sma 2/9/2000 11:43'!
handles: anException
	"Determine whether an exception handler will accept a signaled exception."

	^ exceptions anySatisfy: [:each | each handles: anException]! !


!FileDirectory methodsFor: 'file stream creation' stamp: 'SVP 8/24/1999 08:38'!
relativeReadOnlyFileNamed: localFileName
	"Open the existing file with the given name in this directory for read-only access."

	| fName dir |
	FileDirectory splitName: localFileName to: [ :filePath :name |
		fName _ name.
		filePath isEmpty ifTrue: [ 
			dir _ self
		] ifFalse: [
			dir _ FileDirectory on: (self pathName, self pathNameDelimiter asString, filePath)
		].
	].
	^dir readOnlyFileNamed: fName

! !

!FileDirectory methodsFor: 'enumeration' stamp: 'SVP 8/24/1999 08:47'!
relativeDirectoryNamed: localPathName
	"Return the subdirectory of this directory with the given relative name."

	^FileDirectory on: (self pathName, self pathNameDelimiter asString, localPathName)



! !

!FileDirectory methodsFor: 'testing' stamp: 'bolot 1/5/2000 13:00'!
relativeFileExists: filenameOrPath
	"Answer true if a file of the given name exists. The given name may be either a full path name or a local file within this directory."
	"FileDirectory default fileExists: Smalltalk sourcesName"

	| fName dir |
	FileDirectory splitName: filenameOrPath to: [ :filePath :name |
		fName _ name.
		filePath isEmpty ifTrue: [ 
			dir _ self
		] ifFalse: [
			dir _ FileDirectory on: (self pathName, self pathNameDelimiter asString, filePath)
		].
	].
	self isCaseSensitive 
		ifTrue:[ ^dir fileNames includes: fName ]
		ifFalse:[ ^dir fileNames anySatisfy: [ :name | name sameAs: fName ]].	! !

!FileDirectory methodsFor: 'file operations' stamp: 'svp 11/5/1999 15:52'!
deleteTree: localDirName
	| tmp |
	"Delete an entire tree of the file system."

	(self directoryExists: localDirName) ifTrue: [
		tmp _ self directoryNamed: localDirName.
		tmp directoryNames do: [ :ea | tmp deleteTree: ea ].
		tmp fileNames do: [ :ea | tmp deleteFileNamed: ea ].
		self deleteDirectory: localDirName.
	].

! !

!FileDirectory methodsFor: 'printing' stamp: 'bolot 9/11/1999 15:18'!
printIndexOn: aStream urlPrefix: aRawUrlPrefix
	"print the index of files in an HTML table"
	| name size prefix mDate parentUrl aUrlPrefix |
	(aUrlPrefix _ aRawUrlPrefix) last = $/
		ifTrue: [aUrlPrefix _ aUrlPrefix copyFrom: 1 to: aUrlPrefix size - 1].
	(parentUrl _ (aUrlPrefix copyUpToLast: $/) encodePathForHTTP)
		isEmpty ifTrue: [parentUrl _ aUrlPrefix encodePathForHTTP].

	aStream nextPutAll: '<H1>Index Of ', aUrlPrefix, '</H1>
		<TABLE>
		<TR><TD>Name</TD>  <TD>Last Modified</TD>  <TD>Size</TD></TR>
		<TR><TD><A HREF="', parentUrl,
		'">Parent Directory</A></TD> <TD></TD> <TD></TD></TR>'.

	prefix _ '<TR><TD><A HREF="', aUrlPrefix encodePathForHTTP, '/'.

	" directories "
	self entries do: [:entry |
		(entry at: 4)
			ifTrue: [name _ entry at: 1. mDate _ entry at: 2.
				aStream nextPutAll: prefix, name encodePathForHTTP, '">', name, '</A></TD>
					<TD>', (Time dateAndTimeFromSeconds: mDate) printString, '</TD>
					<TD ALIGN="right">-</TD></TR>'; cr]].
	" files "
	self entries do: [:entry |
		(entry at: 4)
			ifFalse: [name _ entry at: 1. mDate _ entry at: 2. size _ entry at: 5.
				size _ size > 1024
					ifTrue: [(size // 1024) printString, 'k']
					ifFalse: [size printString].
				aStream nextPutAll: prefix, name encodePathForHTTP, '">', name, '</A></TD>
					<TD>', (Time dateAndTimeFromSeconds: mDate) printString, '</TD>
					<TD ALIGN="right">', size, '</TD></TR>'; cr]].
	aStream nextPutAll: '</TABLE>'! !

!FileDirectory methodsFor: 'comanche processing' stamp: 'bolot 1/21/2000 16:50'!
asHttpResponseTo: request
	| indexFile |
	Comanche indexFileNames isEmptyOrNil
		ifFalse: [indexFile _ Comanche indexFileNames detect: [:fileName |
				self fileExists: fileName] ifNone: [nil].
			indexFile ifNotNil: [^(self fileNamed: fileName) asHttpResponseTo: request]].
	^HttpResponse fromString:
	(String streamContents: [:stream | stream nextPutAll: '<HTML><HEAD>
		<TITLE>Index Of ', request url, '</TITLE>
		</HEAD><BODY>'.
		(self printIndexOn: stream urlPrefix: request url).
		Comanche allowUploads
			ifTrue: [stream nextPutAll: '<FORM ACTION="', request url, '" METHOD="POST" ENCTYPE="multipart/form-data">
			<INPUT TYPE="file" NAME="filestuff">
			<INPUT TYPE="submit" VALUE="upload"></FORM>'].
	stream nextPutAll: '</BODY><HTML>'])! !

!FileDirectory methodsFor: 'comanche processing' stamp: 'bolot 1/5/2000 23:51'!
processNetRequest: request
	| name |
	name _ request urlRemainder fixUrlPathDelimiters unescapePercents.
	(name = '') ifTrue: [^self].

	(self relativeFileExists: name) ifTrue: [
		^self relativeReadOnlyFileNamed: name.
	] ifFalse: [
		(self directoryExists: name) ifTrue: [
			^self relativeDirectoryNamed: name.
		] ifFalse: [
			FileDoesNotExist new signalFileName: name class: FileStream concreteStream
		]
	]! !

!FileDirectory methodsFor: 'as yet unclassified' stamp: 'bolot 1/14/2000 17:12'!
copyTo: newPath
	"TODO check that these aren't nested"
	"TODO check that the newPath dir doesn't exist"
	| newDir slash |
	slash _ FileDirectory slash.
	self createDirectory: newPath.
	newDir _ FileDirectory on: newPath.
	self fileNames do: [:fileName |
		self copyFileNamed: fileName
			toFileNamed: (newDir pathName, slash, fileName)].
	self directoryNames do: [:dirName |
		(self directoryNamed: dirName)
			copyTo: newDir pathName, slash, dirName].
! !

!FileDirectory methodsFor: 'as yet unclassified' stamp: 'svp 11/2/1999 17:30'!
totalSize

	| ts tmp |
	ts _ 0.
	self directoryNames do: [ :ea |
		ts _ ts + (self directoryNamed: ea) totalSize
	].
	self fileNames do: [ :ea |
		ts _ ts + (tmp _ self readOnlyFileNamed: ea) size.
		tmp close.
	].
	^ts
! !


!FileDoesNotExist methodsFor: 'exceptionSignaler' stamp: 'svp 12/13/1999 08:38'!
defaultAction

	| selection |
	"File does not exist..."

	selection _ (PopUpMenu labels:
'create a new file
choose another name
cancel')
			startUpWithCaption: (FileDirectory localNameFor: fileName) , '
does not exist.'.
	selection = 1 ifTrue:
		[^ fileStreamClass new open: fileName forWrite: true].
	selection = 2 ifTrue:
		[^ fileStreamClass oldFileNamed:
			(FillInTheBlank request: 'Enter a new file name'
						initialAnswer: (FileDirectory localNameFor: fileName))].
	self halt! !

!FileDoesNotExist methodsFor: 'exceptionSignaler' stamp: 'svp 12/13/1999 08:38'!
signalFileName: aString class: cls

	fileName _ aString.
	fileStreamClass _ cls.
	self signal.! !

!FileDoesNotExist methodsFor: 'accessing' stamp: 'svp 12/13/1999 08:38'!
fileName

	^fileName! !

!FileDoesNotExist methodsFor: 'accessing' stamp: 'svp 12/13/1999 08:38'!
fileStreamClass

	^ fileStreamClass! !

!FileDoesNotExist methodsFor: 'comanche processing' stamp: 'bolot 1/5/2000 14:34'!
asHttpResponseTo: request

	^HttpResponse 
		status: #notFound 
		description: 'The object you requested was not found on this server'! !


!FileServerModule methodsFor: 'processing' stamp: 'bolot 1/5/2000 23:47'!
process: request
	(request url beginsWith: '/', self name)
		ifFalse: [^nil].
	request incrementUrlPositionBy: (self name size + 2 min: request url size). "remove /name portion"
	^self directory processNetRequest: request! !


!Form methodsFor: 'comanche processing' stamp: 'bolot 2/14/2000 15:59'!
asHttpResponseTo: request
	^HttpResponse fromMIMEDocument: self asWebImage! !

!Form methodsFor: 'comanche processing' stamp: 'bolot 2/14/2000 15:59'!
asWebImage
	"return a MIMEDocument"
	| aStream contentType imageWriter |
	aStream _ (RWBinaryOrTextStream on: '').
	self depth <= 8
		ifTrue: [imageWriter _ GIFReadWriter. contentType _ MIMEDocument contentTypeGif]
		ifFalse: [imageWriter _ JPEGReadWriter. contentType _ MIMEDocument contentTypeJpeg].
	imageWriter putForm: self onStream: aStream.
	aStream reset.
	^MIMEDocument contentType: contentType content: aStream! !


!GenericLog methodsFor: 'writing' stamp: 'svp 11/19/1999 09:35'!
atEnd

	self subclassResponsibility! !

!GenericLog methodsFor: 'writing' stamp: 'svp 11/19/1999 09:35'!
nextChunk

	self subclassResponsibility! !

!GenericLog methodsFor: 'writing' stamp: 'svp 11/19/1999 11:32'!
pvtWriteLoop

	| fname file chunk |

	[ true ] whileTrue: [
		chunk _ self nextChunk.
		fname _ self fileNameTemplate copyReplaceAll: '%' with: Date today yymmdd.
		file _ self logDirectory fileNamed: fname.
		file ifNotNil: [
			file setToEnd.
			[ self chunkQueue isEmpty ] whileFalse: [
				file nextPutAll: self chunkQueue next.
			].
			file nextPutAll: chunk.
			file close.
		] ifNil: [
			self chunkQueue nextPut: chunk.
		]
	].! !

!GenericLog methodsFor: 'writing' stamp: 'svp 11/19/1999 11:03'!
startWriting

	writingProcess ifNotNil: [ writingProcess terminate ].
	writingProcess _ nil.
	self writingProcess resume.! !

!GenericLog methodsFor: 'writing' stamp: 'svp 11/19/1999 11:04'!
stopWriting

	writingProcess ifNotNil: [ writingProcess terminate ].
	writingProcess _ nil.! !

!GenericLog methodsFor: 'writing' stamp: 'svp 11/19/1999 11:05'!
writingProcess

	writingProcess ifNil: [
		writingProcess _ [ self pvtWriteLoop ] newProcess.
		writingProcess priority: Processor userBackgroundPriority.
	].
	^writingProcess! !

!GenericLog methodsFor: 'accessing' stamp: 'svp 11/19/1999 11:30'!
chunkQueue

	^chunkQueue! !

!GenericLog methodsFor: 'accessing' stamp: 'svp 11/19/1999 11:35'!
clearLog

	self stopWriting.
	chunkQueue _ SharedQueue new.! !

!GenericLog methodsFor: 'accessing' stamp: 'svp 11/19/1999 09:23'!
fileNameTemplate

	^fileNameTemplate! !

!GenericLog methodsFor: 'accessing' stamp: 'svp 11/19/1999 09:23'!
fileNameTemplate: aString

	fileNameTemplate _ aString! !

!GenericLog methodsFor: 'accessing' stamp: 'svp 11/19/1999 11:18'!
logDirectory

	^logDirectory! !

!GenericLog methodsFor: 'accessing' stamp: 'svp 11/19/1999 09:24'!
logDirectory: aFileDirectory

	logDirectory _ aFileDirectory! !

!GenericLog methodsFor: 'accessing' stamp: 'svp 11/19/1999 09:24'!
logDirectoryName

	^self logDirectory pathName! !

!GenericLog methodsFor: 'accessing' stamp: 'svp 11/19/1999 09:24'!
logDirectoryName: aString

	self logDirectory: (FileDirectory on: aString)! !

!GenericLog methodsFor: 'initialization' stamp: 'svp 11/19/1999 11:29'!
initialize

	chunkQueue _ SharedQueue new.! !


!GenericLog class methodsFor: 'instance creation' stamp: 'svp 11/19/1999 11:29'!
new

	^super new initialize! !


!HttpBadRequest methodsFor: 'comanche processing' stamp: 'bolot 2/9/2000 17:31'!
asHttpResponseTo: request

	^(HttpResponse
			status: #badRequest
			description: 'Bad request, bad!!')! !


!HttpCookie methodsFor: 'rendering' stamp: 'svp 11/23/1999 16:30'!
asHttpHeaderSetString
	| str |

	str _ 'Set-Cookie: ', name, '=', value.
	expires notNil ifTrue: [ str _ str, '; expires=', expires ].
	path notNil ifTrue: [ str _ str, '; path=', path ].
	domain notNil ifTrue: [ str _ str, '; domain=.', domain ].
	^str
! !

!HttpCookie methodsFor: 'accessing' stamp: 'SVP 8/20/1999 18:43'!
domain

	^domain! !

!HttpCookie methodsFor: 'accessing' stamp: 'SVP 8/20/1999 18:43'!
domain: aString

	domain _ aString! !

!HttpCookie methodsFor: 'accessing' stamp: 'SVP 8/20/1999 18:43'!
expires

	^expires! !

!HttpCookie methodsFor: 'accessing' stamp: 'SVP 8/20/1999 18:44'!
expires: aTimeStamp

	expires _ aTimeStamp! !

!HttpCookie methodsFor: 'accessing' stamp: 'SVP 8/20/1999 18:42'!
name

	^name! !

!HttpCookie methodsFor: 'accessing' stamp: 'SVP 8/20/1999 18:44'!
name: aString

	name _ aString! !

!HttpCookie methodsFor: 'accessing' stamp: 'SVP 8/20/1999 18:43'!
path

	^path! !

!HttpCookie methodsFor: 'accessing' stamp: 'SVP 8/20/1999 18:44'!
path: aString

	path _ aString! !

!HttpCookie methodsFor: 'accessing' stamp: 'SVP 8/20/1999 18:43'!
value

	^value! !

!HttpCookie methodsFor: 'accessing' stamp: 'SVP 8/20/1999 18:44'!
value: aString

	value _ aString! !


!HttpCookie class methodsFor: 'instance creation' stamp: 'svp 12/8/1999 21:55'!
cookiesFromHeaderString: aString
	| i tokens lastOne dict |
#todo."Put this parsing behavior someone more accessible, like
		HttpAdaptor class for instance."

	dict _ Dictionary new.
	i _ aString indexOf: $:.
	((aString copyFrom: i + 1 to: aString size) findTokens: ';') do: [ :ea |
		tokens _ ea withBlanksTrimmed findTokens: '='.
		(tokens size = 1) ifTrue: [ tokens add: '' ].
		(((tokens at: 1) at: 1) = $$) ifTrue: [
			lastOne notNil ifTrue: [
				"an attribute of the last cookie"
				((tokens at: 1) = '$Path') ifTrue: [ 
					lastOne path: (tokens at: 2) withoutQuoting 
				].
				((tokens at: 1) = '$Domain') ifTrue: [ 
					lastOne domain: (tokens at: 2) withoutQuoting 
				].
			].
		] ifFalse: [
			"a new cookie"
			dict at: (tokens at: 1) put: (lastOne _ self new).
			lastOne name: (tokens at: 1).
			lastOne value: (tokens at: 2) withoutQuoting.
		].
	].
	^dict! !


!HttpLog methodsFor: 'initialization' stamp: 'svp 11/19/1999 12:50'!
initialize

	super initialize.
	oldSegments _ SharedQueue new.
	currentSegment _ HttpLogSegment new.! !

!HttpLog methodsFor: 'maintenance' stamp: 'svp 11/18/1999 11:00'!
rollSegment

	| tmp |
	tmp _ self currentSegment.
	currentSegment _ HttpLogSegment new.
	self oldSegments nextPut: tmp.! !

!HttpLog methodsFor: 'accessing' stamp: 'svp 11/19/1999 11:36'!
clearLog

	super clearLog.
	self rollSegment.
	oldSegments _ SharedQueue new.! !

!HttpLog methodsFor: 'accessing' stamp: 'svp 11/18/1999 10:59'!
currentSegment

	^currentSegment! !

!HttpLog methodsFor: 'accessing' stamp: 'svp 11/18/1999 10:58'!
oldSegments

	^oldSegments! !

!HttpLog methodsFor: 'entries' stamp: 'svp 11/19/1999 09:40'!
addRequest: request response: response

	| tmp |
	(tmp _ self currentSegment) addRequest: request response: response.
	tmp isFullOrOld ifTrue: [
		self rollSegment
	].! !

!HttpLog methodsFor: 'writing' stamp: 'svp 11/19/1999 09:36'!
atEnd

	^self oldSegments size = 0! !

!HttpLog methodsFor: 'writing' stamp: 'svp 11/19/1999 11:34'!
nextChunk

	| tmp |
	tmp _ WriteStream on: ''.
	self oldSegments next writeOn: tmp.
	^tmp contents! !


!HttpLogEntry methodsFor: 'accessing' stamp: 'svp 11/18/1999 12:51'!
cIp

	cIp ifNil: [ ^nil ].
	^(cIp at: 1) asString, '.',
	(cIp at: 2) asString, '.',
	(cIp at: 3) asString, '.',
	(cIp at: 4) asString
! !

!HttpLogEntry methodsFor: 'accessing' stamp: 'svp 11/18/1999 10:44'!
cIp: anObject
	cIp _ anObject! !

!HttpLogEntry methodsFor: 'accessing' stamp: 'svp 11/18/1999 12:54'!
csBytes

	csBytes ifNil: [ ^nil ].
	^csBytes asString! !

!HttpLogEntry methodsFor: 'accessing' stamp: 'svp 11/18/1999 10:44'!
csBytes: anObject
	csBytes _ anObject! !

!HttpLogEntry methodsFor: 'accessing' stamp: 'svp 11/18/1999 10:44'!
csMethod
	^csMethod! !

!HttpLogEntry methodsFor: 'accessing' stamp: 'svp 11/18/1999 10:44'!
csMethod: anObject
	csMethod _ anObject! !

!HttpLogEntry methodsFor: 'accessing' stamp: 'svp 11/18/1999 10:44'!
csReferer
	^csReferer! !

!HttpLogEntry methodsFor: 'accessing' stamp: 'svp 11/18/1999 10:44'!
csReferer: anObject
	csReferer _ anObject! !

!HttpLogEntry methodsFor: 'accessing' stamp: 'svp 11/18/1999 10:44'!
csUriQuery
	^csUriQuery! !

!HttpLogEntry methodsFor: 'accessing' stamp: 'svp 11/18/1999 10:44'!
csUriQuery: anObject
	csUriQuery _ anObject! !

!HttpLogEntry methodsFor: 'accessing' stamp: 'svp 11/18/1999 10:44'!
csUriStem
	^csUriStem! !

!HttpLogEntry methodsFor: 'accessing' stamp: 'svp 11/18/1999 10:44'!
csUriStem: anObject
	csUriStem _ anObject! !

!HttpLogEntry methodsFor: 'accessing' stamp: 'svp 11/18/1999 12:58'!
csUserAgent

	csUserAgent ifNil: [ ^nil ].
	^csUserAgent headerString copy replaceAll: $  with: $+! !

!HttpLogEntry methodsFor: 'accessing' stamp: 'svp 11/18/1999 10:44'!
csUserAgent: anObject
	csUserAgent _ anObject! !

!HttpLogEntry methodsFor: 'accessing' stamp: 'svp 11/19/1999 18:42'!
csUserName

	csUserName isNil ifTrue: [ ^nil ].
	^csUserName loginName asString! !

!HttpLogEntry methodsFor: 'accessing' stamp: 'svp 11/18/1999 10:44'!
csUserName: anObject
	csUserName _ anObject! !

!HttpLogEntry methodsFor: 'accessing' stamp: 'svp 11/18/1999 10:44'!
csVersion
	^csVersion! !

!HttpLogEntry methodsFor: 'accessing' stamp: 'svp 11/18/1999 10:44'!
csVersion: anObject
	csVersion _ anObject! !

!HttpLogEntry methodsFor: 'accessing' stamp: 'svp 11/18/1999 12:52'!
date

	date ifNil: [ ^nil ].
	^date yyyymmdd! !

!HttpLogEntry methodsFor: 'accessing' stamp: 'svp 11/18/1999 10:44'!
date: anObject
	date _ anObject! !

!HttpLogEntry methodsFor: 'accessing' stamp: 'svp 11/18/1999 10:44'!
sComputerName
	^sComputerName! !

!HttpLogEntry methodsFor: 'accessing' stamp: 'svp 11/18/1999 10:44'!
sComputerName: anObject
	sComputerName _ anObject! !

!HttpLogEntry methodsFor: 'accessing' stamp: 'svp 11/18/1999 12:53'!
sIp

	sIp ifNil: [ ^nil ].
	^(sIp at: 1) asString, '.',
	(sIp at: 2) asString, '.',
	(sIp at: 3) asString, '.',
	(sIp at: 4) asString
! !

!HttpLogEntry methodsFor: 'accessing' stamp: 'svp 11/18/1999 10:44'!
sIp: anObject
	sIp _ anObject! !

!HttpLogEntry methodsFor: 'accessing' stamp: 'svp 11/18/1999 12:55'!
sPort

	sPort ifNil: [ ^nil ].
	^sPort asString! !

!HttpLogEntry methodsFor: 'accessing' stamp: 'svp 11/18/1999 10:44'!
sPort: anObject
	sPort _ anObject! !

!HttpLogEntry methodsFor: 'accessing' stamp: 'svp 11/18/1999 10:44'!
sSiteName
	^sSiteName! !

!HttpLogEntry methodsFor: 'accessing' stamp: 'svp 11/18/1999 10:44'!
sSiteName: anObject
	sSiteName _ anObject! !

!HttpLogEntry methodsFor: 'accessing' stamp: 'svp 11/18/1999 12:54'!
scBytes

	scBytes ifNil: [ ^nil ].
	^scBytes asString! !

!HttpLogEntry methodsFor: 'accessing' stamp: 'svp 11/18/1999 10:44'!
scBytes: anObject
	scBytes _ anObject! !

!HttpLogEntry methodsFor: 'accessing' stamp: 'svp 11/18/1999 12:53'!
scStatus

	scStatus ifNil: [ ^nil ].
	^scStatus asString! !

!HttpLogEntry methodsFor: 'accessing' stamp: 'svp 11/18/1999 10:44'!
scStatus: anObject
	scStatus _ anObject! !

!HttpLogEntry methodsFor: 'accessing' stamp: 'svp 11/18/1999 12:52'!
time

	time ifNil: [ ^nil ].
	^time print24! !

!HttpLogEntry methodsFor: 'accessing' stamp: 'svp 11/18/1999 10:44'!
time: anObject
	time _ anObject! !

!HttpLogEntry methodsFor: 'accessing' stamp: 'svp 11/18/1999 12:55'!
timeTaken

	timeTaken ifNil: [ ^nil ].
	^timeTaken asString! !

!HttpLogEntry methodsFor: 'accessing' stamp: 'svp 11/18/1999 10:44'!
timeTaken: anObject
	timeTaken _ anObject! !

!HttpLogEntry methodsFor: 'initialization' stamp: 'svp 11/18/1999 13:04'!
initializeFromRequest: request response: response

	| tmp |
	date _ Date today.
	time _ Time now.
	cIp _ request remoteAddress.
	(tmp _ request changoAccount) ifNotNil: [ csUserName _ tmp ].
	sSiteName _ 'SWIKINET'.
	sComputerName _ request machineName.
	sIp _ request localAddress.
	csMethod _ request method.
	csUriStem _ request url.
	scStatus _ response statusCode.
	scBytes _ request contentLength.
	csBytes _ response contents size.
	timeTaken _ request timeTaken.
	sPort _ request localPort.
	csVersion _ request protocol.
	csUserAgent _ request webBrowser.
	csReferer _ request referer.

	
	 ! !


!HttpLogEntry class methodsFor: 'instance creation' stamp: 'svp 11/18/1999 11:52'!
fromRequest: request response: response

	^self new
		initializeFromRequest: request response: response;
		yourself! !


!HttpLogSegment methodsFor: 'initialization' stamp: 'svp 12/1/1999 21:59'!
initialize

	date _ Date today.
	time _ Time now.
	entries _ OrderedCollection new: self sizeLimit.! !

!HttpLogSegment methodsFor: 'printing' stamp: 'svp 11/18/1999 13:00'!
entriesString

	| strm |
	strm _ WriteStream on: ''.
	self writeEntriesOn: strm.
	^strm contents

! !

!HttpLogSegment methodsFor: 'printing' stamp: 'svp 11/18/1999 10:33'!
headerString

	| strm |
	strm _ WriteStream on: ''.
	self writeHeaderOn: strm.
	^strm contents

! !

!HttpLogSegment methodsFor: 'printing' stamp: 'svp 11/18/1999 11:04'!
writeEntriesOn: aStream

	| crlf tmp |
	crlf _ String crlf.
	self entries do: [ :entry |
		self format do: [ :ea |
			tmp _ entry perform: (ea at: 2).
			tmp isNil ifTrue: [
				aStream nextPutAll: '- '.
			] ifFalse: [
				aStream nextPutAll: (tmp, ' ').
			].
		].
		aStream nextPutAll: crlf.
	].! !

!HttpLogSegment methodsFor: 'printing' stamp: 'svp 11/18/1999 10:35'!
writeHeaderOn: strm

	| crlf |
	crlf _ String crlf.
	strm 
		nextPutAll: self softwareString;
		nextPutAll: crlf;
		nextPutAll: self versionString;
		nextPutAll: crlf;
		nextPutAll: self dateString;
		nextPutAll: crlf;
		nextPutAll: self fieldsString;
		nextPutAll: crlf.
! !

!HttpLogSegment methodsFor: 'printing' stamp: 'svp 11/18/1999 11:04'!
writeOn: aStream

	self writeHeaderOn: aStream.
	self writeEntriesOn: aStream.! !

!HttpLogSegment methodsFor: 'formatting' stamp: 'svp 11/18/1999 10:30'!
dateString

	^'#Date: ', self date yyyymmdd, ' ' , self time print24
! !

!HttpLogSegment methodsFor: 'formatting' stamp: 'svp 11/18/1999 10:30'!
fieldsString

	| tmp |
	tmp _ '#Fields:'.
	self format do: [ :ea |
		tmp _ tmp, ' ', (ea at: 1)
	].
	^tmp
! !

!HttpLogSegment methodsFor: 'formatting' stamp: 'svp 11/18/1999 12:28'!
format

	^#(
		('date' date) 
		('time' time) 
		('c-ip' cIp) 
		('cs-username' csUserName) 
		('s-sitename' sSiteName) 
		('s-computername' sComputerName) 
		('s-ip' sIp) 
		('cs-method' csMethod) 
		('cs-uri-stem' csUriStem) 
		('sc-status' scStatus) 
		('sc-bytes' scBytes) 
		('cs-bytes' csBytes) 
		('time-taken' timeTaken) 
		('s-port' sPort) 
		('cs-version' csVersion)
		('cs(User-Agent)' csUserAgent)
		('cs(Referer)' csReferer)
	)! !

!HttpLogSegment methodsFor: 'formatting' stamp: 'svp 11/18/1999 10:31'!
softwareString

	^'#Software: Comanche Network Server 2.0'
! !

!HttpLogSegment methodsFor: 'formatting' stamp: 'svp 11/18/1999 10:30'!
versionString

	^'#Version: 2.0'
! !

!HttpLogSegment methodsFor: 'accessing' stamp: 'svp 12/1/1999 21:58'!
ageLimit
	"Age threshold where log segment is considered old"

	^14400 "four hours"! !

!HttpLogSegment methodsFor: 'accessing' stamp: 'svp 11/18/1999 10:28'!
date

	^date! !

!HttpLogSegment methodsFor: 'accessing' stamp: 'svp 11/17/1999 17:32'!
entries

	^entries! !

!HttpLogSegment methodsFor: 'accessing' stamp: 'svp 12/1/1999 21:58'!
sizeLimit
	"Size threshold where log segment is considered full"

	^1000! !

!HttpLogSegment methodsFor: 'accessing' stamp: 'svp 11/18/1999 10:28'!
time

	^time! !

!HttpLogSegment methodsFor: 'entries' stamp: 'svp 12/1/1999 21:55'!
addRequest: request response: response

	self entries add: (HttpLogEntry fromRequest: request response: response)
! !

!HttpLogSegment methodsFor: 'testing' stamp: 'svp 12/1/1999 22:00'!
isFull

	^entries size >= self sizeLimit! !

!HttpLogSegment methodsFor: 'testing' stamp: 'svp 12/1/1999 22:03'!
isFullOrOld

	^self isFull or: [ self isOld ]
! !

!HttpLogSegment methodsFor: 'testing' stamp: 'svp 12/1/1999 22:02'!
isOld

	| tmp |
	tmp _ Time now asSeconds - self time asSeconds.
	^( tmp > self ageLimit ) or: [ tmp < 0 ]
! !


!HttpLogSegment class methodsFor: 'instance creation' stamp: 'svp 11/17/1999 17:32'!
new

	^super new initialize! !


!HttpRedirect methodsFor: 'comanche processing' stamp: 'bolot 2/9/2000 17:25'!
asHttpResponseTo: request

	^(HttpResponse
			status: #tempMoved
			description: 'Temporarily moved to: <A HREF="', location, '">', location, '</A>')
		fieldAt: 'Location' put: location;
		fieldAt: 'URI' put: location;
	yourself! !

!HttpRedirect methodsFor: 'exceptionSignaler' stamp: 'bolot 2/9/2000 17:25'!
signalLocation: aString

	location _ aString.
	self signal.! !


!HttpResponse methodsFor: 'defaults' stamp: 'SVP 9/14/1999 12:42'!
defaultChunkSize

	^4096! !

!HttpResponse methodsFor: 'defaults' stamp: 'SVP 8/12/1999 14:08'!
defaultContentType

	^MIMEDocument contentTypeHtml! !

!HttpResponse methodsFor: 'defaults' stamp: 'SVP 8/12/1999 16:32'!
defaultTimeoutDuration
	"Time to wait for client to accept data before timeout"

	^120! !

!HttpResponse methodsFor: 'responding' stamp: 'SVP 8/26/1999 15:17'!
pvtWriteContentLengthOn: aStream

	aStream nextPutAll: ('Content-length: ', (self contents size asString), String crlf).

! !

!HttpResponse methodsFor: 'responding' stamp: 'SVP 8/26/1999 10:37'!
pvtWriteContentTypeOn: aStream

	aStream nextPutAll: ('Content-type: ', self contentType, String crlf).
! !

!HttpResponse methodsFor: 'responding' stamp: 'bolot 1/5/2000 14:26'!
pvtWriteContentsOn: aStream
	| chunkSize cnts |

	chunkSize _ self defaultChunkSize.
	cnts _ self contents.

	[ cnts atEnd ] whileFalse: [
		aStream nextPutAll: (cnts next: chunkSize); flush.
		"Processor yield."
	].

! !

!HttpResponse methodsFor: 'responding' stamp: 'svp 11/17/1999 11:15'!
pvtWriteFieldsOn: tmp

	fields ifNil: [ ^self ].
	fields isEmpty ifTrue: [ ^self ].

	fields keysAndValuesDo: [ :k :v |
		tmp nextPutAll: k.
		tmp nextPutAll: ': '.
		tmp nextPutAll: v.
		tmp nextPutAll: String crlf.
	].


! !

!HttpResponse methodsFor: 'responding' stamp: 'svp 12/8/1999 20:37'!
pvtWriteNewCookiesOn: aStream

	request newCookies do: [ :ea |
		aStream nextPutAll: (ea asHttpHeaderSetString, String crlf)
	].


! !

!HttpResponse methodsFor: 'responding' stamp: 'bolot 2/19/2000 16:56'!
pvtWriteServerOn: strm

	strm
		nextPutAll: 'Server: Comanche/';
		nextPutAll: Comanche version;
		nextPutAll: String crlf.! !

!HttpResponse methodsFor: 'responding' stamp: 'bolot 1/5/2000 13:07'!
pvtWriteSessionCookieOn: aStream
#todo. "add session cookie support"
	"aStream nextPutAll: (request sessionCookieString, String crlf)"
! !

!HttpResponse methodsFor: 'responding' stamp: 'SVP 8/26/1999 10:39'!
pvtWriteStatusOn: aStream

	aStream nextPutAll: 
		(self httpVersion, ' ', self statusCodeAndReason, String crlf).
! !

!HttpResponse methodsFor: 'responding' stamp: 'bolot 1/5/2000 14:26'!
writeOn: aStream

	| tmp |
	"Header"

	tmp _ WriteStream on: ''.
	self pvtWriteStatusOn: tmp.
	self pvtWriteServerOn: tmp.
	self pvtWriteFieldsOn: tmp.
	self pvtWriteSessionCookieOn: tmp.
	self pvtWriteNewCookiesOn: tmp.
	self pvtWriteContentTypeOn: tmp.
	self pvtWriteContentLengthOn: tmp.
	tmp nextPutAll: String crlf.
	aStream nextPutAll: tmp contents; flush.

	"Body"
	self pvtWriteContentsOn: aStream.



! !

!HttpResponse methodsFor: 'initialize-release' stamp: 'SVP 8/26/1999 08:06'!
destroy

	self contents close.
! !

!HttpResponse methodsFor: 'initialize-release' stamp: 'SVP 8/12/1999 14:09'!
initializeRequest: aRequest entityStream: aStream
	
	entityStream _ aStream.
	contentType _ self defaultContentType.
! !

!HttpResponse methodsFor: 'accessing' stamp: 'SVP 8/16/1999 11:54'!
contentType

	^contentType! !

!HttpResponse methodsFor: 'accessing' stamp: 'SVP 8/16/1999 11:54'!
contentType: aMimeType

	contentType _ aMimeType! !

!HttpResponse methodsFor: 'accessing' stamp: 'SVP 8/16/1999 11:53'!
contents

	^contents! !

!HttpResponse methodsFor: 'accessing' stamp: 'SVP 8/16/1999 11:54'!
contents: aStream

	contents _ aStream! !

!HttpResponse methodsFor: 'accessing' stamp: 'svp 11/17/1999 11:08'!
fieldAt: aString

	^self fields at: aString! !

!HttpResponse methodsFor: 'accessing' stamp: 'svp 11/17/1999 11:08'!
fieldAt: aString ifAbsent: absBlock

	^self fields at: aString ifAbsent: absBlock! !

!HttpResponse methodsFor: 'accessing' stamp: 'svp 11/17/1999 11:08'!
fieldAt: aString ifAbsentPut: absBlock

	^self fields at: aString ifAbsentPut: absBlock! !

!HttpResponse methodsFor: 'accessing' stamp: 'svp 11/17/1999 11:07'!
fieldAt: aString put: aValue

	self fields at: aString put: aValue! !

!HttpResponse methodsFor: 'accessing' stamp: 'svp 11/17/1999 11:07'!
fields

	fields ifNil: [
		fields _ Dictionary new.
	].

	^fields! !

!HttpResponse methodsFor: 'accessing' stamp: 'svp 12/16/1999 11:33'!
httpVersion

	^'HTTP/1.1'! !

!HttpResponse methodsFor: 'accessing' stamp: 'SVP 8/23/1999 11:00'!
request

	^request
! !

!HttpResponse methodsFor: 'accessing' stamp: 'SVP 8/23/1999 11:00'!
request: anHttpRequest

	request _ anHttpRequest.
! !

!HttpResponse methodsFor: 'accessing' stamp: 'SVP 8/16/1999 11:53'!
status

	^status! !

!HttpResponse methodsFor: 'accessing' stamp: 'SVP 8/16/1999 11:53'!
status: aSymbol

	status _ aSymbol! !

!HttpResponse methodsFor: 'accessing' stamp: 'svp 11/18/1999 13:03'!
statusCode

	^(StatusCodes at: self status) key.
! !

!HttpResponse methodsFor: 'accessing' stamp: 'SVP 8/26/1999 10:41'!
statusCodeAndReason
	| tmp |

	tmp _ StatusCodes at: self status.
	^tmp key, ' ', tmp value.! !

!HttpResponse methodsFor: 'printing' stamp: 'svp 12/9/1999 17:31'!
headerOut

	| tmp |
	tmp _ WriteStream on: ''.
	self pvtWriteStatusOn: tmp.
	self pvtWriteFieldsOn: tmp.
	self pvtWriteSessionCookieOn: tmp.
	self pvtWriteNewCookiesOn: tmp.
	self pvtWriteContentTypeOn: tmp.
	self pvtWriteContentLengthOn: tmp.
	tmp nextPutAll: String crlf.

	tmp contents out.! !

!HttpResponse methodsFor: 'printing' stamp: 'svp 11/17/1999 11:21'!
out

	| tmp |
	tmp _ WriteStream on: ''.
	self writeOn: tmp.
	tmp contents out.! !

!HttpResponse methodsFor: 'comanche processing'!
asHttpResponseTo: aRequest
	^self! !


!HttpResponse class methodsFor: 'instance creation' stamp: 'svp 12/21/1999 13:09'!
fromFileStream: aStream

	^self new
		status: #ok;
		"fieldAt: 'Cache-Control' put: 'max-age=86400';"
		contentType: aStream mimeType;
		contents: (AsyncFile from: aStream);
		yourself

	! !

!HttpResponse class methodsFor: 'instance creation' stamp: 'svp 12/21/1999 13:09'!
fromMIMEDocument: aMIMEDoc
	| content |

	content _ aMIMEDoc content.
	(content isKindOf: String) ifTrue: [
		content _ ReadStream on: content.
	].
	^self new
		status: #ok;
		"fieldAt: 'Cache-Control' put: 'max-age=86400';"
		contentType: aMIMEDoc mimeType;
		contents: content;
		yourself

	! !

!HttpResponse class methodsFor: 'instance creation' stamp: 'svp 12/9/1999 20:49'!
fromNetInterface: netInterface

	| tmp |

	^self new
		status: #tempMoved;
		fieldAt: 'Location' put: (tmp _ netInterface fullHttpUrl);
		fieldAt: 'pragma' put: 'no-cache';
		fieldAt: 'Cache-control' put: 'private';
		contentType: MIMEDocument contentTypeHtml;
		contents: (ReadStream on: '<head><title>Object moved</title></head>
<body><h1>Object Moved</h1>This object may be found <a HREF="', tmp,'">here</a>.</body>');
		yourself

	! !

!HttpResponse class methodsFor: 'instance creation' stamp: 'svp 12/3/1999 10:27'!
fromRedirect: redirect

	| tmp |
	^self new
		status: #tempMoved;
		fieldAt: 'Location' put: (tmp _ redirect fullHttpUrl);
		fieldAt: 'pragma' put: 'no-cache';
		fieldAt: 'Cache-control' put: 'private';
		contentType: MIMEDocument contentTypeHtml;
		contents: (ReadStream on: '<head><title>Object moved</title></head>
<body><h1>Object Moved</h1>This object may be found <a HREF="', tmp,'">here</a>.</body>');
		yourself

	! !

!HttpResponse class methodsFor: 'instance creation' stamp: 'svp 12/21/1999 13:09'!
fromStream: aStream

	^self new
		status: #ok;
		"fieldAt: 'Expires' put: 'Thu, 15 Apr 2010 20:00:00 GMT';"
		"fieldAt: 'Cache-Control' put: 'max-age=86400';"
		contentType: aStream mimeType;
		contents: aStream;
		yourself

	! !

!HttpResponse class methodsFor: 'instance creation' stamp: 'svp 12/21/1999 13:10'!
fromString: aString

	^self new
		status: #ok;
		"fieldAt: 'Cache-Control' put: 'max-age=86400';"
		contentType: MIMEDocument contentTypeHtml;
		contents: (ReadStream on: aString);
		yourself

	! !

!HttpResponse class methodsFor: 'instance creation' stamp: 'svp 11/17/1999 13:42'!
fromUrl: aUrl

	^self new
		status: #tempMoved;
		fieldAt: 'Location' put: aUrl asString;
		contentType: MIMEDocument contentTypeHtml;
		contents: (ReadStream on: '<head><title>Object moved</title></head>
<body><h1>Object Moved</h1>This object may be found <a HREF="', aUrl asString,'">here</a>.</body>');
		yourself

	! !

!HttpResponse class methodsFor: 'instance creation' stamp: 'svp 11/30/1999 14:41'!
status: aSymbol description: aString

	^self new
		status: aSymbol;
		contentType: MIMEDocument contentTypeHtml;
		contents: (ReadStream on: aString);
		yourself
! !

!HttpResponse class methodsFor: 'instance creation' stamp: 'SVP 8/17/1999 19:04'!
status: aSymbol mimeDescription: aMIMEDocument
	| content |

	content _ aMIMEDocument content.
	(content isKindOf: String) ifTrue: [
		content _ ReadStream on: content.
	].
	^self new
		status: aSymbol;
		contentType: aMIMEDocument mimeType;
		contents: content;
		yourself
! !

!HttpResponse class methodsFor: 'initialization' stamp: 'SVP 8/16/1999 16:43'!
initialize
	"  HttpResponse initialize  "

	self initializeStatusCodes.! !

!HttpResponse class methodsFor: 'initialization' stamp: 'SVP 8/16/1999 12:17'!
initializeStatusCodes
	"  HttpResponse initializeStatusCodes  "

	StatusCodes _ IdentityDictionary new
		at: #ok				put: ('200' -> 'OK');
		at: #created			put: ('201' -> 'Created');
		at: #accepted		put: ('202' -> 'Accepted');
		at: #noContent		put: ('204' -> 'No Content');
		at: #permMoved		put: ('301' -> 'Moved Permanently');
		at: #tempMoved		put: ('302' -> 'Moved Temporarily');
		at: #notModified		put: ('304' -> 'Not Modified');
		at: #badRequest		put: ('400' -> 'Bad Request');
		at: #unauthorized	put: ('401' -> 'Unauthorized');
		at: #forbidden		put: ('403' -> 'Forbidden');
		at: #notFound		put: ('404' -> 'Not Found');
		at: #serverError		put: ('500' -> 'Internal Server Error');
		at: #notImplemented	put: ('501' -> 'Not Implemented');
		at: #badGateway	put: ('502' -> 'Bad Gateway');
		at: #serviceUnavailable	put: ('503' -> 'Service Unavailable');
 		yourself.! !


!InstructionStream methodsFor: 'private' stamp: 'svp 12/2/1999 18:42'!
privateSender: newSender
	"Set sender (used in cloning for a branch)"

	sender _ newSender! !

!InstructionStream methodsFor: 'private' stamp: 'svp 12/2/1999 15:38'!
pvtSender: newSender
	"Set sender (used in cloning for a branch)"

	sender _ newSender! !


!ContextPart methodsFor: 'cloning' stamp: 'svp 12/3/1999 16:08'!
activeCloneForBranch

	| tmp |
	tmp _ self cloneForBranch.
	tmp push: nil.
	^tmp
! !

!ContextPart methodsFor: 'cloning' stamp: 'svp 12/6/1999 16:56'!
cloneForBranch

	| tmp dict |
	dict _ IdentityDictionary new.
	tmp _ self privateCloneForBranch: dict.
	(sender ~~ nil) ifTrue: [
		tmp privateSender: (sender privateCloneForBranch: dict).
	].
	dict keysAndValuesDo: [ :k :v |
		tmp replaceRefsTo: k with: v.
	].
	^tmp
	! !

!ContextPart methodsFor: 'cloning' stamp: 'svp 12/3/1999 17:19'!
desc

	| tmp |
	tmp _ sender ifNil: [ '' ] ifNotNil: [ sender desc ].
	^tmp, self printString, String crlf! !

!ContextPart methodsFor: 'cloning' stamp: 'svp 12/13/1999 14:10'!
privateCloneForBranch: dict

	| tmp |
	tmp _ self clone.
	dict at: self put: tmp.
	(sender ~~ nil) ifTrue: [
		tmp privateSender: (sender privateCloneForBranch: dict)
	].
	^tmp
	! !

!ContextPart methodsFor: 'cloning' stamp: 'svp 12/6/1999 16:57'!
replaceRefsTo: oldObj with: newObj

	sender ~~ nil ifTrue: [
		sender replaceRefsTo: oldObj with: newObj
	].
	
	1 to: self size do: [ :in | 
		(self at: in) == oldObj ifTrue: [
			self at: in put: newObj
		].
	].! !


!BlockContext methodsFor: 'evaluating' stamp: 'svp 12/6/1999 11:32'!
valueWithContext: ctx

	| tmp |
	tmp _ IdentityDictionary new.	
	(ctx isKindOf: Association) ifTrue: [
		tmp add: ctx.
	] ifFalse: [
		(ctx isKindOf: Dictionary) ifTrue: [
			tmp addAll: ctx.
		] ifFalse: [
			"assume another kind of collection of associations"
			ctx do: [ :ea | tmp add: ea ].
		].
	].
	Processor activeProcess pushContext: tmp.
	[ tmp _ self value ] ensure: [ Processor activeProcess popContext ].
	^tmp
! !

!BlockContext methodsFor: 'cloning' stamp: 'svp 12/6/1999 16:55'!
privateCloneForBranch: dict

	| tmp |
	tmp _ super privateCloneForBranch: dict.
	(home ~~ nil) ifTrue: [
		tmp privateHome: (home privateCloneForBranch: dict)
	].
	^tmp
	! !

!BlockContext methodsFor: 'cloning' stamp: 'svp 12/6/1999 16:21'!
privateHome: newHome

	home _ newHome! !

!BlockContext methodsFor: 'cloning' stamp: 'svp 12/6/1999 16:59'!
replaceRefsTo: oldObj with: newObj

	super replaceRefsTo: oldObj with: newObj.
	home ~~ nil ifTrue: [
		home replaceRefsTo: oldObj with: newObj.
	].
	
	
! !


!JdmColumn methodsFor: 'reading' stamp: 'bolot 12/16/1999 16:39'!
readDecimalPlaces: aReadStream
	decimalPlaces _ aReadStream next asInteger! !

!JdmColumn methodsFor: 'reading' stamp: 'bolot 12/16/1999 16:39'!
readFlags: aReadStream 
	"Currently the size of both the flags field and decimalPlaces field is specified as a sum of the two.
        I am guessing that the size of the flags is more likely to change than that of the decimalPlaces.
        Right now I assume that the flags are all bytes but the last and that the last is the decimalPlaces"
	| ba |
	ba _ (aReadStream next: aReadStream next asInteger - 1) asByteArray.
	flags _ JdmConnection byteArrayAsInteger: ba.
				 ! !

!JdmColumn methodsFor: 'reading' stamp: 'bolot 12/16/1999 16:40'!
readFrom: aReadStream 
	self
		readTable: aReadStream;
		readName: aReadStream;
		readSize: aReadStream;
		readType: aReadStream;
		readFlags: aReadStream;
		readDecimalPlaces: aReadStream! !

!JdmColumn methodsFor: 'reading' stamp: 'bolot 12/16/1999 16:40'!
readName: aReadStream
	name _ (aReadStream next: aReadStream next asInteger)! !

!JdmColumn methodsFor: 'reading' stamp: 'bolot 12/16/1999 16:59'!
readSize: aReadStream
"
	size _ (aReadStream next: aReadStream next asInteger) asByteArray asInteger
"
	| ba |
	ba _ (aReadStream next: aReadStream next asInteger) asByteArray.
	size _ JdmConnection byteArrayAsInteger: ba! !

!JdmColumn methodsFor: 'reading' stamp: 'bolot 12/16/1999 16:41'!
readTable: aReadStream
	table _ (aReadStream next: aReadStream next asInteger)! !

!JdmColumn methodsFor: 'reading' stamp: 'bolot 12/16/1999 16:41'!
readType: aReadStream
	| ba |
	ba _ (aReadStream next: aReadStream next asInteger) asByteArray.
	type _ JdmConnection byteArrayAsInteger: ba.
 ! !

!JdmColumn methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:38'!
decimalPlaces
	^decimalPlaces! !

!JdmColumn methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:38'!
flags
	^flags! !

!JdmColumn methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:39'!
name
	^name! !

!JdmColumn methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:39'!
size
	^size! !

!JdmColumn methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:39'!
table
	^table! !

!JdmColumn methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:39'!
type
	^type! !

!JdmColumn methodsFor: 'testing' stamp: 'bolot 12/16/1999 16:42'!
hasFlag: aFlag
	^(self flags bitAnd: aFlag) > 0! !

!JdmColumn methodsFor: 'testing' stamp: 'bolot 12/16/1999 16:42'!
isAutoIncrement
	^self hasFlag: self class autoIncrementFlag! !

!JdmColumn methodsFor: 'testing' stamp: 'bolot 12/16/1999 16:42'!
isBinary
	^self hasFlag: self class binaryFlag! !

!JdmColumn methodsFor: 'testing' stamp: 'bolot 12/16/1999 16:42'!
isBlob
	^self hasFlag: self class blobFlag! !

!JdmColumn methodsFor: 'testing' stamp: 'bolot 12/16/1999 16:42'!
isEnumeration
	^self hasFlag: self class enumFlag! !

!JdmColumn methodsFor: 'testing' stamp: 'bolot 12/16/1999 16:42'!
isMultipleKey
	^self hasFlag: self class multipleKeyFlag! !

!JdmColumn methodsFor: 'testing' stamp: 'bolot 12/16/1999 16:42'!
isNotNull
	^self hasFlag: self class notNullFlag! !

!JdmColumn methodsFor: 'testing' stamp: 'bolot 12/16/1999 16:42'!
isPrimaryKey
	^self hasFlag: self class primaryKeyFlag! !

!JdmColumn methodsFor: 'testing' stamp: 'bolot 12/16/1999 16:42'!
isTimestamp
	^self hasFlag: self class timestampFlag! !

!JdmColumn methodsFor: 'testing' stamp: 'bolot 12/16/1999 16:42'!
isUniqueKey
	^self hasFlag: self class uniqueKeyFlag! !

!JdmColumn methodsFor: 'testing' stamp: 'bolot 12/16/1999 16:42'!
isZerofill
	^self hasFlag: self class zerofillFlag! !


!JdmColumn class methodsFor: 'constants-types'!
blobType
	^252! !

!JdmColumn class methodsFor: 'constants-types'!
dateType
	^10! !

!JdmColumn class methodsFor: 'constants-types'!
datetimeType
	^12! !

!JdmColumn class methodsFor: 'constants-types'!
decimalType
	^0! !

!JdmColumn class methodsFor: 'constants-types'!
doubleType
	^5! !

!JdmColumn class methodsFor: 'constants-types'!
enumType
	^247! !

!JdmColumn class methodsFor: 'constants-types'!
floatType
	^4! !

!JdmColumn class methodsFor: 'constants-types'!
int24Type
	^9! !

!JdmColumn class methodsFor: 'constants-types'!
longBlobType
	^251! !

!JdmColumn class methodsFor: 'constants-types'!
longType
	^3! !

!JdmColumn class methodsFor: 'constants-types'!
longlongType
	^8! !

!JdmColumn class methodsFor: 'constants-types'!
mediumBlobType
	^250! !

!JdmColumn class methodsFor: 'constants-types'!
newDateType
	^14! !

!JdmColumn class methodsFor: 'constants-types'!
nullType
	^6! !

!JdmColumn class methodsFor: 'constants-types'!
setType
	^248! !

!JdmColumn class methodsFor: 'constants-types'!
shortType
	^2! !

!JdmColumn class methodsFor: 'constants-types'!
stringType
	^254! !

!JdmColumn class methodsFor: 'constants-types'!
timeType
	^11! !

!JdmColumn class methodsFor: 'constants-types'!
timestampType
	^7! !

!JdmColumn class methodsFor: 'constants-types'!
tinyBlobType
	^249! !

!JdmColumn class methodsFor: 'constants-types'!
tinyType
	^1! !

!JdmColumn class methodsFor: 'constants-types'!
varStringType
	^253! !

!JdmColumn class methodsFor: 'constants-types'!
yearType
	^13! !

!JdmColumn class methodsFor: 'constants-flags'!
autoIncrementFlag
	^512! !

!JdmColumn class methodsFor: 'constants-flags'!
binaryFlag
	^128! !

!JdmColumn class methodsFor: 'constants-flags'!
blobFlag
	^16! !

!JdmColumn class methodsFor: 'constants-flags'!
enumFlag
	^256! !

!JdmColumn class methodsFor: 'constants-flags'!
multipleKeyFlag
	^8! !

!JdmColumn class methodsFor: 'constants-flags'!
notNullFlag
	^1! !

!JdmColumn class methodsFor: 'constants-flags'!
primaryKeyFlag
	^2! !

!JdmColumn class methodsFor: 'constants-flags'!
timestampFlag
	^1024! !

!JdmColumn class methodsFor: 'constants-flags'!
uniqueKeyFlag
	^4! !

!JdmColumn class methodsFor: 'constants-flags'!
unsignedFlag
	^32! !

!JdmColumn class methodsFor: 'constants-flags'!
zerofillFlag
	^64! !

!JdmColumn class methodsFor: 'instance creation'!
readFrom: aReadStream
	^self new readFrom: aReadStream! !


!JdmConnection methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:37'!
clientCapabilities
	^clientCapabilities! !

!JdmConnection methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:37'!
connectionSpec
	^connectionSpec! !

!JdmConnection methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:37'!
connectionSpec: anObject
	connectionSpec _ anObject! !

!JdmConnection methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:38'!
createStatement
	^JdmStatement on: self! !

!JdmConnection methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:59'!
replyPacket
	"| s |
	s _ String new: 2000.
	writeStream _ WriteStream on: s from: 1 to: (s size).
"
	^(JdmOutputPacket on: writeStream) 
		packetNumber: responsePacket packetNumber + 1! !

!JdmConnection methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:38'!
requestPacket
	^JdmOutputPacket on: writeStream ! !

!JdmConnection methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:59'!
responsePacket
"socket waitForDataQueryingUserEvery: 30."
	"socket dataAvailable ifFalse: [self error: 'socket data notavailable.']."
"
	buf _ socket getData.
Transcript show: buf; cr.
	readStream _ ReadStream on: buf.
"
	^responsePacket _ JdmInputPacket on: readStream
	
	! !

!JdmConnection methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:38'!
serverInfo
	^serverInfo! !

!JdmConnection methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:38'!
serverInfo: anObject
	serverInfo _ anObject! !

!JdmConnection methodsFor: 'hashing' stamp: 'bolot 12/16/1999 16:37'!
getHashFor: aProtocol 
	^hashesByProtocol at: aProtocol ifAbsent: [nil]! !

!JdmConnection methodsFor: 'hashing' stamp: 'bolot 12/16/1999 16:37'!
hash: aString seed: aSeed for: aProtocol 
	| aHashMethod |
	aHashMethod _ self getHashFor: aProtocol.
	aHashMethod isNil ifTrue: [^aString].
	^self class perform: aHashMethod with: aString with: aSeed! !

!JdmConnection methodsFor: 'closing' stamp: 'bolot 12/16/1999 16:31'!
close
	self
	closeRequest;
		closeReadStream;
		closeWriteStream;
		closeSocket! !

!JdmConnection methodsFor: 'closing' stamp: 'bolot 12/16/1999 16:32'!
closeReadStream
	responsePacket _ nil.	
	readStream isNil ifFalse: [readStream close].
	readStream _ nil! !

!JdmConnection methodsFor: 'closing' stamp: 'bolot 12/16/1999 16:32'!
closeRequest
	(self requestPacket writeStream) nextPutCommand:
		(JdmMysqlCommand withCommandNamed: #quit message: '');
		flush! !

!JdmConnection methodsFor: 'closing' stamp: 'bolot 1/10/2000 16:21'!
closeSocket
	(socket notNil and: [socket isValid])
		ifTrue: [socket close].
	socket _ nil! !

!JdmConnection methodsFor: 'closing' stamp: 'bolot 12/16/1999 16:31'!
closeWriteStream
	writeStream isNil ifFalse: [writeStream close].
	writeStream _ nil! !

!JdmConnection methodsFor: 'initialize-release' stamp: 'bolot 12/16/1999 16:32'!
initialize
	self
		initializeConnection;
		initializeUser;
		initializeDatabase! !

!JdmConnection methodsFor: 'initialize-release' stamp: 'bolot 1/4/2000 20:37'!
initializeConnection
	| a |
	packetClass _ JdmInputPacket.
     a _ self class protocolHashes.
	(hashesByProtocol _ Dictionary new)
		at: (a at: 1) put: (a at: 2);
		at: (a at: 3) put: (a at: 4).

	socket _ SimpleClientSocket new
		connectTo: (connectionSpec host)
		port: (connectionSpec port).
	(socket waitForConnectionUntil: Socket standardDeadline)
		ifFalse: [Transcript cr; show: 'not connected'].

	readStream _ writeStream _ SocketStream on: socket.

	serverInfo _ JdmServerInfo on: self.
	serverInfo serverVersion >= self class largeSizesVersion
		ifTrue: [packetClass _ JdmLargeSizeInputPacket].

	clientCapabilities _ serverInfo protocol = 10 ifTrue: [1] ifFalse: [0]! !

!JdmConnection methodsFor: 'initialize-release' stamp: 'bolot 12/16/1999 16:35'!
initializeDatabase
	(self requestPacket writeStream)
	nextPutCommand: 
		(JdmMysqlCommand withCommandNamed: #initializeDatabase
			message: connectionSpec database);
	flush.
	self responsePacket checkStatusOnError: #setDatabase! !

!JdmConnection methodsFor: 'initialize-release' stamp: 'bolot 12/16/1999 16:58'!
initializeUser
	| replyStream password c s |
	password _ connectionSpec password isEmpty 
		ifTrue: ['']
		ifFalse: [self hash: connectionSpec password
			seed: self serverInfo hashSeed
			for: self serverInfo protocol].

	replyStream _ self replyPacket writeStream.

	c _ String new: 2.
	c at: 1 put: (self clientCapabilities) asCharacter.
	c at: 2 put: 0 asCharacter.
	s _ String new: 3.
	s at: 1 put: 0 asCharacter.
	s at: 2 put: 0 asCharacter.
	s at: 3 put: 1 asCharacter.

	replyStream
		nextPutAll: c;
		nextPutAll: s;
		nextPutAllNullTerminated: connectionSpec user;
		nextPutAllNullTerminated: password.

"
	replyStream
	 nextPutAll: (self clientCapabilities asByteArray: 2) asByteString;
				nextPutAll: (65536 asByteArray: 3) asByteString;
				nextPutAllNullTerminated: connectionSpec user;
				nextPutAllNullTerminated: password.
"
	replyStream flush.
	self responsePacket checkStatusOnError: #authenticate! !


!JdmConnection class methodsFor: 'misc' stamp: 'jb 3/3/1999 16:46'!
byteArrayAsByteString: ba
	| size s |
	size := ba size.
	s := String new: size.
	1 to: size do: [:index |
		s at: index put: ((ba at: index) asCharacter).
	].
	^s.! !

!JdmConnection class methodsFor: 'misc' stamp: 'jb 3/3/1999 16:39'!
byteArrayAsInteger: ba
	^self byteArrayAsInteger: ba from: 1 for: ba size

! !

!JdmConnection class methodsFor: 'misc' stamp: 'jb 3/3/1999 16:34'!
byteArrayAsInteger: ba from: anOffset for: aLength 
 
	| shiftAmount anInteger |
	
	shiftAmount := 0.
	
	anInteger := 0.
	
	anOffset to: aLength
 do: 
[:index | 
			
	anInteger := anInteger bitOr: ((ba at: index) bitShift: shiftAmount).
		
	shiftAmount := shiftAmount + 8].
	
	^anInteger
! !

!JdmConnection class methodsFor: 'misc' stamp: 'jb 3/3/1999 16:36'!
integerAsByteArray: int length: aLength 

	| aByteArray shiftAmount mask |

	aByteArray := ByteArray new: aLength.

	shiftAmount := 0.
	
	mask := 16rFF.
	
	1 to: aLength
 do: 
[:index | 
			
		aByteArray at: index put: (mask bitAnd: (int bitShift: shiftAmount)).
			
		shiftAmount := shiftAmount - 8].
	
	^aByteArray
! !

!JdmConnection class methodsFor: 'misc' stamp: 'jb 3/3/1999 16:32'!
symbolAsClass: aSymbol
	^Smalltalk at: aSymbol.
! !

!JdmConnection class methodsFor: 'misc' stamp: 'jb 3/4/1999 20:35'!
test
"

| connection statement resultSet value |
connection := JdmConnection on: 
  
(JdmConnectionSpec new initialize user: 'root'; password: 'p').
statement := connection createStatement.


resultSet := statement executeQuery: 'select * from person'.


[resultSet next] whileTrue: [value := resultSet valueNamed: 'name'.
Transcript show: value printString.
Transcript cr.
]
"! !

!JdmConnection class methodsFor: 'constants' stamp: 'jb 2/28/1999 19:21'!
largeSizesVersion
	
	^(JdmServerVersion new initialize)
		
		fileFormat: 3;
		
		serverRelease: 22;
		
		version: 7! !

!JdmConnection class methodsFor: 'constants' stamp: 'jb 2/28/1999 19:21'!
protocolHashes
	
	^#(9 #hash1:seed:
          
		10 #hash2:seed:)! !

!JdmConnection class methodsFor: 'instance creation' stamp: 'jb 2/28/1999 19:21'!
on: aConnectionSpec 
	
	^(self new)
	connectionSpec: aConnectionSpec;
 initialize! !

!JdmConnection class methodsFor: 'hashing' stamp: 'jb 2/28/1999 19:22'!
hash1: aString seed: aSeed 
	
	"This algorithm is for protocol 9."

	
	| hashedString maxValue array num1 num2 num3 |
	
	hashedString := String new: aSeed size.
	
	array := self randomInit1: aString seed: aSeed.
	
	maxValue := array at: 1.
	
	num1 := array at: 2.

	num2 := array at: 3.
	
	1 to: hashedString size
 do: 
[:index | 
			
		num1 := (num1 * 3 + num2) \\ maxValue.
			
		num2 := (num1 + num2 + 33) \\ maxValue.
			
		num3 := (num1 / maxValue * 31) truncated + 64.
			
		hashedString at: index put: num3 asCharacter].
	
	^hashedString! !

!JdmConnection class methodsFor: 'hashing' stamp: 'jb 2/28/1999 19:23'!
hash2: aString seed: aSeed 
	
	"This algorithm is for clientProtocol 10."

	
	| hashedString maxValue result num1 num2 num3 |
	
	hashedString := String new: aSeed size.
	
	result := self randomInit2: aString seed: aSeed.
	
	maxValue := result at: 1.

	num1 := result at: 2.
	
	num2 := result at: 3.
	
	1 to: hashedString size
 do: 
[:index | 
			
		num1 := (num1 * 3 + num2) \\ maxValue.
			
		num2 := (num1 + num2 + 33) \\ maxValue.
			
		num3 := (num1 / maxValue * 31) truncated + 64.
			
		hashedString at: index put: num3 asCharacter].
	
	num1 := (num1 * 3 + num2) \\ maxValue.
	
	num2 := (num1 + num2 + 33) \\ maxValue.
	
	num3 := (num1 / maxValue * 31) truncated.
	
	hashedString inject: 1
 into: 
[:index :character | 
			
		hashedString at: index put: (character asInteger bitXor: num3) asCharacter.
			
		index + 1].
	
	^hashedString! !

!JdmConnection class methodsFor: 'hashing' stamp: 'jb 2/28/1999 19:24'!
hash: aString 
	
	"Hash algorithm taken from mysql in order to send password to the server"

	
	| num1 num2 num3 charValue |
	
	num1 := 1345345333.
	
	num2 := 305419889.
	
	num3 := 7.
	
	aString do: 
	[:character | 
			
		(character = Character space or: [character = Character tab]) 
				
		ifFalse: 
[
					
			charValue := character asInteger.
					
			num1 := num1 
bitXor: ((num1 bitAnd: 63) + num3) * charValue + (num1 bitShift: 8).
					
			num2 := num2 + ((num2 bitShift: 8) bitXor: num1).
					
			num3 := num3 + charValue]].
	
	^Array with: (num1 bitAnd: 2147483647) with: (num2 bitAnd: 2147483647)! !

!JdmConnection class methodsFor: 'hashing' stamp: 'jb 2/28/1999 19:25'!
randomInit1: aString seed: aSeed 
	
	| result array1 array2 |
	
	result := Array new: 3.
	
	array1 := self hash: aString.
	
	array2 := self hash: aSeed.
	
	result at: 1 put: 16r01FFFFFF.
	
	result at: 2 put: ((array1 at: 1) bitXor: (array2 at: 1)) \\ (result at: 1).
	result at: 3 put: (result at: 2) // 2.
	
	^result! !

!JdmConnection class methodsFor: 'hashing' stamp: 'jb 2/28/1999 19:25'!
randomInit2: aString seed: aSeed 
	
	| result array1 array2 |
	
	result := Array new: 3.
	
	array1 := self hash: aString.
	
	array2 := self hash: aSeed.
	
	result at: 1 put: 16r3FFFFFFF.
	
	result at: 2 put: ((array1 at: 1) bitXor: (array2 at: 1)) \\ (result at: 1).
	result at: 3 put: ((array1 at: 2) bitXor: (array2 at: 2)) \\ (result at: 1).
	
	^result! !


!JdmConnectionSpec methodsFor: 'initialize-release' stamp: 'bolot 12/16/1999 16:43'!
initialize
	database _ 'joerg'.
	"host _ 'localhost'."
	host _ NetNameResolver localHostAddress.
	port _ 3306.
	user _ ''.
	password _ ''! !

!JdmConnectionSpec methodsFor: 'accessing'!
database
	^database! !

!JdmConnectionSpec methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:42'!
database: anObject
	database _ anObject! !

!JdmConnectionSpec methodsFor: 'accessing'!
host
	^host! !

!JdmConnectionSpec methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:43'!
host: anObject
	host _ anObject! !

!JdmConnectionSpec methodsFor: 'accessing'!
password
	^password! !

!JdmConnectionSpec methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:43'!
password: anObject
	password _ anObject! !

!JdmConnectionSpec methodsFor: 'accessing'!
port
	^port! !

!JdmConnectionSpec methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:43'!
port: anObject
	port _ anObject! !

!JdmConnectionSpec methodsFor: 'accessing'!
user
	^user! !

!JdmConnectionSpec methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:43'!
user: anObject
	user _ anObject! !


!JdmDateHolder methodsFor: 'accessing'!
value
	^date! !

!JdmDateHolder methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:58'!
value: aDate
	date _ aDate! !

!JdmDateHolder methodsFor: 'intialize-release' stamp: 'bolot 12/16/1999 16:58'!
initialize
	date _ Date today! !

!JdmDateHolder methodsFor: 'printing' stamp: 'bolot 2/10/2000 08:41'!
printOn: aStream 
	| aPolicy tokens |
	(aStream respondsTo: #policy)
		ifTrue:
			[aPolicy _ aStream policy dateAndTimePolicy.
			tokens _ JdmTimestampPrintPolicy timestampPrintPolicy policyNamed: #JdmDate.
			aPolicy
				print: date
				on: aStream
				policy: tokens]
		ifFalse:
			[date printOn: aStream format: #(3 2 1 $- 1 1 2 )]! !


!JdmDateHolder class methodsFor: 'instance creation' stamp: 'bolot 2/10/2000 08:30'!
readFrom: aStream 
	^self new
		value: (JdmTimestampPrintPolicy timestampPrintPolicy reader 
				readMysqlDateFrom: aStream)! !


!JdmDateTime methodsFor: 'accessing'!
date
	^date! !

!JdmDateTime methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:58'!
date: aJdmDate
	date _ aJdmDate! !

!JdmDateTime methodsFor: 'accessing'!
time
	^time! !

!JdmDateTime methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:58'!
time: aJdmTime 
	time _ aJdmTime! !

!JdmDateTime methodsFor: 'printing'!
printOn: aStream 
	self date printOn: aStream.
	aStream nextPut: $ .
	self time printOn: aStream! !


!JdmDateTime class methodsFor: 'instance creation'!
fromDate: aJdmDate andTime: aJdmTime 
	^(self new)
		date: aJdmDate;
		time: aJdmTime! !

!JdmDateTime class methodsFor: 'instance creation'!
readFrom: aStream 
	^JdmTimestampPrintPolicy timestampPrintPolicy reader 
		readMysqlDateTimeFrom: aStream! !


!JdmDoubleHolder methodsFor: 'accessing'!
value
	^double! !

!JdmDoubleHolder methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:57'!
value: aDouble
	double _ aDouble! !

!JdmDoubleHolder methodsFor: 'initialize-release' stamp: 'bolot 12/16/1999 16:57'!
initialize
	double _ 0.0! !

!JdmDoubleHolder methodsFor: 'printing' stamp: 'bolot 12/16/1999 16:57'!
printOn: aStream 
	| readStream character |
	readStream _ ReadStream on: double printString.
	
	[character _ readStream next.
	character isNil] whileFalse: 
				[character = $d 
					ifTrue: 
						[character _ readStream next.
						character isNil ifTrue: [^self].
						aStream nextPut: $e.
						character = $- ifFalse: [aStream nextPut: $+]].
				aStream nextPut: character]! !


!JdmDoubleHolder class methodsFor: 'instance creation' stamp: 'bolot 12/16/1999 16:44'!
readFrom: aStream 
	"use Float instead of Double"
	| writeStream character |
	writeStream := WriteStream on: String new.
	
	[character := aStream next.
	character isNil] whileFalse: 
				[character = $e 
					ifTrue: 
						[writeStream nextPut: $d.
						character := aStream next.
						character = $+ ifTrue: [character := aStream next]].
				writeStream nextPut: character].
	^self new value: (Float readFrom: (ReadStream on: writeStream contents))! !


!JdmErrorTable methodsFor: 'initialize-release' stamp: 'bolot 12/16/1999 18:17'!
initialize
	errors _ IdentityDictionary new.
	self class errorTableMap pairsDo: [:key :value | errors at: key put: value]! !

!JdmErrorTable methodsFor: 'accessing'!
errors
	^errors! !

!JdmErrorTable methodsFor: 'actions'!
throwException: aSymbol 
	self throwException: aSymbol message: ''! !

!JdmErrorTable methodsFor: 'actions'!
throwException: aSymbol message: aString 
	self 
		error: (self errors at: aSymbol ifAbsent: ['Unknown']) , ': ' , aString! !


!JdmErrorTable class methodsFor: 'errors'!
errorTableMap
	"JdmErrorTable resetErrorTable"
	^#(#protocol 'Invalid Protocol'
	    #authentication 'Access denied'
	    #setDatabase   'Could not set the database'
	    #invalidQuery 'Invalid query'
	    #invalidSize    'Read size out of bounds')! !

!JdmErrorTable class methodsFor: 'singleton'!
errorTable
	ErrorTable isNil ifTrue: [ErrorTable := self new initialize].
	^ErrorTable! !

!JdmErrorTable class methodsFor: 'singleton'!
resetErrorTable
	ErrorTable := nil! !


!JdmFieldConverter methodsFor: 'actions'!
convert: aValue from: aColumn 
	^self 
		perform: (types at: aColumn type)
		with: aValue
		with: aColumn! !

!JdmFieldConverter methodsFor: 'converting'!
toByteArray: aString column: aColumn 
	aColumn isBinary ifFalse: [^aString].
	^aString asByteArray! !

!JdmFieldConverter methodsFor: 'converting'!
toDate: aString column: aColumn
	^JdmDateHolder readFrom: (ReadStream on: aString)! !

!JdmFieldConverter methodsFor: 'converting'!
toDateTime: aString column: aColumn
	^JdmDateTime readFrom: (ReadStream on: aString)! !

!JdmFieldConverter methodsFor: 'converting'!
toDouble: aString column: aColumn
	^JdmDoubleHolder readFrom: (ReadStream on: aString)! !

!JdmFieldConverter methodsFor: 'converting'!
toFloat: aString column: aColumn
	^JdmFloatHolder readFrom: (ReadStream on: aString)! !

!JdmFieldConverter methodsFor: 'converting'!
toInteger: aString column: aColumn
	^Integer readFrom: (ReadStream on: aString)! !

!JdmFieldConverter methodsFor: 'converting'!
toString: aString column: aColumn
	^aString! !

!JdmFieldConverter methodsFor: 'converting'!
toTime: aString column: aColumn
	^JdmTimeHolder readFrom: (ReadStream on: aString)! !

!JdmFieldConverter methodsFor: 'converting'!
toTimestamp: aString column: aColumn
	^JdmTimestampHolder readFrom: (ReadStream on: aString)! !

!JdmFieldConverter methodsFor: 'private-initialize' stamp: 'bolot 12/16/1999 16:56'!
buildTypeMap
	types _ Dictionary new.
	types
		at: JdmColumn tinyType put: #toInteger:column:;
		at: JdmColumn shortType put: #toInteger:column:;
		at: JdmColumn longType put: #toInteger:column:;
		at: JdmColumn int24Type put: #toInteger:column:;
		at: JdmColumn longlongType put: #toInteger:column:;
		at: JdmColumn floatType put: #toFloat:column:;
		at: JdmColumn doubleType put: #toDouble:column:;
		at: JdmColumn decimalType put: #toDouble:column:;
		at: JdmColumn dateType put: #toDate:column:;
		at: JdmColumn datetimeType put: #toDateTime:column:;
		at: JdmColumn timeType put: #toTime:column:;
		at: JdmColumn timestampType put: #toTimestamp:column:;
		at: JdmColumn enumType put: #toString:column:;
		at: JdmColumn setType put: #toSet:column:;
		at: JdmColumn tinyBlobType put: #toByteArray:column:;
		at: JdmColumn mediumBlobType put: #toByteArray:column:;
		at: JdmColumn longBlobType put: #toByteArray:column:;
		at: JdmColumn blobType put: #toByteArray:column:;
		at: JdmColumn varStringType put: #toString:column:;
		at: JdmColumn stringType put: #toString:column:! !

!JdmFieldConverter methodsFor: 'initialize-release'!
initialize
	self buildTypeMap! !


!JdmFieldConverter class methodsFor: 'singleton'!
fieldConverter
	Instance isNil ifTrue: [Instance := self new initialize].
	^Instance! !

!JdmFieldConverter class methodsFor: 'singleton'!
resetFieldConverter
	"JdmFieldConverter resetFieldConverter"
	Instance := nil! !


!JdmFloatHolder methodsFor: 'accessing'!
value
	^float! !

!JdmFloatHolder methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:56'!
value: aFloat
	float _ aFloat! !

!JdmFloatHolder methodsFor: 'initialize-release' stamp: 'bolot 12/16/1999 16:56'!
initialize
	float _ 0.0! !

!JdmFloatHolder methodsFor: 'printing' stamp: 'bolot 12/16/1999 16:56'!
printOn: aStream 
	| readStream character |
	readStream _ ReadStream on: float printString.
	
	[character _ readStream next.
	character isNil] whileFalse: 
				[character = $e 
					ifTrue: 
						[aStream nextPut: character.
						character _ readStream next.
						character = $- ifFalse: [aStream nextPut: $+]].
				aStream nextPut: character]! !


!JdmFloatHolder class methodsFor: 'instance creation'!
readFrom: aStream 
	| writeStream character |
	writeStream := WriteStream on: String new.
	
	[character := aStream next.
	character isNil] 
			whileFalse: [character = $+ ifFalse: [writeStream nextPut: character]].
	^self new value: (Float readFrom: (ReadStream on: writeStream contents))! !


!JdmMysqlCommand methodsFor: 'private-accessing' stamp: 'bolot 12/16/1999 16:55'!
command: aCommand
	command _ aCommand! !

!JdmMysqlCommand methodsFor: 'accessing'!
command
	^command! !

!JdmMysqlCommand methodsFor: 'accessing'!
message
	^message! !

!JdmMysqlCommand methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:55'!
message: aMessage 
	message _ aMessage isNil ifTrue: [' '] ifFalse: [aMessage]! !


!JdmMysqlCommand class methodsFor: 'mysql-constants'!
connect
	^11! !

!JdmMysqlCommand class methodsFor: 'mysql-constants'!
createDatabase
	^5! !

!JdmMysqlCommand class methodsFor: 'mysql-constants'!
debug
	^13! !

!JdmMysqlCommand class methodsFor: 'mysql-constants'!
dropDatabase
	^6! !

!JdmMysqlCommand class methodsFor: 'mysql-constants'!
fieldList
	^4! !

!JdmMysqlCommand class methodsFor: 'mysql-constants'!
initializeDatabase
	^2! !

!JdmMysqlCommand class methodsFor: 'mysql-constants'!
killProcess
	^12! !

!JdmMysqlCommand class methodsFor: 'mysql-constants'!
processInfo
	^10! !

!JdmMysqlCommand class methodsFor: 'mysql-constants'!
query
	^3! !

!JdmMysqlCommand class methodsFor: 'mysql-constants'!
quit
	^1! !

!JdmMysqlCommand class methodsFor: 'mysql-constants'!
refresh
	^7! !

!JdmMysqlCommand class methodsFor: 'mysql-constants'!
shutdown
	^8! !

!JdmMysqlCommand class methodsFor: 'mysql-constants'!
sleep
	^0! !

!JdmMysqlCommand class methodsFor: 'mysql-constants'!
statistics
	^9! !

!JdmMysqlCommand class methodsFor: 'instance creation'!
withCommand: aCommand 
	^self withCommand: aCommand message: nil! !

!JdmMysqlCommand class methodsFor: 'instance creation'!
withCommand: aCommand message: aMessage 
	^(self new)
		command: aCommand;
		message: aMessage! !

!JdmMysqlCommand class methodsFor: 'instance creation'!
withCommandNamed: aCommandName
	^self withCommandNamed: aCommandName message: nil! !

!JdmMysqlCommand class methodsFor: 'instance creation'!
withCommandNamed: aCommandName message: aMessage 
	^(self new)
		command: (self perform: aCommandName);
		message: aMessage! !


!JdmPacket methodsFor: 'accessing'!
packetNumber
	^packetNumber! !

!JdmPacket methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:55'!
packetNumber: anInteger
	packetNumber _ anInteger! !

!JdmPacket methodsFor: 'accessing'!
size
	^size! !

!JdmPacket methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:55'!
size: anObject
	size _ anObject! !

!JdmPacket methodsFor: 'accessing'!
stream
	^stream! !

!JdmPacket methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:55'!
stream: anObject
	stream _ anObject! !


!JdmInputPacket methodsFor: 'initialize-release' stamp: 'bolot 12/16/1999 16:56'!
initialize
	
	size _ self readPacketSize.
	
	packetNumber _ self readPacketNumber.
	
	buffer _ self readBuffer.
	
	readStream _ JdmReadStream on: buffer.! !

!JdmInputPacket methodsFor: 'reading' stamp: 'jb 3/2/1999 17:33'!
checkForStatus: anInteger onError: aSymbol 

	(self readStatusOnError: aSymbol) = anInteger ifFalse: [self handleError: aSymbol]! !

!JdmInputPacket methodsFor: 'reading' stamp: 'jb 3/2/1999 17:33'!
checkStatusOnError: aSymbol 
	
	self checkForStatus: 0 onError: aSymbol! !

!JdmInputPacket methodsFor: 'reading' stamp: 'bolot 12/16/1999 18:23'!
handleError: aSymbol 
	
	JdmErrorTable errorTable throwException: aSymbol
		message: ((readStream next: 2) asByteArray shortAt: 1 bigEndian: false) printString , ' ' 
				, readStream readNullTerminatedString! !

!JdmInputPacket methodsFor: 'reading' stamp: 'jb 3/2/1999 17:32'!
readBuffer
	
	^self stream next: self size! !

!JdmInputPacket methodsFor: 'reading' stamp: 'bolot 12/16/1999 16:56'!
readPacketNumber
	
	| ba o int1 |
	o _ (self stream next: self class packetNumberSize).
	ba _ o asByteArray.
	int1 _ ba basicAt: 1.
	^int1.

"	^(self stream next: self class packetNumberSize) asByteArray asInteger
"! !

!JdmInputPacket methodsFor: 'reading' stamp: 'bolot 12/16/1999 18:39'!
readPacketSize
	
	| ba o int1 int2 int3 |
	o _ self stream next: self class sizeSize.
	"o _ String streamContents: [:aStream | 1 to: self class sizeSize do: [:i | aStream nextPut: self stream next]]."
	ba _ o asByteArray.
	int1 _ ba basicAt: 1.
	int2 _ ba basicAt: 2.
	int2 _ int2 bitShift: 8.
	int3 _ ba basicAt: 3.
	int3 _ int3 bitShift: 16.
	^int1 + int2 + int3.
"
	s _ ba asString.
	n _ Integer readFrom: (ReadStream on: s).
	n inspect.
	^ba asInteger
"! !

!JdmInputPacket methodsFor: 'reading' stamp: 'bolot 12/16/1999 16:56'!
readStatusOnError: aSymbol
 
	| status |
	
	status _ readStream next asInteger.
	
	status = 255 ifFalse: [^status].
	
	self handleError: aSymbol! !

!JdmInputPacket methodsFor: 'accessing' stamp: 'jb 3/3/1999 18:20'!
readStream
	
	
	^readStream! !


!JdmLargeSizeInputPacket methodsFor: 'initialize-release' stamp: 'bolot 12/16/1999 16:56'!
initialize
	size _ self readPacketSize.
	packetNumber _ self readPacketNumber.
	buffer _ self readBuffer.
	readStream _ JdmLargeSizeReadStream on: buffer! !


!JdmOutputPacket methodsFor: 'initialize-release' stamp: 'bolot 12/16/1999 17:49'!
initialize
	packetNumber _ 0.
	buffer _ String new: self class defaultBufferSize.
	writeStream _ JdmWriteStream on: buffer startingAt: (self class headerSize) outputPacket: (self).
	"This is a bit of a hack...I should utilize events instead"
	
"	writeStream expressInterestIn: #flush for: self sendBack: #flush"! !

!JdmOutputPacket methodsFor: 'actions' stamp: 'bolot 12/16/1999 17:51'!
flush
	| aString ba s bytesSend |
	aString _ self writeStream contents.
	self writeStream close.
	self size: aString size - self class headerSize.
	ba _ JdmConnection integerAsByteArray: self size length: self class sizeSize.
	s _ JdmConnection byteArrayAsByteString: ba.
	aString replaceFrom: 1 to: self class sizeSize with: s startingAt: 1.

"	aString 
replaceFrom: 1
 to: self class sizeSize
	with: (self size asByteArray: self class sizeSize) asByteString
 startingAt: 1.

"	
	aString at: self class sizeSize + 1 put: self packetNumber asCharacter.
	

	(self stream) nextPutAll: aString; flush

"
	bytesSend _ socket sendData: aString.
	(bytesSend = aString size) ifFalse: [self error: 'error'.].
"
! !

!JdmOutputPacket methodsFor: 'accessing' stamp: 'bolot 12/16/1999 17:51'!
writeStream
	^writeStream! !


!JdmPacket class methodsFor: 'constants'!
defaultBufferSize
	^8192! !

!JdmPacket class methodsFor: 'constants'!
headerSize
	^4! !

!JdmPacket class methodsFor: 'constants'!
packetNumberOffset
	^4! !

!JdmPacket class methodsFor: 'constants'!
packetNumberSize
	^1! !

!JdmPacket class methodsFor: 'constants'!
sizeOffset
	^1! !

!JdmPacket class methodsFor: 'constants'!
sizeSize
	^3! !

!JdmPacket class methodsFor: 'instance creation' stamp: 'bolot 12/16/1999 17:47'!
on: aStream 
	^(self new) stream: aStream; initialize! !


!JdmResult methodsFor: 'testing'!
hasResultSet
	^type = #read! !

!JdmResult methodsFor: 'accessing'!
type
	^type! !

!JdmResult methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:55'!
type: aType
	type _ aType! !

!JdmResult methodsFor: 'accessing'!
value
	^value! !

!JdmResult methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:55'!
value: aValue
	value _ aValue! !


!JdmResultSet methodsFor: 'private-accessing'!
currentRow
	^currentRow! !

!JdmResultSet methodsFor: 'accessing'!
columnAt: index
	^columns at: index! !

!JdmResultSet methodsFor: 'accessing'!
columnNamed: aName 
	^self columnAt: (columnsByName at: aName ifAbsent: [^nil])! !

!JdmResultSet methodsFor: 'accessing'!
columns
	^columns! !

!JdmResultSet methodsFor: 'accessing'!
connection
	^connection! !

!JdmResultSet methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:54'!
connection: anObject
	connection _ anObject! !

!JdmResultSet methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:54'!
next
	currentRow _ (JdmRow withNumColumns: columns size) 
				readFrom: connection responsePacket readStream.
	^currentRow isEmpty not! !

!JdmResultSet methodsFor: 'accessing'!
rawValueAt: anIndex
	^self currentRow at: anIndex! !

!JdmResultSet methodsFor: 'accessing'!
rawValueNamed: aName 
	^self rawValueAt: (columnsByName at: aName)! !

!JdmResultSet methodsFor: 'accessing'!
valueAt: anIndex 
	^JdmFieldConverter fieldConverter convert: (self currentRow at: anIndex)
		from: (self columns at: anIndex)! !

!JdmResultSet methodsFor: 'accessing'!
valueNamed: aName 
	^self valueAt: (columnsByName at: aName)! !

!JdmResultSet methodsFor: 'initialize-release' stamp: 'bolot 12/16/1999 16:54'!
initialize
			
	| column rpacket |
	
	columnsByName _ Dictionary new.
	

	rpacket _ connection responsePacket.

	columns _ Array 
new: (rpacket readStatusOnError: #invalidQuery).

 	
	1 to: columns size
 do: 
[:index | 
		
		rpacket _ connection responsePacket.	
	
		column _ JdmColumn readFrom: rpacket readStream.
			
		columns at: index put: column.
			
		columnsByName at: column name put: index].
	
	connection responsePacket checkForStatus: 254 onError: #invalidQuery.
	
	currentRow _ JdmRow withNumColumns: columns size.! !

!JdmResultSet methodsFor: 'printing' stamp: 'rew 11/7/2000 17:03'!
printOn: aStream
	columns 
		do: [:each | aStream nextPutAll: (each name printString)]
		separatedBy: [aStream tab].
	aStream cr.
	
	[self next] whileTrue:
		[currentRow printOn: aStream.
		aStream cr.]	! !


!JdmResultSet class methodsFor: 'instance creation'!
on: aConnection 
	^(self new)
		connection: aConnection;
		initialize! !


!JdmRow methodsFor: 'reading' stamp: 'bolot 12/16/1999 16:54'!
checkForEndOrNull: aReadStream 
	"This is a bit unclean...the value 254 has been overloaded in the protocol.  When it is the only
        value in the stream, it indicates there are no more rows.  It also indicates that the following
        4 bytes contain the size of the field value.  The problem is that there is another condition that
        produces a single value on the stream...a row with one column whose value is NULL."

	| endOrNull |
	aReadStream size = 1 ifFalse: [^false].
	endOrNull _ aReadStream next asInteger.
	endOrNull = 254 
		ifTrue: 
			[isEmpty _ true.
			^true].
	endOrNull = 251 ifTrue: [^true].
	"Unexpected Value"
	JdmErrorTable throwException: #invalidQuery
		message: 'Unexpected value ' , endOrNull printString.
	^true! !

!JdmRow methodsFor: 'reading'!
readFrom: aReadStream 
	(self checkForEndOrNull: aReadStream) ifTrue: [^self].
	self readRowsFrom: aReadStream! !

!JdmRow methodsFor: 'reading' stamp: 'bolot 12/16/1999 16:54'!
readRowsFrom: aReadStream 

			| aSize |
	1 to: numColumns do: 
			[:index | 
			aSize _ aReadStream readSize32.
			aSize = 0 ifFalse: [values at: index put: (aReadStream next: aSize)]]! !

!JdmRow methodsFor: 'initialize-release' stamp: 'bolot 12/16/1999 16:54'!
initialize
	values _ Array new: numColumns.
	self initializeWithNulls.
	isEmpty _ false.! !

!JdmRow methodsFor: 'initialize-release'!
initializeWithNulls
	1 to: numColumns do: [:index | values at: index put: nil]! !

!JdmRow methodsFor: 'accessing'!
at: anIndex
	^values at: anIndex! !

!JdmRow methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:54'!
numColumns: anInteger
	numColumns _ anInteger! !

!JdmRow methodsFor: 'testing'!
isEmpty
	^isEmpty! !

!JdmRow methodsFor: 'printing' stamp: 'rew 11/7/2000 17:02'!
printOn: aStream
	values
		do: [:each | aStream nextPutAll: (each printString)]
		separatedBy: [aStream tab]! !


!JdmRow class methodsFor: 'instance creation'!
withNumColumns: anInteger 
	^(self new)
		numColumns: anInteger;
		initialize! !


!JdmServerInfo methodsFor: 'reading' stamp: 'bolot 12/16/1999 16:52'!
readFrom: aResponsePacket
	self
		readProtocolFrom: aResponsePacket;
		readServerVersionFrom: aResponsePacket;
		readServerThreadFrom: aResponsePacket;
		readHashSeedFrom: aResponsePacket;
		readOptionsFrom: aResponsePacket! !

!JdmServerInfo methodsFor: 'reading' stamp: 'bolot 12/16/1999 16:53'!
readHashSeedFrom: aResponsePacket
	hashSeed _ aResponsePacket readStream readNullTerminatedString! !

!JdmServerInfo methodsFor: 'reading' stamp: 'bolot 12/16/1999 16:52'!
readOptionsFrom: aResponsePacket 
	| ba int1 int2 |
	ba _ (aResponsePacket readStream next: 2) asByteArray .
	int1 _ ba basicAt: 1.
	int2 _ ba basicAt: 2.
	int2 _ int2 bitShift: 8.
	options _ int1 + int2.

! !

!JdmServerInfo methodsFor: 'reading' stamp: 'bolot 12/16/1999 16:52'!
readProtocolFrom: aResponsePacket 
	protocol _ (aResponsePacket readStatusOnError: #protocol)! !

!JdmServerInfo methodsFor: 'reading' stamp: 'bolot 12/16/1999 16:53'!
readServerThreadFrom: aResponsePacket
	| ba int1 int2 int3 int4 |
	ba _ (aResponsePacket readStream next: 4) asByteArray .
	int1 _ ba basicAt: 1.
	int2 _ ba basicAt: 2.
	int2 _ int2 bitShift: 8.
	int3 _ ba basicAt: 3.
	int3 _ int3 bitShift: 16.
	int4 _ ba basicAt: 4.
	int4 _ int4 bitShift: 24.

	serverThread _ int1 + int2 + int3 + int4! !

!JdmServerInfo methodsFor: 'reading' stamp: 'bolot 12/16/1999 16:53'!
readServerVersionFrom: aResponsePacket 
	serverVersion _ JdmServerVersion readFrom: aResponsePacket readStream! !

!JdmServerInfo methodsFor: 'initialize-release' stamp: 'bolot 12/16/1999 16:51'!
initialize
	serverVersion _ JdmServerVersion new initialize.
	hashSeed _ String new.
	protocol _ -1.
	serverThread _ -1.
	options _ -1! !

!JdmServerInfo methodsFor: 'validation'!
validateProtocol: aProtocol 
	(aProtocol = 9 or: [aProtocol = 10]) 
		ifFalse: [JdmErrorTable errorTable error: #protocol]! !

!JdmServerInfo methodsFor: 'accessing'!
hashSeed
	^hashSeed! !

!JdmServerInfo methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:53'!
hashSeed: anObject
	hashSeed _ anObject! !

!JdmServerInfo methodsFor: 'accessing'!
options
	^options! !

!JdmServerInfo methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:53'!
options: anObject
	options _ anObject! !

!JdmServerInfo methodsFor: 'accessing'!
protocol
	^protocol! !

!JdmServerInfo methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:53'!
protocol: aProtocol 
	self validateProtocol: aProtocol.
	protocol _ aProtocol! !

!JdmServerInfo methodsFor: 'accessing'!
serverThread
	^serverThread! !

!JdmServerInfo methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:53'!
serverThread: anObject
	serverThread _ anObject! !

!JdmServerInfo methodsFor: 'accessing'!
serverVersion
	^serverVersion! !

!JdmServerInfo methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:53'!
serverVersion: anObject
	serverVersion _ anObject! !


!JdmServerInfo class methodsFor: 'constants'!
clientProtocolSize
	^1! !

!JdmServerInfo class methodsFor: 'constants'!
optionsSize
	^2! !

!JdmServerInfo class methodsFor: 'constants'!
serverThreadSize
	^4! !

!JdmServerInfo class methodsFor: 'instance creation' stamp: 'jb 3/2/1999 17:26'!
on: aConnection 
	
	^self new readFrom: aConnection responsePacket! !


!JdmServerVersion methodsFor: 'accessing'!
fileFormat
	^fileFormat! !

!JdmServerVersion methodsFor: 'accessing'!
fileFormat: anInteger
	fileFormat := anInteger! !

!JdmServerVersion methodsFor: 'accessing'!
serverRelease
	"Renamed this because of a conflict with the Object method release"
	^release! !

!JdmServerVersion methodsFor: 'accessing'!
serverRelease: anInteger
	release := anInteger! !

!JdmServerVersion methodsFor: 'accessing'!
version
	^version! !

!JdmServerVersion methodsFor: 'accessing'!
version: anInteger
	version := anInteger! !

!JdmServerVersion methodsFor: 'initialize-release'!
initialize
	fileFormat := 0.
	release := 0.
	version := 0.! !

!JdmServerVersion methodsFor: 'comparing'!
< aJdmServerVersion 
	^aJdmServerVersion fileFormat > fileFormat or: 
			[(aJdmServerVersion fileFormat = fileFormat 
				and: [aJdmServerVersion serverRelease > release]) or: 
						[aJdmServerVersion serverRelease = release 
							and: [aJdmServerVersion version > version]]]! !

!JdmServerVersion methodsFor: 'comparing'!
= aJdmServerVersion 
	^fileFormat = aJdmServerVersion fileFormat and: 
			[release = aJdmServerVersion serverRelease 
				and: [version = aJdmServerVersion version]]! !

!JdmServerVersion methodsFor: 'reading' stamp: 'bolot 12/16/1999 16:51'!
readFrom: aStream
	fileFormat _ Integer readFrom: aStream.
	aStream next.
	release _ Integer readFrom: aStream.
	aStream next.
	version _ Integer readFrom: aStream.
	aStream readNullTerminatedString! !

!JdmServerVersion methodsFor: 'printing'!
printOn: aStream 
	aStream
		nextPutAll: fileFormat printString;
		nextPut: $.;
		nextPutAll: release printString;
		nextPut: $.;
		nextPutAll: version printString! !


!JdmServerVersion class methodsFor: 'instance creation'!
readFrom: aStream 
	^self new readFrom: aStream! !


!JdmStatement methodsFor: 'private-accessing' stamp: 'bolot 12/16/1999 16:49'!
connection: aConnection
	connection _ aConnection! !

!JdmStatement methodsFor: 'private-accessing' stamp: 'bolot 12/16/1999 16:49'!
createResult: queryInfo 
	^self perform: ((queryInfo at: 1) , 'Result:') asSymbol with: queryInfo! !

!JdmStatement methodsFor: 'private-accessing' stamp: 'bolot 12/16/1999 16:49'!
readResult: queryInfo 
	| symbol aClass |
	symbol _ (JdmResult new) type: (queryInfo at: 1); value: ((queryInfo at: 2)).
	aClass _ JdmConnection symbolAsClass: (queryInfo at: 2) asSymbol.
     ^aClass on: connection.

"	^(JdmResult new)
 type: (queryInfo at: 1);
 value: ((queryInfo at: 2) inspect)."! !

!JdmStatement methodsFor: 'private-accessing' stamp: 'bolot 12/16/1999 16:50'!
updateResult: queryInfo 
	"Right now the insert id is being dropped."
	| responsePacket affectedRows insertID |
	responsePacket _ connection responsePacket.
	responsePacket checkStatusOnError: #invalidQuery.
	affectedRows _ responsePacket readStream readSize.
	insertID _ responsePacket readStream readSize.
	^(JdmResult new) type: (queryInfo at: 1); value: affectedRows! !

!JdmStatement methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:49'!
executeQuery: aQuery 
	| queryInfo r |
	queryInfo _ self class queryInfoFor: aQuery.
	queryInfo isNil 
		ifTrue: 
		[JdmErrorTable errorTable throwException: #invalidQuery message: aQuery].
	(connection requestPacket writeStream)
 	nextPutCommand:
		(JdmMysqlCommand withCommandNamed: #query message: aQuery);
	flush.
	
	r _ self createResult: queryInfo.
	^r! !


!JdmStatement class methodsFor: 'initialize-release' stamp: 'jb 2/28/1999 18:25'!
initialize
	
	"JdmStatement initialize"

	
	MysqlQueries := Dictionary new.
	
	self mysqlQueries do: 
			
		[:association | 
			
			MysqlQueries 
add: (Association key: (association at: 1) value: (association at: 2))]! !

!JdmStatement class methodsFor: 'initialize-release' stamp: 'jb 2/28/1999 18:25'!
initializeOnLoad
	
	self initialize! !

!JdmStatement class methodsFor: 'accessing' stamp: 'jb 2/28/1999 18:22'!
queryInfoFor: aQuery 
	
	^MysqlQueries at: (self getCommand: aQuery) ifAbsent: [nil]! !

!JdmStatement class methodsFor: 'constants' stamp: 'jb 2/28/1999 18:24'!
mysqlQueries
	
	"To be added: DESCRIBE, EXPLAIN, SHOW"
	
	^#( #('SELECT'    #(#read #JdmResultSet))
           
		#('INSERT'     #(#update))
           
		#('UPDATE'    #(#update))
           
		#('DELETE'      #(#update))
           
		#('CREATE'    #(#update))
           
		#('DROP'       #(#update))
           
		#('ALTER'      #(#update ))
           
		#('LOCK'       #(#update ))
           
		#('UNLOCK'   #(#update ))
           
		#('SET'          #(#update ))
           
		#('GRANT'     #(#update ))
           
		#('REPLACE'  #(#update )))! !

!JdmStatement class methodsFor: 'private-parsing' stamp: 'jb 2/28/1999 18:23'!
getCommand: aQuery 
	
	| readStream writeStream aCharacter |
	
	writeStream := WriteStream on: String new.
	
	readStream := ReadStream on: aQuery.
	
	readStream skipSeparators.
	
	[readStream atEnd or: [aCharacter := readStream next. aCharacter isSeparator]] 
		
		whileFalse: [writeStream nextPut: aCharacter asUppercase].
	
	^writeStream contents! !

!JdmStatement class methodsFor: 'instance creation' stamp: 'jb 2/28/1999 18:25'!
on: aConnection 
	
	^self new connection: aConnection! !


!JdmTimeHolder methodsFor: 'accessing'!
value
	^time! !

!JdmTimeHolder methodsFor: 'accessing'!
value: aTime
	time := aTime! !

!JdmTimeHolder methodsFor: 'initialize-release'!
initialize
	time := Time now! !

!JdmTimeHolder methodsFor: 'printing' stamp: 'bolot 2/10/2000 08:43'!
printOn: aStream 
	| aPolicy tokens |
	(aStream respondsTo: #policy)
		ifTrue:
			[aPolicy := aStream policy dateAndTimePolicy.
			tokens := JdmTimestampPrintPolicy timestampPrintPolicy policyNamed: #JdmTime.
			aPolicy
				print: time
				on: aStream
				policy: tokens]
		ifFalse:
			[time print24: true on: aStream]! !


!JdmTimeHolder class methodsFor: 'instance creation' stamp: 'bolot 2/10/2000 08:32'!
readFrom: aStream 
	^self new
		value: (JdmTimestampPrintPolicy timestampPrintPolicy reader 
				readMysqlTimeFrom: aStream)! !


!JdmTimestampHolder methodsFor: 'accessing'!
value
	^timestamp! !

!JdmTimestampHolder methodsFor: 'accessing'!
value: aTimestamp
	timestamp := aTimestamp! !

!JdmTimestampHolder methodsFor: 'initialize-release'!
initialize
	timestamp := Timestamp now! !

!JdmTimestampHolder methodsFor: 'printing' stamp: 'bolot 2/10/2000 08:43'!
printOn: aStream 
	| aPolicy tokens |
	(aStream respondsTo: #policy)
		ifTrue:
			[aPolicy := aStream policy dateAndTimePolicy.
			tokens := JdmTimestampPrintPolicy timestampPrintPolicy 
						policyNamed: #JdmTimestamp.
			aPolicy 
				print: timestamp
				on: aStream
				policy: tokens]
		ifFalse:
			[timestamp printOn: aStream]! !


!JdmTimestampHolder class methodsFor: 'instance creation' stamp: 'bolot 2/10/2000 08:51'!
readFrom: aStream 
	^self new
		value: (JdmTimestampPrintPolicy timestampPrintPolicy reader 
				readMysqlTimestampFrom: aStream)! !


!JdmTimestampPrintPolicy methodsFor: 'accessing' stamp: 'rew 9/2/2000 16:37'!
reader
	^(JdmTimestampReader new)
		printPolicy: self;
		yourself! !

!JdmTimestampPrintPolicy methodsFor: 'initialize-release'!
mysql
	self
		us;
		policyNamed: #JdmTimestamp putString: 'yyyymmddhhmmss';
		policyNamed: #JdmTime putString: 'hh:mm:ss';
		policyNamed: #JdmDate putString: 'yyyy-mm-dd'! !


!JdmTimestampPrintPolicy class methodsFor: 'singleton' stamp: 'bolot 2/10/2000 08:26'!
newFor: nameSpace
	^self new! !

!JdmTimestampPrintPolicy class methodsFor: 'singleton'!
resetTimestampPrintPolicy
	Instance := nil! !

!JdmTimestampPrintPolicy class methodsFor: 'singleton'!
timestampPrintPolicy
	Instance isNil ifTrue: [Instance := self newFor: #mysql].
	^Instance! !


!JdmTimestampReader methodsFor: 'reading mysql' stamp: 'bolot 2/10/2000 08:31'!
readMysqlDateFrom: aStream 
	| day month year |
	year := Integer readFrom: aStream.
	aStream next.
	month := Integer readFrom: aStream.
	aStream next.
	day := Integer readFrom: aStream.
	^Date 
		newDay: day
		month: month
		year: year! !

!JdmTimestampReader methodsFor: 'reading mysql'!
readMysqlDateTimeFrom: aStream 
	| aJdmDate aJdmTime |
	aJdmDate := JdmDateHolder new value: (self readMysqlDateFrom: aStream).
	aStream next.
	aJdmTime := JdmTimeHolder new value: (self readMysqlTimeFrom: aStream).
	^JdmDateTime fromDate: aJdmDate andTime: aJdmTime! !

!JdmTimestampReader methodsFor: 'reading mysql'!
readMysqlTimeFrom: aStream 
	| hour minute second |
	hour := Integer readFrom: aStream.
	aStream next.
	minute := Integer readFrom: aStream.
	aStream next.
	second := Integer readFrom: aStream.
	^Time fromSeconds: 60 * (60 * hour + minute) + second! !

!JdmTimestampReader methodsFor: 'reading mysql'!
readMysqlTimestampFrom: aStream 
	| year month day hour minute second |
	year := self readIntegerFrom: aStream next: 4.
	month := self readIntegerFrom: aStream next: 2.
	day := self readIntegerFrom: aStream next: 2.
	hour := self readIntegerFrom: aStream next: 2.
	minute := self readIntegerFrom: aStream next: 2.
	second := self readIntegerFrom: aStream next: 2.
	^Timestamp fromDate: (Date 
				newDay: day
				monthNumber: month
				year: year)
		andTime: (Time fromSeconds: 60 * (60 * hour + minute) + second)! !

!JdmTimestampReader methodsFor: 'private-reading'!
readIntegerFrom: aStream next: anInteger 
	^Integer readFrom: (ReadStream on: (aStream next: anInteger))! !

!JdmTimestampReader methodsFor: 'initialize'!
mysql
	timeSelector := #readMysqlTimeFrom:.
	dateSelector := #readMysqlDateFrom:.
	timestampSelector := #readMysqlTimestampFrom:! !

!JdmTimestampReader methodsFor: 'bad should fix' stamp: 'bolot 2/10/2000 08:28'!
printPolicy: aPolicy
	"ignore"! !


!JdmTimestampReader class methodsFor: 'instance creation' stamp: 'bolot 2/10/2000 08:26'!
newFor: nameSpace
	^self new! !


!MIMEDocument methodsFor: 'access' stamp: 'svp 12/16/1999 11:55'!
mimeType

	^self type! !


!MIMEDocument class methodsFor: 'content-types' stamp: 'svp 12/16/1999 10:35'!
contentTypeGif
	^'image/gif'! !

!MIMEDocument class methodsFor: 'content-types' stamp: 'bolot 2/14/2000 15:58'!
contentTypeJpeg
	^'image/jpeg'! !


!MethodContext methodsFor: 'cloning' stamp: 'svp 12/6/1999 16:59'!
replaceRefsTo: oldObj with: newObj

	super replaceRefsTo: oldObj with: newObj.
	receiver == oldObj ifTrue: [
		receiver _ newObj
	].
	
	! !


!MultipartPostModule methodsFor: 'processing' stamp: 'bolot 2/20/2000 11:46'!
process: request
	" process multipart form data "
	" save files in the work directory "
" TODO: save other form data "
	| hdr body boundary str idx origFileName fileName file fieldName contentType formDict doc |
#todo. "allow saving elsewhere first"
	(request method = 'POST' and: [request contentType = MIMEDocument contentTypeMultipart])
		ifFalse: [^nil].

	formDict _ Dictionary new.
	boundary _ request multipartBoundary.
"Transcript show: 'Boundary = ', boundary; cr."
	[hdr _ request stream getSubHeader.
	hdr isEmptyOrNil ifTrue: [request privPostFields: formDict. ^nil].
"Transcript show: hdr asString; cr."
	str _ (hdr at: 'content-disposition' ifAbsent: ['']).

	fileName _ fieldName _ ''.

	idx _ str findString: 'filename='.
	idx > 0 ifTrue: [fileName _ str copyFrom: idx + 10 to: (str indexOf: $" startingAt: idx+10) - 1].

	idx _ str findString: 'name='.
	idx > 0 ifTrue: [fieldName _ str copyFrom: idx + 6 to: (str indexOf: $" startingAt: idx+6) - 1].

	contentType _ hdr at: 'content-type' ifAbsent: [MIMEDocument defaultContentType].
"Transcript show: 'field=', fieldName; cr; show: 'file=', fileName; cr;
	show: 'content-type=', contentType; cr."

	origFileName _ fileName.
	(fileName size > 0 and: [Comanche allowUploads])
		ifTrue: [fileName _ (fileName findTokens: ':/\') last.
			fileName _ (FileDirectory checkName: fileName fixErrors: true) unescapePercents.
			Comanche caseSensitiveFilenames
				ifTrue: [fileName _ fileName asLowercase].
			workDir deleteFileNamed: fileName ifAbsent: [].
			file _ workDir fileNamed: fileName]
		ifFalse: [file _ DummyStream on: String new. fileName _ nil].
" TODO: parse regular form data "
" TODO: create IgnoreStream "

"Transcript show: 'reading body...'; cr."
	body _ request stream nextChunk.
	"IE4 for Mac appends 128 bytes of Mac file system info - must remove"
	"this fix assumes that body size >= 128"
	((body at: 1) asciiValue = 0
			and: [(body at: 2) asciiValue = origFileName size
				and: [(body copyFrom: 3 to: origFileName size + 2) = origFileName]])
		ifTrue: [body _ body copyFrom: 129 to: body size].
"Transcript show: 'init body=', body; cr."
	[(idx _ body findString: boundary) = 0]
		whileTrue:
			[idx _ body size - boundary size + 1 max: 1.
" Transcript show: 'idx=', idx asString; cr. "
			str _ request stream nextChunk.
" Transcript show: 'str=', str; cr;
	show: 'file=', (body copyFrom: 1 to: idx); cr. "
			file nextPutAll: (body copyFrom: 1 to: idx - 1).
			body _ (body copyFrom: idx to: body size) , str].
	" save the last chunk in the file "
	file nextPutAll: (body copyFrom: 1 to: idx-5). " idx-1 - String crlf size "
	file close.
	fileName
		ifNotNil:
			[doc _ MIMEDocument contentType: contentType content: ''
				url: (String streamContents: [:stream |
					stream nextPutAll: 'file://'.
					(workDir pathName findTokens: FileDirectory slash)
						do: [:piece |
							stream nextPutAll: piece; nextPut: $/].
					stream nextPutAll: fileName]).
			formDict at: fieldName put: doc].

	request stream putDataBack: (body copyFrom: idx-4 to: body size).
	request stream atEnd or: [hdr isNil]
	] whileFalse.

	request privPostFields: formDict.

	^nil! !


!NetworkDialog methodsFor: 'initialization' stamp: 'svp 12/6/1999 12:23'!
initialize

	data _ Dictionary new.

! !

!NetworkDialog methodsFor: 'accessing' stamp: 'svp 12/13/1999 11:21'!
actionRefHttpUrl

	^self networkInterface actionRefHttpUrl! !

!NetworkDialog methodsFor: 'accessing' stamp: 'svp 12/7/1999 10:39'!
answer

	^answer! !

!NetworkDialog methodsFor: 'accessing' stamp: 'svp 12/7/1999 10:41'!
answer: anObject

	answer _ anObject! !

!NetworkDialog methodsFor: 'accessing' stamp: 'svp 12/7/1999 10:40'!
answerIfNil: aBlock

	answer == nil ifTrue: [
		^aBlock value
	].
	^answer! !

!NetworkDialog methodsFor: 'accessing' stamp: 'svp 9/28/1999 14:48'!
data

	^data! !

!NetworkDialog methodsFor: 'accessing' stamp: 'svp 9/28/1999 14:49'!
data: aDictionary

	data _ aDictionary! !

!NetworkDialog methodsFor: 'accessing' stamp: 'svp 12/13/1999 11:20'!
fullHttpUrl

	^self networkInterface fullHttpUrl! !

!NetworkDialog methodsFor: 'accessing' stamp: 'svp 12/7/1999 14:58'!
lastRequest

	^lastRequest! !

!NetworkDialog methodsFor: 'accessing' stamp: 'svp 12/7/1999 15:31'!
lastRequest: request

	lastRequest _ request.! !

!NetworkDialog methodsFor: 'accessing' stamp: 'svp 12/8/1999 08:12'!
lifespan
	"Answer the maximum amount of time (in seconds) that this dialog is allowed
	to exist without having received activity from the client.  The originating dialog
	controls the lifespan of the entire dialog (i.e. calling a sub-dialog with a different
	lifespan will not alter the lifespan of the overall dialog sequence)."

	^1200 " 20 minutes "! !

!NetworkDialog methodsFor: 'processing' stamp: 'svp 12/7/1999 15:29'!
begin

	| ans |
	self networkInterface pushDialog: self.	
	ans _ self initiateDialog.
	self networkInterface popDialog.
	^ans
! !

!NetworkDialog methodsFor: 'processing' stamp: 'svp 12/13/1999 11:26'!
begin: request

	lastRequest _ request.
	Processor activeProcess contextAt: #request put: request.
	^self begin.! !

!NetworkDialog methodsFor: 'processing' stamp: 'svp 12/7/1999 14:59'!
initiateDialog

	"Subclasses should override to provide the sequence of dialogs
	that define this dialog"

	self subclassResponsibility! !

!NetworkDialog methodsFor: 'processing' stamp: 'svp 11/30/1999 14:02'!
networkInterface

	^Processor activeProcess contextAt: #netInterface ifAbsent: [ nil ]
! !

!NetworkDialog methodsFor: 'processing' stamp: 'svp 12/7/1999 15:07'!
prompt: anObject

	self networkInterface postResponse: anObject.
	self networkInterface recordBranchProc: Process forBranch.
	self storeFormData: (self networkInterface getRequest).

! !

!NetworkDialog methodsFor: 'processing' stamp: 'svp 12/13/1999 11:27'!
storeFormData: request

	lastRequest _ request.
	Processor activeProcess contextAt: #request put: request.
	self data addAll: request formFields! !

!NetworkDialog methodsFor: 'flow control' stamp: 'svp 9/28/1999 14:49'!
copyForBranch

	| tmp |
	tmp _ self copy.
	tmp data: tmp data copy.
	^tmp! !

!NetworkDialog methodsFor: 'converting' stamp: 'svp 12/7/1999 11:26'!
asHttpResponseTo: request

	| tmp |
	tmp _ NetworkDialogInterface new.
	tmp session: request session.
	tmp processDialog: self.
	^tmp asHttpResponseTo: request! !


!NetworkDialog class methodsFor: 'instance creation' stamp: 'svp 12/7/1999 15:30'!
from: aNetworkDialog

	^self new
		lastRequest: aNetworkDialog lastRequest;
		yourself! !

!NetworkDialog class methodsFor: 'instance creation' stamp: 'svp 9/27/1999 17:01'!
new

	^super new initialize! !


!NetworkHost methodsFor: 'accessing' stamp: 'svp 11/18/1999 19:59'!
domainString

	| sz |
	^self isNamedHost ifTrue: [
		((sz _ self name size) >= 2) ifTrue: [
			(self name at: (sz - 1)), '.', self name last.
		] ifFalse: [
			''
		]
	] ifFalse: [
		self nameString
	]! !

!NetworkHost methodsFor: 'accessing' stamp: 'svp 11/5/1999 13:43'!
fullName

	^fullName! !

!NetworkHost methodsFor: 'accessing' stamp: 'svp 12/9/1999 17:12'!
httpReference

	^'http://', self fullName! !

!NetworkHost methodsFor: 'accessing' stamp: 'svp 11/5/1999 13:34'!
machineName

	^(self isNamedHost and: [ self name size >= 3 ]) ifTrue: [
		self name at: 1
	] ifFalse: [
		nil
	]! !

!NetworkHost methodsFor: 'accessing' stamp: 'svp 11/5/1999 13:37'!
name

	^name! !

!NetworkHost methodsFor: 'accessing' stamp: 'svp 11/18/1999 19:59'!
nameString

	| tmp nm |
	tmp _ (nm _ self name) first asString.

	2 to: nm size do: [ :in |
		tmp _ tmp, '.', (nm at: in) asString
	].
	^tmp
! !

!NetworkHost methodsFor: 'accessing' stamp: 'svp 11/5/1999 13:37'!
port

	^port! !

!NetworkHost methodsFor: 'accessing' stamp: 'svp 11/5/1999 13:37'!
type

	^type! !

!NetworkHost methodsFor: 'testing' stamp: 'svp 11/5/1999 13:37'!
isNamedHost

	^self type == #name! !

!NetworkHost methodsFor: 'initialization' stamp: 'svp 11/5/1999 13:32'!
initializeFromIPAddress: str

	| nums |
	((str occurrencesOf: $.) = 3) ifTrue: [
		nums _ (str findTokens: '.') collect: [ :ea | 
			ea isPositiveInteger ifTrue: [
				ea asNumber
			] ifFalse: [ ^self ]
		].
		name _ nums.
		type _ #address.
	].	
	


	! !

!NetworkHost methodsFor: 'initialization' stamp: 'svp 11/5/1999 13:36'!
initializeFromString: aString

	^self initializeFromString: aString defaultPort: 80

	! !

!NetworkHost methodsFor: 'initialization' stamp: 'svp 11/5/1999 13:43'!
initializeFromString: aString defaultPort: dPort

	| tmp |
	fullName _ aString.
	tmp _ self initializePortFromString: aString defaultPort: dPort.
	self initializeFromIPAddress: tmp.
	name ifNil: [
		name _ tmp findTokens: '.'.
		type _ #name.
	].

	! !

!NetworkHost methodsFor: 'initialization' stamp: 'svp 11/5/1999 13:20'!
initializePortFromString: aString defaultPort: dPort

	| in tmp |
	^((in _ aString indexOf: $:) > 0) ifTrue: [
		tmp _ aString copyFrom: (in + 1) to: aString size.
		tmp isPositiveInteger ifTrue: [ 
			port _ tmp asNumber 
		] ifFalse: [
			port _ dPort.
		].
		aString copyFrom: 1 to: (in - 1).
	] ifFalse: [ 
		port _ dPort. 
		aString
	].


	

	


	! !


!NetworkHost class methodsFor: 'instance creation' stamp: 'svp 11/5/1999 13:15'!
fromString: aString

	^self new
		initializeFromString: aString;
		yourself! !


!NetworkProtocolAdaptor methodsFor: 'processing' stamp: 'SVP 8/26/1999 08:12'!
beginConversation
	"Process the stream, converting protocol requests into messages, and
		answers into protocol responses"

	self subclassResponsibility! !

!NetworkProtocolAdaptor methodsFor: 'accessing' stamp: 'svp 11/18/1999 11:46'!
log

	^log
! !

!NetworkProtocolAdaptor methodsFor: 'accessing' stamp: 'svp 11/18/1999 11:47'!
log: aLog

	log _ aLog
! !

!NetworkProtocolAdaptor methodsFor: 'accessing' stamp: 'SVP 8/26/1999 08:12'!
readStream

	^readStream! !

!NetworkProtocolAdaptor methodsFor: 'accessing' stamp: 'SVP 8/4/1999 13:09'!
target

	^target! !

!NetworkProtocolAdaptor methodsFor: 'accessing' stamp: 'SVP 8/26/1999 08:12'!
writeStream

	^writeStream! !

!NetworkProtocolAdaptor methodsFor: 'dispatching' stamp: 'SVP 8/16/1999 11:07'!
dispatchRequest: aNetworkRequest
	"<Stream> Dispatches a NetworkRequest as a method to the target and
	answers a stream to be transferred to the client in the response"

	^self target processNetworkRequest: aNetworkRequest

! !

!NetworkProtocolAdaptor methodsFor: 'initialization' stamp: 'svp 11/18/1999 11:47'!
initializeReadFrom: rStream writeTo: wStream target: aTarget log: aLog

	readStream _ rStream.
	writeStream _ wStream.
	target _ aTarget.
	log _ aLog.! !


!HttpAdaptor methodsFor: 'logging' stamp: 'bolot 1/5/2000 20:38'!
logRequest: aRequest response: aResponse
	| logFile |
	self log
		ifNotNil: [self log addRequest: aRequest response: aResponse]
		ifNil: [logFile _ Processor activeProcess contextAt: #log ifAbsent: [^nil].
			self printLogOn: logFile]! !

!HttpAdaptor methodsFor: 'logging' stamp: 'bolot 1/5/2000 20:38'!
printLogOn: printStream
	"remotehost rfc931 authuser [date] 'request' status bytes"
	printStream nextPutAll:
	(String streamContents: [:aStream |
		aStream nextPutAll: (NetNameResolver stringFromAddress: request remoteAddress); tab;
			nextPutAll: '-	-'; tab;
			nextPutAll: request timestamp asString; tab;
			nextPutAll: request url asString; tab;
			nextPutAll: response status asString; tab;
			nextPutAll: request stream outDataCount asString; cr])! !

!HttpAdaptor methodsFor: 'processing' stamp: 'bolot 2/19/2000 16:41'!
beginConversation
	"Read an HTTP request from our readStream, dispatch a method based on the
	request to our target, and then formulate an HTTP response to wrap the
	answer stream."

	"This method should be called on a background process to avoid tying
	up the UI while waiting for the request."

	startTime _ Time millisecondClockValue.

	[
		self pvtReadRequest.
		self pvtGetResponseAndDo: [
			self pvtWriteLogAndDestroy.
		].
	] on: Error do: [ :ex |
		(Comanche suppressErrors)
			ifTrue:
				[self pvtDestroy.
				self pvtHandleError: ex]
			ifFalse: "re-raise the exception"
				[ex signal].
	]! !

!HttpAdaptor methodsFor: 'processing' stamp: 'bolot 1/21/2000 16:33'!
pvtDestroy

	[self readStream close.
	self writeStream close.
	response ~~ nil ifTrue: [ response destroy ]
	] ifError: [:err :rcvr | "ignore"].! !

!HttpAdaptor methodsFor: 'processing' stamp: 'bolot 1/5/2000 12:49'!
pvtGetResponseAndDo: blk

	[
#todo. "remove debugging"
'HttpAdaptor pvtGetResponseAndDo:' displayAt: 10@540.
		response _ ((self dispatchRequest: request) asHttpResponseTo: request)
			request: request;
			yourself.
	] on: Error do: [ :ex |
ex description displayAt: 10@560.
ex receiver asString displayAt: 10@580.
		response _ (ex asHttpResponseTo: request)
			request: request;
			yourself.
		blk value.
		self pvtHandleError: ex.
		^self
	].

	blk value.
! !

!HttpAdaptor methodsFor: 'processing' stamp: 'svp 12/13/1999 10:38'!
pvtHandleError: ex

	| tmp |

	(tmp _ Processor activeProcess contextAt: #chango ifAbsent: [ nil ]) ifNil: [ ^self ].
	(tmp operatingMode == #debug) ifTrue: [
		tmp logError: ex context: thisContext. 
		Processor activeProcess suspend.
	].! !

!HttpAdaptor methodsFor: 'processing' stamp: 'svp 12/9/1999 15:25'!
pvtLogActivity

	[
		request timeTaken: (Time millisecondClockValue - startTime).
		self logRequest: request response: response.
	] on: Error do: [ :ex |
		"Print something in the transcript for diagnosis purposes."
		'----Error Recording Log Entry----' out.
		ex shortStackDescription out.
		'----' out.
	].! !

!HttpAdaptor methodsFor: 'processing' stamp: 'svp 12/16/1999 12:24'!
pvtReadRequest

	request _ HttpRequest readFromStream: self readStream.
	Processor activeProcess contextAt: #request put: request.



! !

!HttpAdaptor methodsFor: 'processing' stamp: 'svp 12/9/1999 15:24'!
pvtWriteLogAndDestroy

	self pvtWriteResponse.
	self pvtLogActivity.
	self pvtDestroy.
! !

!HttpAdaptor methodsFor: 'processing' stamp: 'bolot 1/5/2000 14:37'!
pvtWriteResponse
	[ response writeOn: self writeStream ] on: Error do: [ :ex | 
		"If we're here, it's likely because something on the other
		end of the socket it hosed.  Do nothing, a log entry will 
		be written and the socket and response will be destroyed"
	]! !


!NetworkProtocolAdaptor class methodsFor: 'instance creation' stamp: 'SVP 8/26/1999 11:03'!
readAndWriteTo: aStream target: aTarget

	^self readFrom: aStream writeTo: aStream target: aTarget
! !

!NetworkProtocolAdaptor class methodsFor: 'instance creation' stamp: 'svp 11/18/1999 11:43'!
readAndWriteTo: aStream target: aTarget logTo: log

	^self readFrom: aStream writeTo: aStream target: aTarget logTo: log
! !

!NetworkProtocolAdaptor class methodsFor: 'instance creation' stamp: 'SVP 8/26/1999 10:57'!
readFrom: rStream writeTo: wStream target: aTarget

	^(self readingFrom: rStream writingTo: wStream target: aTarget)
		beginConversation;
		yourself
! !

!NetworkProtocolAdaptor class methodsFor: 'instance creation' stamp: 'svp 11/18/1999 11:45'!
readFrom: rStream writeTo: wStream target: aTarget logTo: log

	^(self readingFrom: rStream writingTo: wStream target: aTarget logTo: log)
		beginConversation;
		yourself
! !

!NetworkProtocolAdaptor class methodsFor: 'instance creation' stamp: 'svp 11/18/1999 11:45'!
readingFrom: rStream writingTo: wStream target: aTarget

	^self readingFrom: rStream writingTo: wStream target: aTarget logTo: nil
! !

!NetworkProtocolAdaptor class methodsFor: 'instance creation' stamp: 'svp 11/18/1999 11:45'!
readingFrom: rStream writingTo: wStream target: aTarget logTo: log

	^self new
		initializeReadFrom: rStream writeTo: wStream target: aTarget log: log;
		yourself
! !


!HttpAdaptor class methodsFor: 'utilities' stamp: 'sma 2/9/2000 17:40'!
parseHttpHeader: string
	| header key value start end more colonPos fieldDelims lastKey keyValueDelim |
	"TODO: support multi-line headers (if line starts with a separator, append to last"
	header _ Dictionary new.
	string isEmptyOrNil ifTrue: [^ header].
	fieldDelims _ String crlf asCharacterSet.
	keyValueDelim _ $:.
	more _ true.
	start _ 1.
	lastKey _ ''.
	[end _ string indexOfAnyOf: fieldDelims startingAt: start.
	end == 0
		ifTrue: [end _ string size. more _ false]
		ifFalse: [end _ end - 1].
	(end >= start and: [start < string size])
		ifTrue: [
			(string at: start) isSeparator
				ifTrue: [header at: lastKey put: ((header at: lastKey), (string copyFrom: start to: end))]
				ifFalse: [colonPos _ string indexOf: keyValueDelim startingAt: start.
					(colonPos > end or: [colonPos == 0])
						ifTrue: [key _ (key _ string copyFrom: start to: end) asLowercase.
							value _ '']
						ifFalse: [key _ (key _ string copyFrom: start to: colonPos-1) asLowercase.
							value _ (value _ string copyFrom: colonPos+1 to: end) withBlanksTrimmed]].
			key isEmpty
				ifFalse: [header at: key put: value.
					lastKey _ key.
					key _ ''].
			start _ string skipDelimiters: String crlf startingAt: end+1].
	more] whileTrue.

	^header! !


!NetworkRequest methodsFor: 'accessing' stamp: 'SVP 8/18/1999 09:44'!
method

	self subclassResponsibility! !

!NetworkRequest methodsFor: 'accessing' stamp: 'svp 12/8/1999 21:57'!
session

	session ifNil: [ 
		session _ self sessionClass on: self.
	].
	^session! !

!NetworkRequest methodsFor: 'accessing' stamp: 'SVP 8/20/1999 14:46'!
sessionClass

	^NetworkSession! !

!NetworkRequest methodsFor: 'accessing' stamp: 'SVP 8/16/1999 10:44'!
url

	self subclassResponsibility! !

!NetworkRequest methodsFor: 'chango request' stamp: 'SVP 8/17/1999 12:03'!
address
	
	^self swikiAddress
! !

!NetworkRequest methodsFor: 'chango request' stamp: 'SVP 8/17/1999 12:04'!
isAppend

	^false! !

!NetworkRequest methodsFor: 'chango request' stamp: 'SVP 8/17/1999 12:04'!
isEdit

	^false! !

!NetworkRequest methodsFor: 'chango request' stamp: 'SVP 8/17/1999 19:20'!
isFramesCapable

	^true! !

!NetworkRequest methodsFor: 'chango request' stamp: 'SVP 8/17/1999 12:03'!
page

	^self swikiPage! !

!NetworkRequest methodsFor: 'chango request' stamp: 'SVP 8/27/1999 14:21'!
reference: page address: address

	(self swikiPage = '') ifTrue: [
		^self urlPrefix, address
	] ifFalse: [
		(address = '') ifTrue: [
			^self urlPrefix, '/', page
		] ifFalse: [
			(page = '') ifTrue: [
				^self urlPrefix, '.', address
			] ifFalse: [
				^self urlPrefix, '/', page, '.', address
			].
		].
	].
! !

!NetworkRequest methodsFor: 'url walking' stamp: 'SVP 8/23/1999 20:55'!
incrementUrlPositionBy: count

	self urlPosition: (self urlPosition + count)! !

!NetworkRequest methodsFor: 'url walking' stamp: 'SVP 8/23/1999 20:55'!
lastUrlTokenSeparator

	^self propertyAt: #lastUrlTokenSeparator ifAbsentPut: [ nil ]! !

!NetworkRequest methodsFor: 'url walking' stamp: 'SVP 8/23/1999 20:54'!
lastUrlTokenSeparator: aCharacter

	^self propertyAt: #lastUrlTokenSeparator put: aCharacter! !

!NetworkRequest methodsFor: 'url walking' stamp: 'SVP 9/3/1999 02:11'!
nextStdUrlToken

	^self nextUrlToken: '/.?'
! !

!NetworkRequest methodsFor: 'url walking' stamp: 'SVP 8/23/1999 21:01'!
nextUrlToken: aString

	| urlRem ch |
	urlRem _ self urlRemainder.
	1 to: urlRem size do: [ :in |
		(aString includes: (ch _ urlRem at: in)) ifTrue: [
			self lastUrlTokenSeparator: ch.
			self incrementUrlPositionBy: in.
			^urlRem copyFrom: 1 to: (in - 1).
		].
	].
	self lastUrlTokenSeparator: nil.
	self incrementUrlPositionBy: urlRem size.
	^urlRem! !

!NetworkRequest methodsFor: 'url walking' stamp: 'SVP 8/23/1999 20:53'!
urlPosition

	^self propertyAt: #urlPosition ifAbsentPut: [ 1 ]! !

!NetworkRequest methodsFor: 'url walking' stamp: 'SVP 8/23/1999 20:56'!
urlPosition: aNumber

	self propertyAt: #urlPosition put: aNumber! !

!NetworkRequest methodsFor: 'url walking' stamp: 'SVP 8/23/1999 21:15'!
urlRemainder

	^self url copyFrom: self urlPosition to: self url size! !

!NetworkRequest methodsFor: 'dialogs' stamp: 'svp 12/8/1999 14:05'!
dialog

	| dlgid |
	dlgid _ self formFields at: 'dlgid' ifAbsent: [ ^nil ].
	dlgid isPositiveInteger ifFalse: [ ^nil ].
	^self session dialogsAt: dlgid asNumber ifAbsent: [ ^nil ].! !

!NetworkRequest methodsFor: 'dialogs' stamp: 'svp 12/8/1999 13:44'!
dialogIfAbsent: dlgBlock

	| tmp |
	(tmp _ self dialog) ifNil: [
		^dlgBlock value.
	].
	^tmp
! !

!NetworkRequest methodsFor: 'dialogs' stamp: 'svp 12/6/1999 14:02'!
dialogIfAbsentPut: dlgBlock

	| tmp |
	(tmp _ self dialog) ifNil: [
		tmp _ dlgBlock value.
		tmp session: self session.
	].
	^tmp! !

!NetworkRequest methodsFor: 'initialize-release' stamp: 'SVP 8/17/1999 12:01'!
initialize

	properties _ IdentityDictionary new.! !

!NetworkRequest methodsFor: 'testing' stamp: 'SVP 8/25/1999 08:53'!
isGetRequest

	self subclassResponsibility! !

!NetworkRequest methodsFor: 'testing' stamp: 'SVP 8/25/1999 08:53'!
isHeaderRequest

	self subclassResponsibility! !

!NetworkRequest methodsFor: 'testing' stamp: 'SVP 8/25/1999 08:53'!
isPostRequest

	self subclassResponsibility! !

!NetworkRequest methodsFor: 'misc properties' stamp: 'SVP 8/24/1999 09:46'!
urlPrefix

	^self propertyAt: #urlPrefix ifAbsentPut: [
		('/', self swikiName).
	].
! !

!NetworkRequest methodsFor: 'misc properties' stamp: 'bf 1/17/2000 12:23'!
urlTokens

	^self propertyAt: #urlTokens ifAbsentPut: [
		(self url copyUpTo: $?) findTokens: '/.'.
	].
! !

!NetworkRequest methodsFor: 'properties' stamp: 'SVP 8/17/1999 11:38'!
propertyAt: aSymbol

	^properties at: aSymbol! !

!NetworkRequest methodsFor: 'properties' stamp: 'SVP 8/17/1999 11:38'!
propertyAt: aSymbol ifAbsent: absentBlock

	^properties at: aSymbol ifAbsent: absentBlock! !

!NetworkRequest methodsFor: 'properties' stamp: 'SVP 8/17/1999 11:38'!
propertyAt: aSymbol ifAbsentPut: absentBlock

	^properties at: aSymbol ifAbsentPut: absentBlock! !

!NetworkRequest methodsFor: 'properties' stamp: 'SVP 8/17/1999 11:38'!
propertyAt: aSymbol put: anObject

	properties at: aSymbol put: anObject! !

!NetworkRequest methodsFor: 'properties' stamp: 'SVP 8/17/1999 11:38'!
removePropertyAt: aSymbol

	properties removeKey: aSymbol! !

!NetworkRequest methodsFor: 'file server properties' stamp: 'SVP 8/17/1999 19:45'!
filename
	"The relative file name using the local directory naming convention."

	^self propertyAt: #filename ifAbsentPut: [
		(FileUrl absoluteFromText: self url) pathForFile.
	].

! !


!HttpRequest methodsFor: 'initialization' stamp: 'bolot 1/5/2000 20:20'!
initializeFromStream: aStream
	
	stream _ aStream.
	(stream respondsTo: #remoteAddress) ifTrue: [
		self pvtRemoteAddress: stream remoteAddress.
	].
#todo. "remove usage of responseHeader"
	responseHeader _ Dictionary new.
	self timestamp: Time totalSeconds.
	"Initialize the fields of an HTTP request from aStream"
	self pvtReadRequestFrom: stream.
! !

!HttpRequest methodsFor: 'initialization' stamp: 'bolot 5/6/1999 20:17'!
stream: s
	stream _ s! !

!HttpRequest methodsFor: 'accessing' stamp: 'sma 2/8/2000 17:19'!
addCookie: aCookie

	^ self newCookies add: aCookie! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 1/22/2000 16:24'!
body
	^self propertyAt: #body ifAbsent: []! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 1/22/2000 16:24'!
body: aString
	self propertyAt: #body put: aString! !

!HttpRequest methodsFor: 'accessing' stamp: 'SVP 8/26/1999 18:12'!
contentLength

	^self propertyAt: #contentLength ifAbsentPut: [
		(header at: 'content-length' ifAbsent: [0]) asNumber
	]! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 1/4/2000 18:49'!
contentType
	| i contentType |
	^self propertyAt: #contentType ifAbsentPut: [
		contentType _ self header at: 'content-type' ifAbsent: [self defaultContentType].
		contentType ifNotNil: [i _ contentType indexOf: $;. "get rid of charset field"
			i > 0 ifTrue: [contentType _ contentType copyFrom: 1 to: i-1]].
		contentType asLowercase]! !

!HttpRequest methodsFor: 'accessing' stamp: 'SVP 8/26/1999 16:23'!
cookies
	"<Dictionary> Answers a dictionary of cookie names with HttpCookie values"

	^self propertyAt: #cookies ifAbsentPut: [ 
		(header includesKey: 'cookie') ifTrue: [
			HttpCookie cookiesFromHeaderString: (header at: 'cookie').
		] ifFalse: [
			Dictionary new.
		].
	].
! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 5/15/1999 16:33'!
destroy
	stream close.
	stream _ nil! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 12/27/1999 15:10'!
endOfRequestMarker
	^self class endOfRequestMarker! !

!HttpRequest methodsFor: 'accessing' stamp: 'svp 11/30/1999 16:21'!
formFields
	"Answer the multipart fields for a post request (if in fact this is a
	POST request"

	^self propertyAt: #formFields ifAbsentPut: [
		self getFields copy addAll: self postFields; yourself
	]! !

!HttpRequest methodsFor: 'accessing' stamp: 'svp 11/30/1999 16:27'!
getFields
	| tmp in |
	"Answer the multipart fields for a post request (if in fact this is a
	POST request"

	^self propertyAt: #getFields ifAbsentPut: [
		" parse GET fields in the header of request, if it's standard form data "

		tmp _ self url.
		((in _ tmp indexOf: $?) > 0) ifTrue: [
			self class decodeUrlEncodedForm: 
				(tmp copyFrom: (in + 1) to: tmp size)
		] ifFalse: [
			Dictionary new.
		].
	]! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 1/4/2000 18:53'!
header
	^header! !

!HttpRequest methodsFor: 'accessing' stamp: 'svp 11/18/1999 12:04'!
localAddress
	"Answer the address of the request originator"

	^self propertyAt: #localAddress ifAbsentPut: [
		(stream respondsTo: #localAddress) ifTrue: [
			stream localAddress
		] ifFalse: [
			nil
		]
	]! !

!HttpRequest methodsFor: 'accessing' stamp: 'svp 11/18/1999 12:12'!
localPort
	"Answer the address of the request originator"

	^self propertyAt: #localPort ifAbsentPut: [
		(stream respondsTo: #localPort) ifTrue: [
			stream localPort
		] ifFalse: [
			nil
		]
	]! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 1/4/2000 18:42'!
machineName

	^self networkHost machineName! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 1/4/2000 18:15'!
method
	^self propertyAt: #method ifAbsent: ['GET']! !

!HttpRequest methodsFor: 'accessing' stamp: 'svp 12/8/1999 20:57'!
newCookies

	^self propertyAt: #newCookies ifAbsentPut: [
		OrderedCollection new
	].! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 8/18/1999 18:37'!
operation
	^operation! !

!HttpRequest methodsFor: 'accessing' stamp: 'svp 11/30/1999 16:21'!
postFields
	"Answer the multipart fields for a post request (if in fact this is a
	POST request"

	^self propertyAt: #postFields ifAbsentPut: [
		" parse POST fields in the body of request, if it's standard form data "

		(self isPostRequest and: [ 
			self contentType = MIMEDocument contentTypeFormData 
		]) ifTrue: [
			self class decodeUrlEncodedForm: 
				(stream next: self contentLength).
		] ifFalse: [
			Dictionary new
		].
	].
! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 1/4/2000 18:51'!
protocol
	^self propertyAt: #protocol ifAbsent: [self defaultProtocol]! !

!HttpRequest methodsFor: 'accessing' stamp: 'SVP 8/27/1999 00:25'!
referer

	^self propertyAt: #referer ifAbsentPut: [
		header at: 'referer' ifAbsent: [ nil ]
	]

! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 1/4/2000 17:55'!
remoteAddress
	^self propertyAt: #remoteAddress ifAbsent: [nil]! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 5/18/1999 19:57'!
responseHeader
	^responseHeader! !

!HttpRequest methodsFor: 'accessing' stamp: 'SVP 8/20/1999 22:08'!
sessionClass

	^HttpSession! !

!HttpRequest methodsFor: 'accessing' stamp: 'sma 2/8/2000 18:20'!
simpleUrl
	^ self url copyUpTo: $?! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 5/6/1999 20:16'!
stream
	^stream! !

!HttpRequest methodsFor: 'accessing' stamp: 'svp 11/18/1999 12:21'!
timeTaken

	^self propertyAt: #timeTaken ifAbsent: [ nil ]! !

!HttpRequest methodsFor: 'accessing' stamp: 'svp 11/18/1999 12:21'!
timeTaken: seconds

	self propertyAt: #timeTaken put: seconds! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 1/5/2000 20:18'!
timestamp

	^self propertyAt: #timestamp ifAbsent: [ nil ]! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 1/5/2000 20:18'!
timestamp: seconds

	self propertyAt: #timestamp put: seconds! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 5/16/1999 16:58'!
url
	^url! !

!HttpRequest methodsFor: 'accessing' stamp: 'svp 12/3/1999 07:38'!
webBrowser

	^self propertyAt: #webBrowser ifAbsentPut: [
		WebBrowser concreteInstanceFromHeader: (header at: 'user-agent' ifAbsent: [ '' ])
	]
! !

!HttpRequest methodsFor: 'multipart support' stamp: 'bolot 1/4/2000 18:35'!
multipartBoundary
	| str idx |
	"Decode multipart form data boundary information from a
	header line that looks like the following line:"
	" Content-Type: multipart/form-data; boundary=----- "


	^self propertyAt: #multipartBoundary ifAbsentPut: [
		str _ header at: 'content-type' ifAbsent: [ '' ].
		(str asLowercase beginsWith: MIMEDocument contentTypeMultipart)
			ifTrue: [idx _ str indexOf: $=. 
			
	(str copyFrom: idx + 1 to: str size)]
			ifFalse: [ nil ]]! !

!HttpRequest methodsFor: 'converting' stamp: 'bolot 1/4/2000 18:58'!
printHtmlOn: printStream
	printStream nextPutAll: '<B>', self class name, '</B><UL>'; cr;
		nextPutAll: '<LI><B>URL</B>=', url asString; cr;
		nextPutAll: '<LI><B>protocol</B>=', self protocol asString; cr.

	self header isEmpty not
		ifTrue: [printStream nextPutAll: '<LI><B>Header</B><UL>'; cr.
			self header associationsDo: [:a | printStream nextPutAll: '<LI><B>', a key, '</B>=', a value; cr].
			printStream nextPutAll: '</UL>'; cr].

	self getFields isEmptyOrNil not
		ifFalse: [printStream nextPutAll: '<LI><B>getFields</B><UL>'; cr.
			self getFields associationsDo: [:a | printStream nextPutAll: '<LI><B>', a key, '</B>=', a value; cr].
			printStream nextPutAll: '</UL>'; cr].

	self postFields isEmptyOrNil
		ifFalse: [printStream nextPutAll: '<LI><B>postFields</B><UL>'; cr.
			self postFields associationsDo: [:a | printStream nextPutAll: '<LI><B>', a key, '</B>=', a value; cr].
			printStream nextPutAll: '</UL>'; cr].

	printStream
		nextPutAll: '</UL>'; cr.! !

!HttpRequest methodsFor: 'converting' stamp: 'bolot 5/16/1999 14:48'!
printHtmlString
	^String streamContents: [:tempStream | self printHtmlOn: tempStream]
! !

!HttpRequest methodsFor: 'converting' stamp: 'bolot 1/4/2000 18:58'!
printOn: printStream
	printStream nextPutAll: self class name;
		nextPutAll: ' (URL=', self url asString;
		nextPutAll: '; protocol=', self protocol asString;
		nextPutAll: '; header=', self header asString;
		nextPutAll: '; getFields=', self getFields asString;
		nextPutAll: '; postFields=', self postFields asString;
		nextPutAll: ')'! !

!HttpRequest methodsFor: 'converting' stamp: 'bolot 1/22/2000 16:24'!
writeOn: aStream
	"this can be used to form a client-side request and send it over network"
	aStream nextPutAll: self method, ' ', self url, ' ', self protocol, String crlf.
	self header keysAndValuesDo: [:key :value |
		aStream nextPutAll: key, ': ', value, String crlf].
	aStream nextPutAll: String crlf.
	aStream nextPutAll: self body asString! !

!HttpRequest methodsFor: 'logging' stamp: 'bolot 1/5/2000 20:19'!
printFullLogOn: printStream
	"remotehost rfc931 authuser [date] 'request' status bytes"
	printStream nextPutAll:
	(String streamContents: [:writeStream |
		writeStream nextPutAll: (NetNameResolver stringFromAddress: self remoteAddress); tab;
			nextPutAll: '-	-'; tab;
			nextPutAll: self timestamp asString; tab;
			nextPutAll: url asString; tab;
			nextPutAll: (self propertyAt: #httpResponseStatus ifAbsent:[]) asString; tab;
			nextPutAll: stream outDataCount asString; cr; tab;
			nextPutAll: self getFields asString; cr; tab;
			nextPutAll: self postFields asString; cr]).

#todo. "remove property use above"! !

!HttpRequest methodsFor: 'logging' stamp: 'bolot 1/5/2000 20:19'!
printLogOn: printStream
	"remotehost rfc931 authuser [date] 'request' status bytes"
	printStream nextPutAll:
	(String streamContents: [:writeStream |
		writeStream nextPutAll: (NetNameResolver stringFromAddress: self remoteAddress); tab;
			nextPutAll: '-	-'; tab;
			nextPutAll: self timestamp asString; tab;
			nextPutAll: url asString; tab;
			nextPutAll: (self propertyAt: #httpResponseStatus ifAbsent:[]) asString; tab;
			nextPutAll: stream outDataCount asString; cr]).

#todo. "remove property use above"! !

!HttpRequest methodsFor: 'private' stamp: 'bolot 1/4/2000 17:51'!
hostName

	^self propertyAt: #hostName ifAbsentPut: [
		(header at: 'host' ifAbsent: [ '' ]) asLowercase.
	]! !

!HttpRequest methodsFor: 'private' stamp: 'svp 11/5/1999 13:57'!
networkHost

	^self propertyAt: #networkHost ifAbsentPut: [
		NetworkHost fromString: self hostName
	].

! !

!HttpRequest methodsFor: 'private'!
privHeader: aDict
	header _ aDict! !

!HttpRequest methodsFor: 'private' stamp: 'bolot 8/18/1999 18:37'!
privOperation: op
	operation _ op! !

!HttpRequest methodsFor: 'private' stamp: 'bolot 1/4/2000 19:02'!
privPostFields: p
	postFields _ p! !

!HttpRequest methodsFor: 'private'!
privProperties
	^properties! !

!HttpRequest methodsFor: 'private'!
privProperties: anIdentDict
	properties _ anIdentDict copy! !

!HttpRequest methodsFor: 'private' stamp: 'bolot 5/18/1999 19:57'!
privResponseHeader: dict
	responseHeader _ dict! !

!HttpRequest methodsFor: 'private' stamp: 'bolot 5/16/1999 17:23'!
privStream: s
	stream _ s! !

!HttpRequest methodsFor: 'private' stamp: 'bolot 5/16/1999 17:22'!
privUrl: u
	url _ u! !

!HttpRequest methodsFor: 'private' stamp: 'bolot 1/4/2000 17:59'!
pvtHeader: aDict
	header _ aDict! !

!HttpRequest methodsFor: 'private' stamp: 'bolot 1/4/2000 17:47'!
pvtMethod: aString
	self propertyAt: #method put: aString! !

!HttpRequest methodsFor: 'private' stamp: 'bolot 12/27/1999 15:07'!
pvtOperation: op
	operation _ op! !

!HttpRequest methodsFor: 'private' stamp: 'bolot 2/9/2000 17:53'!
pvtProtocol: aString
	| tokens |
	self propertyAt: #protocol put: aString.
	(self protocol asUppercase beginsWith: 'HTTP/')
		ifTrue:
			[tokens _ aString findTokens: '.'.
			tokens size = 2
				ifTrue:
					[self propertyAt: #httpMajorVersion put: tokens first.
					self propertyAt: #httpMinorVersion put: tokens second]]! !

!HttpRequest methodsFor: 'private' stamp: 'sma 2/9/2000 11:56'!
pvtReadRequestFrom: aStream
	| headerString statusString statusLine i |

	headerString _ aStream upToAll: self endOfRequestMarker.
	i _ headerString findString: String crlf.
	i = 0
		ifFalse:
			[statusString _ headerString copyFrom: 1 to: i-1.
			headerString _ headerString copyFrom: i+2 to: headerString size]
		ifTrue:
			[statusString _ headerString.
			headerString _ ''].
	statusLine _ statusString findTokens: ' '.

	"skip CRLFCRLF"  aStream next: (self endOfRequestMarker size).

	statusLine size = 3
		ifTrue: [self pvtMethod: statusLine first.
			url _ statusLine second.
			self pvtProtocol: statusLine third]
		ifFalse: [self error: 'Bad request'].

	self pvtHeader: (HttpAdaptor parseHttpHeader: headerString).

	self postFields. "force reading/parsing post fields"! !

!HttpRequest methodsFor: 'private' stamp: 'bolot 1/4/2000 17:55'!
pvtRemoteAddress: aRemoteAddress
	self propertyAt: #remoteAddress put: aRemoteAddress! !

!HttpRequest methodsFor: 'private' stamp: 'bolot 12/27/1999 15:06'!
pvtStream: s
	stream _ s! !

!HttpRequest methodsFor: 'private' stamp: 'bolot 12/27/1999 15:06'!
pvtUrl: u
	url _ u! !

!HttpRequest methodsFor: 'authentication' stamp: 'bolot 9/11/1999 16:44'!
user
	"currently, only basic authentication is supported"
	| userID i |
	userID _ self header at: 'authorization' ifAbsent: [^nil].
	(userID notNil and: [(i _ userID findString: 'Basic ') > 0])
		ifTrue: [userID _ userID copyFrom: i+6 to: userID size]
		ifFalse: [userID _ nil].
	^userID! !

!HttpRequest methodsFor: 'response' stamp: 'bolot 2/9/2000 17:34'!
redirectTo: aUrl
	^HttpRedirect new signalLocation: aUrl! !

!HttpRequest methodsFor: 'response' stamp: 'bolot 8/11/1999 22:10'!
responseHeaderAt: key put: value
	responseHeader at: key put: value! !

!HttpRequest methodsFor: 'errors' stamp: 'bolot 2/9/2000 17:34'!
badRequest
	^HttpBadRequest signal! !

!HttpRequest methodsFor: 'errors' stamp: 'bolot 2/9/2000 17:21'!
unauthorizedFor: realm
	^Unauthorized new signalRealm: realm! !

!HttpRequest methodsFor: 'defaults' stamp: 'SVP 8/12/1999 11:40'!
defaultContentType

	^self class defaultContentType! !

!HttpRequest methodsFor: 'defaults' stamp: 'SVP 8/11/1999 11:52'!
defaultMethod

	^self class defaultMethod! !

!HttpRequest methodsFor: 'defaults' stamp: 'SVP 8/11/1999 11:52'!
defaultProtocol

	^self class defaultProtocol! !

!HttpRequest methodsFor: 'defaults' stamp: 'SVP 8/12/1999 11:40'!
defaultUrl

	^self class defaultUrl! !

!HttpRequest methodsFor: 'testing' stamp: 'SVP 8/23/1999 19:16'!
isFramesCapable

	^self webBrowser isFramesCapable! !

!HttpRequest methodsFor: 'testing' stamp: 'SVP 8/25/1999 08:55'!
isGetRequest

	^self method = 'GET'! !

!HttpRequest methodsFor: 'testing' stamp: 'SVP 8/25/1999 08:55'!
isHeaderRequest

	^self method = 'HEAD'! !

!HttpRequest methodsFor: 'testing' stamp: 'SVP 8/25/1999 08:55'!
isPostRequest

	^self method = 'POST'! !


!NetworkRequest class methodsFor: 'instance creation' stamp: 'SVP 8/17/1999 12:01'!
new

	^super new initialize! !


!HttpRequest class methodsFor: 'instance creation'!
fromRequest: rawRequest
	"create a copy from another request"
	"cannot use #copy because may be a different class"
	rawRequest class == self
		ifTrue: [^rawRequest copy].
	^(self new)
		privResponseHeader: rawRequest responseHeader;
		privHeader: rawRequest header;
		privProperties: rawRequest privProperties;
		privUrl: rawRequest url;
		privOperation: rawRequest operation;
		privStream: rawRequest stream! !

!HttpRequest class methodsFor: 'instance creation' stamp: 'SVP 8/26/1999 10:50'!
readFromSocket: aSocket

	^self new initializeFromStream: (SocketStream on: aSocket)
! !

!HttpRequest class methodsFor: 'instance creation' stamp: 'SVP 8/25/1999 19:48'!
readFromStream: aStream

	^self new initializeFromStream: aStream
! !

!HttpRequest class methodsFor: 'http stuff' stamp: 'bolot 2/9/2000 16:23'!
decodeUrlEncodedForm: string
	| dict key value start end eqSignPos more |
	dict _ Dictionary new.
	string isEmptyOrNil ifTrue: [^dict].
	more _ true.
	start _ 1.
	[end _ string indexOf: $& startingAt: start.
	end == 0
		ifTrue: [end _ string size. more _ false]
		ifFalse: [end _ end - 1].
	eqSignPos _ string indexOf: $= startingAt: start.
	(eqSignPos > end or: [eqSignPos == 0])
		ifTrue: [key _ (key _ string copyFrom: start to: end) unescapePercents asLowercase.
			value _ '']
		ifFalse: [key _ (key _ string copyFrom: start to: eqSignPos-1) unescapePercents asLowercase.
			value _ (value _ string copyFrom: eqSignPos+1 to: end) unescapePercents].
	(dict includesKey: key)
		ifFalse: [dict at: key put: value]
		ifTrue: [dict at: key modify: [:oldValue | oldValue, value]].
	start _ end + 2.
	more] whileTrue.

	^dict! !

!HttpRequest class methodsFor: 'http stuff' stamp: 'bolot 5/18/1999 20:09'!
decodeUrlEncodedForm: string fieldDelimiters: delims
	| dict tokens i key value |
	dict _ Dictionary new.
	tokens _ string findTokens: delims.
	tokens do: [:t |
		i _ t indexOf: $=.
		key _ (key _ t copyFrom: 1 to: i-1) unescapePercents asLowercase.
		value _ (value _ i < t size
			ifTrue: [ t copyFrom: i+1 to: t size ]
			ifFalse: ['']) unescapePercents.
	(dict includesKey: key)
		ifFalse: [ dict at: key put: value ]
		ifTrue: [
			((dict at: key) isKindOf: String)
				ifTrue: [ dict at: key put: (OrderedCollection with: (dict at: key)) ].
			(dict at: key) add: value]].
	^dict! !

!HttpRequest class methodsFor: 'http stuff' stamp: 'bolot 8/11/1999 14:48'!
fastParseHeader: string
	| dict key value start end more colonPos fieldDelims statusLine status lastKey keyValueDelim |
	"TODO: support multi-line headers (if line starts with a separator, append to last"
	dict _ Dictionary new.
	string isEmptyOrNil ifTrue: [^dict].
	fieldDelims _ String crlf asCharacterSet.
	keyValueDelim _ $:.
	more _ true.
	start _ 1.
	end _ string indexOfAnyOf: fieldDelims startingAt: start.
	end == 0
		ifTrue: [^dict].
	statusLine _ (string copyFrom: start to: end-1) findTokens: ' '.
	statusLine size = 3
		ifTrue: [(status _ Dictionary new)
			at: #method put: statusLine first;
			at: #url put: statusLine second;
			at: #protocol put: statusLine third].
	start _ string skipDelimiters: String crlf startingAt: end.
	lastKey _ ''.
	[end _ string indexOfAnyOf: fieldDelims startingAt: start.
	end == 0
		ifTrue: [end _ string size. more _ false]
		ifFalse: [end _ end - 1].
	(end >= start and: [start < string size])
		ifTrue: [
			(string at: start) isSeparator
				ifTrue: [dict at: lastKey put: ((dict at: lastKey), (string copyFrom: start to: end))]
				ifFalse: [colonPos _ string indexOf: keyValueDelim startingAt: start.
					(colonPos > end or: [colonPos == 0])
						ifTrue: [key _ (key _ string copyFrom: start to: end) asLowercase.
							value _ '']
						ifFalse: [key _ (key _ string copyFrom: start to: colonPos-1) asLowercase.
							value _ (value _ string copyFrom: colonPos+1 to: end) withBlanksTrimmed]].
			key isEmpty
				ifFalse: [dict at: key put: value.
					lastKey _ key.
					key _ ''].
			start _ string skipDelimiters: String crlf startingAt: end+1].
	more] whileTrue.

	^dict! !

!HttpRequest class methodsFor: 'http stuff' stamp: 'bolot 5/21/1999 03:29'!
parseHeader: string
	"divide into basic lines"
	" based on HTTPSocket header: code "
	| lines foldedLines i statusLine status header |
	lines _ string findTokens: String crlf.
	lines isEmpty ifTrue: [^nil].
	statusLine _ (lines first) findTokens: ' '.
	lines _ lines copyFrom: 2 to: lines size.

	"parse the status (pretty trivial right now)"
	statusLine size = 3
		ifTrue: [(status _ Dictionary new)
			at: #method put: statusLine first;
			at: #url put: statusLine second;
			at: #protocol put: statusLine third].

	"fold lines that start with spaces into the previous line"
	foldedLines _ OrderedCollection new.
	lines do: [ :line |
		line first isSeparator ifTrue: [
			foldedLines at: foldedLines size  put: (foldedLines last, line) ]
		ifFalse: [ foldedLines add: line ] ].

	"make a dictionary mapping headers to header contents"
	header _ Dictionary new.
	foldedLines do: [ :line |
		i _ line indexOf: $:.
		i > 0 ifTrue: [
			header
			at: (line copyFrom: 1 to: i-1) asLowercase 
			put: (line copyFrom: i+1 to: line size) withBlanksTrimmed ] ]..

	^header! !

!HttpRequest class methodsFor: 'initialize-release' stamp: 'bolot 2/20/2000 11:24'!
initialize
	EndOfRequestMarker _ String crlf, String crlf! !

!HttpRequest class methodsFor: 'defaults' stamp: 'SVP 8/12/1999 11:39'!
defaultContentType

	^MIMEDocument defaultContentType! !

!HttpRequest class methodsFor: 'defaults' stamp: 'SVP 8/11/1999 11:51'!
defaultMethod

	^'GET'! !

!HttpRequest class methodsFor: 'defaults' stamp: 'SVP 8/11/1999 11:50'!
defaultProtocol

	^'HTTP/1.0'! !

!HttpRequest class methodsFor: 'defaults' stamp: 'SVP 8/11/1999 11:51'!
defaultUrl

	^''! !

!HttpRequest class methodsFor: 'accessing' stamp: 'SVP 8/12/1999 09:39'!
endOfRequestMarker
	"This marks the end of an HTTP request (two consecutive CR-LFs)"

	^EndOfRequestMarker! !


!ObjectServerModule methodsFor: 'processing' stamp: 'bolot 8/16/1999 14:31'!
fileInFromRequest: request
	"assumption: POST, body=SmartRefStream"

	| srefStream string |
	string _ request stream upToEnd.
	srefStream _ RWBinaryOrTextStream on: (String new: request contentLength).
	srefStream nextPutAll: string; reset.
	^srefStream fileInObjectAndCode! !

!ObjectServerModule methodsFor: 'processing' stamp: 'bolot 8/16/1999 13:32'!
filter: rawRequest
	| request query uid |
	rawRequest getFields isEmptyOrNil ifTrue: [^nil].
	(rawRequest url beginsWith: '/', self name)
		ifFalse: [^nil].
	(query _ rawRequest getFields at: 'query' ifAbsent: [nil])
		ifNil: [^nil].
	request _ ObjectServerRequest fromRequest: rawRequest.
	uid _ rawRequest getFields at: 'uid' ifAbsent: [nil].
	request privQuery: query; privUid: uid.	
	^request! !

!ObjectServerModule methodsFor: 'processing' stamp: 'bolot 8/16/1999 14:44'!
processBeforeModules: request
	(self processQuery: request)
		ifFalse: [request badRequest].

	^request! !

!ObjectServerModule methodsFor: 'processing' stamp: 'bolot 8/18/1999 19:50'!
processQuery: request
	"return true/false - if handled"
	| anObject |
	request query caseOf:
	{
	['getclass']->[
		anObject _ request getFields at: 'classname' ifAbsent: [].
		anObject _ Smalltalk at: anObject asSymbol ifAbsent: [anObject].
		(anObject isKindOf: Class)
			ifTrue: [self sendClass: anObject onRequest: request]
			ifFalse: [request notFound]].
	['getchangeset']->[
		anObject _ request getFields at: 'changesetname' ifAbsent: [].
		anObject _ ChangeSorter changeSetNamed: anObject.
		(anObject isKindOf: ChangeSet)
			ifTrue: [self sendChangeSet: anObject onRequest: request]
			ifFalse: [request notFound]].
	['getobject']->[
		"return an object by ID..."].
	['putobject']->[
		self fileInFromRequest: request]
	} otherwise: [^false].

	^true! !

!ObjectServerModule methodsFor: 'processing'!
sendChangeSet: aChangeSet onRequest: request
	| srefStream |
	srefStream _ RWBinaryOrTextStream on: String new.
	aChangeSet checkForConversionMethods.
	srefStream header; timestamp.
	aChangeSet fileOutPreambleOn: srefStream.
	aChangeSet fileOutOn: srefStream.
	aChangeSet fileOutPostscriptOn: srefStream.
	srefStream trailer; close.
	DeepCopier new checkVariables.
	request responseHeaderAt: 'Content-type' put: MIMEDocument contentTypeBinary;
		responseHeaderAt: 'Content-length' put: srefStream contents size printString;
		success.
	request stream nextPutAll: srefStream contents! !

!ObjectServerModule methodsFor: 'processing'!
sendClass: aClass onRequest: request
	| srefStream |
	srefStream _ RWBinaryOrTextStream on: String new.
	srefStream fileOutClass: aClass andObject: 'signature'.
	request responseHeaderAt: 'Content-type' put: MIMEDocument contentTypeBinary;
		responseHeaderAt: 'Content-length' put: srefStream contents size printString;
		success.
	request stream nextPutAll: srefStream contents! !

!ObjectServerModule methodsFor: 'processing'!
sendObject: anObject onRequest: request
	| srefStream |
	srefStream _ RWBinaryOrTextStream on: String new.
	srefStream fileOutClass: nil andObject: anObject.
	request responseHeaderAt: 'Content-type' put: MIMEDocument contentTypeBinary;
		responseHeaderAt: 'Content-length' put: srefStream contents size printString;
		success.
	request stream nextPutAll: srefStream contents! !


!ObjectServerRequest methodsFor: 'accessing' stamp: 'bolot 8/15/1999 23:42'!
privQuery: aQuery
	query _ aQuery! !

!ObjectServerRequest methodsFor: 'accessing' stamp: 'bolot 8/15/1999 23:42'!
privUid: aUid
	uid _ aUid! !

!ObjectServerRequest methodsFor: 'accessing' stamp: 'bolot 8/15/1999 23:43'!
query
	^query! !

!ObjectServerRequest methodsFor: 'accessing' stamp: 'bolot 8/15/1999 23:43'!
uid
	^uid! !


!Process methodsFor: 'cloning' stamp: 'svp 12/3/1999 16:15'!
cloneForBranch

	^self class forContext: suspendedContext cloneForBranch priority: self priority! !

!Process methodsFor: 'cloning' stamp: 'svp 12/3/1999 18:08'!
desc

	^suspendedContext desc! !

!Process methodsFor: 'cloning' stamp: 'svp 12/3/1999 15:01'!
replaceReceiver: rcvr with: newRcvr

	suspendedContext replaceReceiver: rcvr with: newRcvr
! !

!Process methodsFor: 'cloning' stamp: 'svp 12/6/1999 17:01'!
replaceRefsTo: oldObj with: newObj

	suspendedContext replaceRefsTo: oldObj with: newObj
! !

!Process methodsFor: 'context stack' stamp: 'bolot 12/28/1999 14:52'!
contextAt: aKey

	^self contextAt: aKey ifAbsent: [ self error: 'key not found' ]! !

!Process methodsFor: 'context stack' stamp: 'bolot 12/28/1999 14:52'!
contextAt: aKey ifAbsent: absentBlock

	context ifNil: [ ^absentBlock value ].

	context reverseDo: [ :ea |
		ea at: aKey ifPresent: [ :v | ^v ]
	].
	^absentBlock value! !

!Process methodsFor: 'context stack' stamp: 'bolot 12/28/1999 14:52'!
contextAt: aKey put: aValue

	(context == nil) ifTrue: [
		context _ OrderedCollection new.
		context add: IdentityDictionary new.
	].
	context last at: aKey put: aValue.
	
! !

!Process methodsFor: 'context stack' stamp: 'bolot 12/28/1999 14:52'!
popContext

	((context == nil) or: [ context isEmpty ]) ifTrue: [ ^nil ].

	^context removeLast

! !

!Process methodsFor: 'context stack' stamp: 'bolot 12/28/1999 14:52'!
pushContext: dict

	(context == nil) ifTrue: [
		context _ OrderedCollection new.
	].
	context add: dict
! !


!Process class methodsFor: 'instance creation' stamp: 'svp 12/8/1999 14:05'!
forBranch

	| tmp |
	(tmp _ thisContext activeCloneForBranch) ~~ nil ifTrue: [	
		^self forContext: tmp priority: Processor activeProcess priority
	].
	^nil! !


!PwsModule methodsFor: 'pws api' stamp: 'bolot 5/16/1999 18:42'!
actions
	^PWS actions! !

!PwsModule methodsFor: 'processing' stamp: 'bolot 8/11/1999 23:53'!
filter: rawRequest
	| request fields userId message |
	message _ rawRequest url findTokens: '/.\?:='.

	(PWS actions includesKey: message first)
		ifFalse: [^nil].

	request _ PwsRequest fromRequest: rawRequest.

	request getFields
		ifNil: [fields _ Dictionary new]
		ifNotNil: [fields _ request getFields].
	request postFields
		ifNotNil: [request postFields associationsDo: [:a | fields at: a key put: a value]].

	userId _ request user.

	request
		privFields: fields;
		privMessage: message;
		privUserId: userId;
		privPeerName: nil;
		privAction: (PWS actions at: message first).

	^request! !

!PwsModule methodsFor: 'processing' stamp: 'bolot 1/5/2000 12:58'!
process: rawRequest
	| request |
	(request _ self filter: rawRequest)
		ifNil: [^nil].

	"Transcript show: request printString; cr."
	[request action process: request]
		ifError: [:err :rcvr |
			request log: '*** ', rcvr asString, ': ', err.
			[(err beginsWith: 'HTTP')
				ifFalse: [request badRequest].
			request stream nextPutAll: err] ifError: [:m :r | "ignore errors"]].

	^true "done"! !


!PwsRequest methodsFor: 'pws api' stamp: 'bolot 5/16/1999 18:14'!
fields
	^fields! !

!PwsRequest methodsFor: 'pws api' stamp: 'bolot 5/16/1999 18:14'!
log
	^log! !

!PwsRequest methodsFor: 'pws api' stamp: 'bolot 8/11/1999 23:53'!
log: str
	log ifNotNil: [log nextPutAll: str]! !

!PwsRequest methodsFor: 'pws api' stamp: 'bolot 5/16/1999 18:15'!
message
	^message! !

!PwsRequest methodsFor: 'pws api' stamp: 'bolot 5/16/1999 18:15'!
message: array
	message _ array! !

!PwsRequest methodsFor: 'pws api' stamp: 'bolot 5/16/1999 18:17'!
peerName
	^peerName! !

!PwsRequest methodsFor: 'pws api' stamp: 'bolot 5/16/1999 18:17'!
reply: str
	stream nextPutAll: str! !

!PwsRequest methodsFor: 'pws api' stamp: 'bolot 5/16/1999 18:36'!
replyStream: file
	stream serveFile: file! !

!PwsRequest methodsFor: 'pws api' stamp: 'bolot 5/16/1999 18:17'!
userId
	^userId! !

!PwsRequest methodsFor: 'private' stamp: 'bolot 5/16/1999 18:43'!
action
	^action! !

!PwsRequest methodsFor: 'private' stamp: 'bolot 5/16/1999 18:43'!
privAction: str
	action _ str! !

!PwsRequest methodsFor: 'private' stamp: 'bolot 5/16/1999 18:36'!
privFields: dict
	fields _ dict! !

!PwsRequest methodsFor: 'private' stamp: 'bolot 5/16/1999 18:34'!
privMessage: coll
	message _ coll! !

!PwsRequest methodsFor: 'private' stamp: 'bolot 5/16/1999 18:33'!
privPeerName: str
	peerName _ str! !

!PwsRequest methodsFor: 'private' stamp: 'bolot 5/16/1999 18:33'!
privUserId: str
	userId _ str! !


!PwsRequest class methodsFor: 'instance creation' stamp: 'bolot 8/11/1999 23:51'!
for: module fromRequest: rawRequest
	| request fields userId message |
	message _ rawRequest url findTokens: '/.\?:='.

	(PWS actions includesKey: message first)
		ifFalse: [^nil].

	request _ self fromRequest: rawRequest.

	request getFields
		ifNil: [fields _ Dictionary new]
		ifNotNil: [fields _ request getFields].
	request postFields
		ifNotNil: [request postFields associationsDo: [:a | fields at: a key put: a value]].

	userId _ request user.

	request
		privFields: fields;
		privMessage: message;
		privUserId: userId;
		privPeerName: nil;
		privAction: (PWS actions at: message first).

	^request! !


!RedirectModule methodsFor: 'initialization' stamp: 'bolot 8/19/1999 20:23'!
initialize
	super initialize.
	redirectMap _ Dictionary new! !

!RedirectModule methodsFor: 'processing' stamp: 'bolot 1/5/2000 12:59'!
process: request
	"combine filter: and process:"
	| coreRef index oldUrl |
	oldUrl _ request url.
	index _ oldUrl indexOfAnyOf: '?/\.' asCharacterSet startingAt: 2.
	index > 0 ifFalse: [index _ oldUrl size + 1].
	coreRef _ oldUrl copyFrom: 2 to: index - 1.
	redirectMap at: coreRef ifPresent: [:newUrl |
		request redirectTo: newUrl, (oldUrl copyFrom: index to: oldUrl size)].
	^true "done"! !

!RedirectModule methodsFor: 'accessing' stamp: 'bolot 8/19/1999 19:25'!
addMappingFrom: oldUrl to: newUrl
	redirectMap at: oldUrl put: newUrl! !

!RedirectModule methodsFor: 'accessing' stamp: 'bolot 8/19/1999 19:25'!
removeMappingFrom: oldUrl
	redirectMap removeKey: oldUrl ifAbsent: []! !


!RedirectModule class methodsFor: 'instance creation' stamp: 'bolot 8/19/1999 20:33'!
newModuleNamed: aName withRedirects: array
	"RedirectModule newModuleNamed: 'redirect'
		withRedirects: #( ('cnn' 'http://cnn.com')
			('excite' 'http://www.excite.com'))"
	| m oldUrl newUrl |
	m _ self newModuleNamed: aName.
	array do: [:elem | oldUrl _ elem first. newUrl _ elem second.
		m addMappingFrom: oldUrl to: newUrl].
	^m! !


!RemoteDisplayModule methodsFor: 'processing' stamp: 'bolot 2/14/2000 16:07'!
process: request
	| viewSize thumbnail |
	request formFields at: 'viewsize' ifPresent: [:value | viewSize _ value asPoint].
	viewSize ifNil: [viewSize _ Display extent // 8].
	thumbnail _ Form extent: viewSize depth: Display depth.
	(WarpBlt toForm: thumbnail)
			sourceForm: Display;
			cellSize: 2;  "installs a colormap"
			combinationRule: Form over;
			copyQuad: (Display boundingBox) innerCorners
			toRect: (0@0 extent: viewSize).
	thumbnail _ thumbnail asFormOfDepth: 8. "convert to GIFable form"
	^thumbnail



"process: request
	| project |
	(request urlTokens first asLowercase = self name)
		ifFalse: [^nil].

	projectName _ request formFields at: 'project' ifAbsent: [Project current name].
	extent _ 
	project _ Project named: projectName.
	thumbnail _ Form extent: viewSize depth: project imageForm.

	(WarpBlt toForm: thumbnail)
			sourceForm: project imageForm;
			cellSize: 2; 
			combinationRule: Form over;
			copyQuad: project innerCorners
			toRect: (0@0 extent: viewSize).

"! !


!RemoteDisplayModule class methodsFor: 'web server packages' stamp: 'bolot 2/14/2000 16:09'!
remoteDisplayServer
	^self newModuleNamed: 'remotedisplay'! !

!RemoteDisplayModule class methodsFor: 'web server packages' stamp: 'bolot 2/14/2000 16:08'!
remoteDisplayWebServer
	^self newModuleNamed: 'remotedisplay'! !


!SSPCompiler class methodsFor: 'accessing' stamp: 'bolot 2/19/2000 16:02'!
parserClass
	"Return a parser class to use for parsing method headers."

	^SSPParser! !


!SSPModule methodsFor: 'processing' stamp: 'bolot 2/19/2000 16:06'!
compileStream: stream
	| sourceCode compiler methodNode |

	(sourceCode _ self translateStream: stream)
		ifNil: [^nil].

	sourceCode reset.
	compiler _ SSPPage compilerClass new.
	compiler from: sourceCode class: SSPPage context: nil notifying: nil.
	methodNode _ compiler translate: sourceCode noPattern: true ifFail: [].
	^methodNode generate: #(0 0 0 0)! !

!SSPModule methodsFor: 'processing' stamp: 'bolot 2/19/2000 16:03'!
process: request
	| page executable value tempSelector stream |
#todo. "disallow direct access to stream in SSPages"
	"TODO: cache compiled pages"
	((stream _ super process: request) isKindOf: Stream)
		ifFalse: [^nil].

	(executable _ self compileStream: stream)
		ifNil: [^request notFound].

	request responseHeaderAt: 'Content-type' put: 'text/html'.
	request success.

	page _ SSPPage new.
	page request: request.
	tempSelector _ ('sspDoIt', (Time millisecondClockValue) asString) asSymbol.
	SSPPage addSelector: tempSelector withMethod: executable.
	value _ page perform: tempSelector.
	SSPPage removeSelectorSimply: tempSelector.

	request stopResponse.

	^value! !

!SSPModule methodsFor: 'processing' stamp: 'bolot 2/19/2000 16:07'!
translateStream: stream
	"translate the SSP file/stream into a doIt-able Smalltalk code"
	"text <?code?> text2 -> page stream nextPutAll: text. code. page stream nextPutAll: text2"
	"TODO: account for possibility of '?>' being in the code"
	"-- for now, work-around is to do ('?', '>')"
	| text code outStream |
	outStream _ ReadWriteStream on: String new.

	[stream atEnd]
	whileFalse: [
		text _ (stream upToAll: '<?').
		outStream nextPutAll: 'stream nextPutAll: ', text printString, '.'; cr.
		"stream next; next." "skip '<?'"
		code _ stream upToAll: '?>'.
		outStream nextPutAll: code, '.'; cr.
		"stream next; next." "skip '?>'"].

	^outStream! !


!SSPPage class methodsFor: 'accessing' stamp: 'bolot 2/19/2000 16:05'!
compilerClass
	"Answer a compiler class appropriate for source methods of this class."

	^SSPCompiler! !


!Semaphore methodsFor: 'mutual exclusion' stamp: 'svp 12/8/1999 13:01'!
critical: mutuallyExcludedBlock 
	"Evaluate mutuallyExcludedBlock only if the receiver is not currently in 
	the process of running the critical: message. If the receiver is, evaluate 
	mutuallyExcludedBlock after the other critical: message is finished."

	| blockValue |
	self wait.
	blockValue _ mutuallyExcludedBlock ensure: [ 
		self signal
	].
	^blockValue! !

!Semaphore methodsFor: 'mutual exclusion' stamp: 'svp 12/8/1999 13:01'!
critical: mutuallyExcludedBlock ifError: errorBlock
	"Evaluate mutuallyExcludedBlock only if the receiver is not currently in 
	the process of running the critical: message. If the receiver is, evaluate 
	mutuallyExcludedBlock after the other critical: message is finished."

	| blockValue hasError errMsg errRcvr |
	self wait.
	hasError _ false.
	blockValue _ [mutuallyExcludedBlock value] ifError:[:msg :rcvr|
		hasError _ true.
		errMsg _ msg.
		errRcvr _ rcvr].
	hasError ifTrue:[
		self signal.
		^errorBlock value: errMsg value: errRcvr].
	self signal.
	^blockValue! !


!Socket methodsFor: 'queries' stamp: 'SVP 8/26/1999 08:24'!
isDestroyed
	"Return true if this socket has a handle."

	^socketHandle == nil
! !

!Socket methodsFor: 'queries' stamp: 'bolot 10/21/1999 13:24'!
isOtherEndConnected
	| status |
	"Return true if this socket is connected or if the other end hasn't signalled a close yet."

	socketHandle == nil ifTrue: [^ false].
	status _ (self primSocketConnectionStatus: socketHandle).
	^(status = Connected or: [ status = ThisEndClosed ])! !

!Socket methodsFor: 'connection open/close' stamp: 'bolot 8/12/1999 13:05'!
accept
	"Accept a connection from the receiver socket.
	Return a new socket that is connected to the client"
	^self class acceptFrom: self.! !

!Socket methodsFor: 'sending-receiving' stamp: 'bolot 10/22/1999 11:29'!
discardReceivedData
	"Discard any data received up until now, and return the number of bytes discarded."

	| buf totalBytesDiscarded |
	buf _ String new: 10000.
	totalBytesDiscarded _ 0.
	[self isOtherEndConnected and: [ self dataAvailable ]] whileTrue: [
		totalBytesDiscarded _
			totalBytesDiscarded + (self receiveDataInto: buf)].
	^ totalBytesDiscarded
! !

!Socket methodsFor: 'sending-receiving' stamp: 'bolot 1/4/2000 19:28'!
getData
	"Get some data"

	| buf bytesRead |
	(self waitForDataUntil: Socket standardDeadline) ifFalse: [self error: 'getData timeout'].
	buf _ String new: 2000.
	bytesRead _ self primSocket: socketHandle receiveDataInto: buf startingAt: 1 count: buf size.
	^ buf copyFrom: 1 to: (bytesRead max: 0)! !

!Socket methodsFor: 'sending-receiving' stamp: 'bolot 9/10/1999 21:12'!
getResponseUpTo: markerString
	"Keep reading until the marker is seen.  Return three parts: header, marker, beginningOfData.  Fails if no marker in first 2000 chars." 

	| buf response bytesRead tester mm |
	buf _ String new: 2000.
	response _ WriteStream on: buf.
	tester _ 1. mm _ 1.
	[tester _ tester - markerString size + 1 max: 1.  "rewind a little, in case the marker crosses a read boundary"
	tester to: response position do: [:tt |
		(buf at: tt) = (markerString at: mm) ifTrue: [mm _ mm + 1] ifFalse: [mm _ 1].
			"Not totally correct for markers like xx0xx"
		mm > markerString size ifTrue: ["got it"
			^ Array with: (buf copyFrom: 1 to: tt+1-mm)
				with: markerString
				with: (buf copyFrom: tt+1 to: response position)]].
	 tester _ 1 max: response position.	"OK if mm in the middle"
	 (response position < buf size) & (self isConnected | self dataAvailable)] whileTrue: [
		(self waitForDataUntil: (Socket deadlineSecs: 5)) ifFalse: [
			Transcript show: 'data was late'; cr].
		bytesRead _ self primSocket: socketHandle receiveDataInto: buf 
			startingAt: response position + 1 count: buf size - response position.
		"response position+1 to: response position+bytesRead do: [:ii | 
			response nextPut: (buf at: ii)].	totally redundant, but needed to advance position!!"
		response instVarAt: 2 "position" put: 
			(response position + bytesRead)].	"horrible, but fast"

	^ Array with: response contents
		with: ''
		with: ''		"Marker not found and connection closed"
! !

!Socket methodsFor: 'sending-receiving' stamp: 'SVP 8/4/1999 15:36'!
receiveDataInto: aStringOrByteArray startingAt: startPos count: sizeOfBuf
	"Receive data into the given buffer and return the number of bytes received. Note the given buffer may be only partially filled by the received data."

	^ self primSocket: socketHandle
		receiveDataInto: aStringOrByteArray
		startingAt: startPos
		count: sizeOfBuf
! !

!Socket methodsFor: 'sending-receiving' stamp: 'SVP 8/13/1999 18:39'!
sendData: aStringOrByteArray waitForSeconds: timeoutSeconds
	"Send all of the data in the given array, even if it requires multiple calls to send it all. Return the number of bytes sent."

	| bytesSent bytesToSend count |
	bytesToSend _ aStringOrByteArray size.
	bytesSent _ 0.
	[bytesSent < bytesToSend] whileTrue: [
		(self waitForSendDoneUntil: (Socket deadlineSecs: timeoutSeconds))
			ifFalse: [self error: 'send data timeout; data not sent'].
		count _ self primSocket: socketHandle
			sendData: aStringOrByteArray
			startIndex: bytesSent + 1
			count: bytesToSend - bytesSent.
		bytesSent _ bytesSent + count].
	^ bytesSent
! !

!Socket methodsFor: 'waiting' stamp: 'bolot 10/21/1999 13:29'!
waitForDisconnectionUntil: deadline
	"Wait up until the given deadline for the the connection to be broken. Return true if it is broken by the deadline, false if not."
	"Note: The client should know the the connect is really going to be closed (e.g., because he has called 'close' to send a close request to the other end) before calling this method."

	| extraBytes status |
	extraBytes _ 0.
	status _ self primSocketConnectionStatus: socketHandle.
	[((status = Connected) or: [status = ThisEndClosed]) and:
	 [Time millisecondClockValue < deadline]] whileTrue: [
		self dataAvailable
			ifTrue: [extraBytes _ extraBytes + self discardReceivedData].
		semaphore waitTimeoutMSecs: (deadline - Time millisecondClockValue).
		status _ self primSocketConnectionStatus: socketHandle].


	^ status ~= Connected
! !


!Socket class methodsFor: 'instance creation' stamp: 'bolot 1/5/2000 10:54'!
concreteClass
	^Socket! !


!Stream methodsFor: 'accessing' stamp: 'SVP 8/26/1999 08:06'!
close

	"Do nothing by default"! !

!Stream methodsFor: 'accessing' stamp: 'SVP 8/12/1999 14:25'!
mimeType

	^MIMEDocument defaultContentType! !

!Stream methodsFor: 'converting' stamp: 'SVP 8/23/1999 19:07'!
asHttpResponseTo: request

	^HttpResponse fromStream: self! !


!BufferStream methodsFor: 'as yet unclassified' stamp: 'bolot 1/4/2000 20:04'!
contents
	^buffer copyFrom: startPos to: endPos! !

!BufferStream methodsFor: 'as yet unclassified' stamp: 'bolot 1/4/2000 20:02'!
includes: aChar
	^buffer includes: aChar! !

!BufferStream methodsFor: 'as yet unclassified' stamp: 'bolot 1/4/2000 20:02'!
includesAll: aString
	^(buffer findString: aString) > 0! !

!BufferStream methodsFor: 'as yet unclassified' stamp: 'bolot 1/4/2000 20:24'!
isEmpty
	^self size <= 0! !

!BufferStream methodsFor: 'as yet unclassified' stamp: 'bolot 1/4/2000 20:09'!
next
	^buffer at: (startPos _ startPos + 1) - 1! !

!BufferStream methodsFor: 'as yet unclassified' stamp: 'bolot 1/4/2000 20:09'!
next: anInteger
	^buffer copyFrom: startPos to: (startPos _ startPos + anInteger) - 1! !

!BufferStream methodsFor: 'as yet unclassified' stamp: 'bolot 1/4/2000 20:08'!
nextPutAll: aString
	buffer _ (buffer copyFrom: startPos to: endPos), aString.
	startPos _ 1.
	endPos _ buffer size! !

!BufferStream methodsFor: 'as yet unclassified' stamp: 'bolot 1/4/2000 20:15'!
on: aString
	buffer _ aString.
	startPos _ 1.
	endPos _ buffer size! !

!BufferStream methodsFor: 'as yet unclassified' stamp: 'bolot 1/4/2000 20:18'!
reset
	"hack"
	self on: ''! !

!BufferStream methodsFor: 'as yet unclassified' stamp: 'bolot 1/4/2000 20:23'!
size
	^endPos - startPos + 1! !

!BufferStream methodsFor: 'as yet unclassified' stamp: 'bolot 1/4/2000 20:22'!
upTo: aChar
	| i |
	i _ buffer indexOf: aChar startingAt: startPos.
	(i <= 0 or: [i > endPos])
		ifTrue: [^self upToEnd].
	^self next: (i-startPos)! !

!BufferStream methodsFor: 'as yet unclassified' stamp: 'bolot 1/4/2000 20:27'!
upToAll: aString
	| i |
	i _ buffer findString: aString startingAt: startPos.
	(i <= 0 or: [i > endPos])
		ifTrue: [^self upToEnd].
	^self next: (i-startPos)! !

!BufferStream methodsFor: 'as yet unclassified' stamp: 'bolot 1/4/2000 20:22'!
upToEnd
	| string |
	string _ self contents.
	self reset.
	^string! !


!BufferStream class methodsFor: 'instance creation' stamp: 'bolot 1/4/2000 20:16'!
on: aString
	^self basicNew on: aString! !


!DummyStream methodsFor: 'as yet unclassified' stamp: 'bolot 1/5/2000 12:30'!
setToEnd
	"do nothing"! !


!JdmLargeSizeReadStream methodsFor: 'accessing'!
readSize
	^self readSize64! !


!JdmReadStream methodsFor: 'accessing' stamp: 'jb 3/2/1999 17:33'!
readNullTerminatedString
	
	^self upTo: self class null asCharacter! !

!JdmReadStream methodsFor: 'accessing' stamp: 'jb 3/2/1999 17:33'!
readSize
	
	^self readSize32! !

!JdmReadStream methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:55'!
readSize32
	
	| aSize |
	
	aSize _ self next asInteger.
	
	(aSize < 0 or: [aSize > 254]) 
		
		ifTrue: 
	
		[JdmErrorTable throwException: #invalidSize message: aSize printString].
	
	aSize < 251 ifTrue: [^aSize].
	
	aSize = 251 ifTrue: [^0].
	
	^(self next: (aSize bitAnd: 3) + 2) asByteArray asInteger! !

!JdmReadStream methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:55'!
readSize64
	
	| aSize |
	
	aSize _ self next asInteger.
	
	(aSize < 0 or: [aSize > 254]) 
		
		ifTrue: 
			
		[JdmErrorTable throwException: #invalidSize message: aSize printString].
	
	aSize < 251 ifTrue: [^aSize].
	
	aSize = 251 ifTrue: [^0].
	
	aSize < 254 
		
		ifTrue: [^(self next: (aSize bitAnd: 3) + 2) asByteArray asInteger].
	
	^(self next: 8) asByteArray asInteger! !


!JdmReadStream class methodsFor: 'constants'!
null
	^0! !


!SocketStream methodsFor: 'initialization' stamp: 'bolot 12/27/1999 12:41'!
initialize
	self resetStatus.
	self setBuffered.
	self resetInStream.
	self resetOutStream! !

!SocketStream methodsFor: 'initialization' stamp: 'bolot 12/23/1999 16:21'!
initialize: aSocket
	self initialize.
	self socket: aSocket! !

!SocketStream methodsFor: 'http' stamp: 'bolot 12/17/1999 02:03'!
contentLength
	^(header at: 'content-length' ifAbsent: [0]) asNumber! !

!SocketStream methodsFor: 'http' stamp: 'bolot 12/17/1999 02:01'!
fastHeader: string
	| key value start end more colonPos fieldDelims statusLine lastKey keyValueDelim |
	"TODO: support multi-line headers (if line starts with a separator, append to last"
	header _ Dictionary new.
	string isEmptyOrNil ifTrue: [^self].
	fieldDelims _ String crlf asCharacterSet.
	keyValueDelim _ $:.
	more _ true.
	start _ 1.
	end _ string indexOfAnyOf: fieldDelims startingAt: start.
	end == 0
		ifTrue: [^self].
	statusLine _ (string copyFrom: start to: end-1) findTokens: ' '.
	statusLine size = 3
		ifTrue: [status
			at: #method put: statusLine first;
			at: #url put: statusLine second;
			at: #protocol put: statusLine third].
	start _ string skipDelimiters: String crlf startingAt: end.
	lastKey _ ''.
	[end _ string indexOfAnyOf: fieldDelims startingAt: start.
	end == 0
		ifTrue: [end _ string size. more _ false]
		ifFalse: [end _ end - 1].
	(end >= start and: [start < string size])
		ifTrue: [
			(string at: start) isSeparator
				ifTrue: [header at: lastKey put: ((header at: lastKey), (string copyFrom: start to: end))]
				ifFalse: [colonPos _ string indexOf: keyValueDelim startingAt: start.
					(colonPos > end or: [colonPos == 0])
						ifTrue: [key _ (key _ string copyFrom: start to: end) asLowercase.
							value _ '']
						ifFalse: [key _ (key _ string copyFrom: start to: colonPos-1) asLowercase.
							value _ (value _ string copyFrom: colonPos+1 to: end) withBlanksTrimmed]].
			key isEmpty
				ifFalse: [header at: key put: value.
					lastKey _ key.
					key _ ''].
			start _ string skipDelimiters: String crlf startingAt: end+1].
	more] whileTrue! !

!SocketStream methodsFor: 'http' stamp: 'bolot 12/22/1999 17:07'!
getSubHeader
	" return a MIME section header "
	| i result string dict |
	string _ inStream contents.
	self resetInStream.
	[(i _ string findString: String crlf, String crlf) > 0
		ifTrue: [result _ string copyFrom: 1 to: i-1.
			inStream nextPutAll: (string copyFrom: i to: string size).
			self next: 4. " ignore CRLFCRLF "
			^HttpRequest parseHeader: result].
	socket isConnected and: [socket dataAvailable]]
		whileTrue:
	[string _ string, socket getData].
	result _ string.
	dict _ HttpRequest parseHeader: result.
	dict isEmptyOrNil ifFalse: [self next: 4]. " ignore CRLFCRLF "
	^dict! !

!SocketStream methodsFor: 'http' stamp: 'bolot 12/17/1999 02:01'!
header: string
	"divide into basic lines"
	" based on HTTPSocket header: code "
	| lines foldedLines i statusLine |
	lines _ string findTokens: String crlf.
	statusLine _ (lines first) findTokens: ' '.
	lines _ lines copyFrom: 2 to: lines size.

	"parse the status (pretty trivial right now)"
	(status _ Dictionary new)
		at: #method put: statusLine first;
		at: #url put: statusLine second;
		at: #protocol put: statusLine third.

	"fold lines that start with spaces into the previous line"
	foldedLines _ OrderedCollection new.
	lines do: [ :line |
		line first isSeparator ifTrue: [
			foldedLines at: foldedLines size  put: (foldedLines last, line) ]
		ifFalse: [ foldedLines add: line ] ].

	"make a dictionary mapping headers to header contents"
	header _ Dictionary new.
	foldedLines do: [ :line |
		i _ line indexOf: $:.
		i > 0 ifTrue: [
			header
			at: (line copyFrom: 1 to: i-1) asLowercase 
			put: (line copyFrom: i+1 to: line size) withBlanksTrimmed ] ]..
! !

!SocketStream methodsFor: 'http' stamp: 'bolot 1/4/2000 17:22'!
readHeader
	| headerString crlf |
	crlf _ String crlf.
	[headerString _ self upToAll: crlf, crlf.
	"self next: 4." "(crlf, crlf) size"
	self fastHeader: headerString]
		ifError: [:err :rcvr | socket destroy. ^nil].! !

!SocketStream methodsFor: 'network' stamp: 'bolot 2/22/2000 16:23'!
localAddress
	^status at: #localAddress! !

!SocketStream methodsFor: 'network' stamp: 'bolot 2/22/2000 16:23'!
localPort
	^status at: #localPort! !

!SocketStream methodsFor: 'network' stamp: 'bolot 12/17/1999 02:02'!
remoteAddress
	^status at: #remoteAddress! !

!SocketStream methodsFor: 'network' stamp: 'bolot 2/22/2000 16:25'!
remotePort
	^status at: #remotePort! !

!SocketStream methodsFor: 'stream in' stamp: 'bolot 1/4/2000 20:31'!
next
	self atEnd ifTrue: [^nil].
	inStream isEmpty ifTrue: [self pvtGetData].
	^inStream next! !

!SocketStream methodsFor: 'stream in' stamp: 'bolot 1/4/2000 20:30'!
next: n
	| limit |

	[(inStream size < n) and: [ self isConnected ]]
		whileTrue: [self pvtGetData].

	limit _ n min: inStream size.
	^inStream next: limit! !

!SocketStream methodsFor: 'stream in' stamp: 'bolot 1/5/2000 15:59'!
nextChunk
	"getData front - retrieve all data available now"
	inStream isEmpty
		ifTrue: [self pvtGetData].
	^inStream upToEnd! !

!SocketStream methodsFor: 'stream in' stamp: 'bolot 12/22/1999 17:06'!
putDataBack: string
	| tempString |
	tempString _ inStream contents.
	self resetInStream.
	inStream nextPutAll: string; nextPutAll: tempString! !

!SocketStream methodsFor: 'stream in' stamp: 'bolot 1/4/2000 20:29'!
upTo: delim 
	| string |
	(inStream includes: delim)
		ifTrue: ["Found the delimiter part way into buffer"
			^inStream upTo: delim].
	self atEnd
		ifTrue: ["Never found it, and hit end of file"
			string _ inStream contents.
			self resetInStream.
			^string].
	"Never found it, but there's more..."
	self pvtGetData.
	^self upTo: delim! !

!SocketStream methodsFor: 'stream in' stamp: 'bolot 1/4/2000 20:46'!
upToAll: delims
	(inStream includesAll: delims)
		ifTrue: ["Found the delimiter part way into buffer"
			^inStream upToAll: delims].
	self atEnd
		ifTrue: ["Never found it, and hit end of file"
			^inStream upToEnd].
	"Never found it, but there's more..."
	self pvtGetData.
	^self upToAll: delims! !

!SocketStream methodsFor: 'stream in' stamp: 'bolot 12/22/1999 17:13'!
upToEnd
	| rest |
	rest _ socket getRestOfBuffer: inStream contents totalLength: self contentLength.
	self resetInStream.
	(rest isKindOf: String) ifTrue: [^'']. " error "
	^rest contents
! !

!SocketStream methodsFor: 'stream out' stamp: 'bolot 12/27/1999 12:17'!
cr
	self nextPutAll: String cr! !

!SocketStream methodsFor: 'stream out' stamp: 'bolot 8/11/1999 22:13'!
crlf
	self nextPutAll: String crlf! !

!SocketStream methodsFor: 'stream out' stamp: 'bolot 1/21/2000 16:33'!
flush
	socket isOtherEndConnected
		ifTrue: [socket sendData: outStream contents].
	self incOutDataCountBy: outStream contents size.
	self resetOutStream! !

!SocketStream methodsFor: 'stream out' stamp: 'bolot 12/27/1999 12:24'!
nextPut: char
	self nextPutAll: char asString! !

!SocketStream methodsFor: 'stream out' stamp: 'bolot 12/27/1999 12:25'!
nextPutAll: string
	outStream nextPutAll: string.
	self isBuffered ifTrue: [self flush]! !

!SocketStream methodsFor: 'accessing' stamp: 'bolot 12/22/1999 17:45'!
close
	self flush.
	socket closeAndDestroy: 30! !

!SocketStream methodsFor: 'accessing' stamp: 'bolot 12/17/1999 02:02'!
header
	^header! !

!SocketStream methodsFor: 'accessing' stamp: 'bolot 12/27/1999 12:25'!
isBuffered
	^true = (status at: #buffered ifAbsent: [false])! !

!SocketStream methodsFor: 'accessing' stamp: 'bolot 12/27/1999 12:40'!
setBuffered
	status at: #buffered put: true! !

!SocketStream methodsFor: 'accessing' stamp: 'bolot 12/27/1999 12:40'!
setUnBuffered
	status at: #buffered put: false! !

!SocketStream methodsFor: 'testing' stamp: 'bolot 12/27/1999 12:39'!
atEnd
	^self isConnected not
	and: [inStream isEmpty
	and: [self isDataAvailable not]]! !

!SocketStream methodsFor: 'testing' stamp: 'bolot 12/16/1999 18:40'!
isConnected
	^socket isConnected! !

!SocketStream methodsFor: 'testing' stamp: 'bolot 12/27/1999 12:38'!
isDataAvailable
	^socket dataAvailable! !

!SocketStream methodsFor: 'testing' stamp: 'bolot 12/16/1999 18:41'!
isOtherEndConnected
	^socket isOtherEndConnected! !

!SocketStream methodsFor: 'testing' stamp: 'bolot 12/16/1999 18:41'!
status
	^status! !

!SocketStream methodsFor: 'private' stamp: 'bolot 12/23/1999 16:18'!
inDataCount
	^status at: #inDataCount! !

!SocketStream methodsFor: 'private' stamp: 'bolot 12/27/1999 12:26'!
incInDataCountBy: increment
	"increment inDataCount by"
	status at: #inDataCount modify: [:n | n + increment]! !

!SocketStream methodsFor: 'private' stamp: 'bolot 12/27/1999 12:26'!
incOutDataCountBy: increment
	"increment outDataCount by"
	status at: #outDataCount modify: [:n | n + increment]! !

!SocketStream methodsFor: 'private' stamp: 'bolot 12/23/1999 16:18'!
outDataCount
	^status at: #outDataCount! !

!SocketStream methodsFor: 'private' stamp: 'bolot 12/23/1999 16:18'!
pvtGetData
	| string |
	inStream nextPutAll: (string _ socket getData).
	self incInDataCountBy: string size.
	^string! !

!SocketStream methodsFor: 'private' stamp: 'bolot 1/4/2000 20:19'!
resetInStream
	inStream _ BufferStream on: ''! !

!SocketStream methodsFor: 'private' stamp: 'bolot 1/4/2000 20:19'!
resetOutStream
	outStream _ BufferStream on: ''! !

!SocketStream methodsFor: 'private' stamp: 'bolot 12/23/1999 16:20'!
resetStatus
	(status _ Dictionary new)
	at: #inDataCount put: 0;
	at: #outDataCount put: 0! !

!SocketStream methodsFor: 'private' stamp: 'bolot 12/23/1999 16:22'!
socket: aSocket
	socket _ aSocket.
	status at: #localAddress put: aSocket localAddress.
	status at: #localPort put: aSocket localPort.
	status at: #remoteAddress put: aSocket remoteAddress.
	status at: #remotePort put: aSocket remotePort! !


!SocketStream class methodsFor: 'instance creation' stamp: 'bolot 12/16/1999 18:06'!
on: socket
	"create a socket stream on a server socket"
	"for HTTP style header must call readHeader explicitly"
	^self basicNew initialize: socket! !


!String methodsFor: 'converting' stamp: 'SVP 8/23/1999 19:07'!
asHttpResponseTo: request

	^HttpResponse fromString: self
! !

!String methodsFor: 'converting' stamp: 'bolot 2/14/2000 16:06'!
asPoint
	| coords |
	coords _ self findTokens: '@'.
	coords size = 2
		ifFalse: [^nil].
	^coords first asNumber @ coords second asNumber
! !

!String methodsFor: 'converting' stamp: 'bolot 9/11/1999 12:23'!
encodePathForHTTP
	"change dangerous characters to their %XX form, for use in HTTP transactions"
	"but leave / as-is"
	| encodedStream |
	encodedStream _ WriteStream on: (String new).
	
	self do: [ :c |
		(c isSafeForHTTP or: [c = $/]) ifTrue: [ encodedStream nextPut: c ] ifFalse: [
			encodedStream nextPut: $%.
			encodedStream nextPut: (c asciiValue // 16) asHexDigit.
			encodedStream nextPut: (c asciiValue \\ 16) asHexDigit.
		]
	].
	^encodedStream contents. ! !

!String methodsFor: 'converting' stamp: 'SVP 8/24/1999 08:24'!
fixUrlPathDelimiters
	"Path using local file system's delimiter.  $\ or $:"

	^String streamContents: [ :s |
		self do: [ :p |
			(p == $/) ifTrue: [
				s nextPut: FileDirectory pathNameDelimiter.
			] ifFalse: [
				s nextPut: p.
			].
		].
	]. 
! !

!String methodsFor: 'testing' stamp: 'bolot 1/5/2000 21:20'!
isAllDigits
	"whether the receiver is composed entirely of digits"
	self do: [:c | c isDigit ifFalse: [^ false]].
	^ true! !

!String methodsFor: 'testing' stamp: 'SVP 8/17/1999 11:07'!
isPositiveInteger

	(self = '') ifTrue: [ ^false ].
	self do: [ :letter | letter isDigit ifFalse: [ ^false ]].
	^true! !

!String methodsFor: 'chango processing' stamp: 'svp 12/7/1999 17:14'!
processNetRequest: request

	self error: self! !


!TerminalObject methodsFor: 'accessing' stamp: 'svp 12/8/1999 08:48'!
id

	^id! !

!TerminalObject methodsFor: 'accessing' stamp: 'svp 12/8/1999 08:47'!
lifespan

	^lifespan! !

!TerminalObject methodsFor: 'accessing' stamp: 'svp 12/8/1999 08:47'!
lifespan: seconds

	lifespan _ seconds! !

!TerminalObject methodsFor: 'defaults' stamp: 'svp 12/8/1999 08:49'!
defaultLifespan
	"1800 seconds = 30 minutes"

	^1800! !

!TerminalObject methodsFor: 'store/recall' stamp: 'svp 12/8/1999 09:22'!
destroy

	self class retire: self id.
	id _ nil.! !

!TerminalObject methodsFor: 'store/recall' stamp: 'svp 12/8/1999 14:14'!
resetId

	self class retire: id.
	id _ nil.
	self store.! !

!TerminalObject methodsFor: 'store/recall' stamp: 'svp 12/14/1999 09:09'!
store
	| newID |

	Mutex critical: [
		[	
			newID := (RandomGenerator next * SmallInteger maxVal) asInteger.
			Instances includesKey: newID 
		] whileTrue.
		Instances at: newID put: self.
	].
	id _ newID.
	self class startUndertaking.
	^newID! !

!TerminalObject methodsFor: 'initialize-release' stamp: 'svp 12/8/1999 09:29'!
initialize

	lastAccess _ Time totalSeconds.
	lifespan _ self defaultLifespan. 
	self store.! !

!TerminalObject methodsFor: 'life support' stamp: 'svp 12/8/1999 08:46'!
isViable

	^self isViableAsOf: Time totalSeconds

! !

!TerminalObject methodsFor: 'life support' stamp: 'svp 12/8/1999 09:48'!
isViableAsOf: aNumber
	"aNumber <Number> - a value in seconds since Jan. 1, 1901 (from Time>>totalSeconds)"
	
	^(aNumber - lastAccess) < self lifespan.
! !

!TerminalObject methodsFor: 'life support' stamp: 'svp 12/13/1999 09:26'!
touch
	"Touching a terminal object gives the object a new lease on life."

	lastAccess _ Time totalSeconds.
! !


!NetworkDialogInterface methodsFor: 'html templates' stamp: 'svp 11/30/1999 17:16'!
dialogFieldsTemplate

^'	<input name="dlgid" TYPE="hidden" VALUE="<?dlgid?>">
	<input name="dlgstep" TYPE="hidden" VALUE="<?dlgstep?>">'

! !

!NetworkDialogInterface methodsFor: 'converting' stamp: 'svp 12/6/1999 13:49'!
asHttpResponseTo: request

	^HttpResponse fromNetInterface: self! !

!NetworkDialogInterface methodsFor: 'processing' stamp: 'svp 12/13/1999 13:35'!
dialogProcessHandlerBlock

	^[ :ex | 
		(Processor activeProcess contextAt: #netInterface) postResponse: ex.
		Processor activeProcess suspend.
	].! !

!NetworkDialogInterface methodsFor: 'processing' stamp: 'svp 12/8/1999 13:55'!
formatResponse: anObject

	| tmp |
	(anObject isKindOf: String) ifFalse: [ ^anObject ].
	tmp _ '	<input name="dlgid" TYPE="hidden" VALUE="', self id printString,'">
		<input name="dlgstep" TYPE="hidden" VALUE="',self step asString,'">'.

	^anObject asFormattedString
		inPlaceOf: 'dialogfields' put: [ tmp ];
		formatted! !

!NetworkDialogInterface methodsFor: 'processing' stamp: 'svp 12/7/1999 12:43'!
getRequest

	^self requestQueue next! !

!NetworkDialogInterface methodsFor: 'processing' stamp: 'svp 12/7/1999 12:43'!
getResponse

	^self responseQueue next! !

!NetworkDialogInterface methodsFor: 'processing' stamp: 'svp 12/7/1999 12:43'!
postRequest: anObject

	self requestQueue nextPut: anObject! !

!NetworkDialogInterface methodsFor: 'processing' stamp: 'svp 12/8/1999 14:04'!
postResponse: anObject

	self responseQueue nextPut: anObject! !

!NetworkDialogInterface methodsFor: 'processing' stamp: 'svp 12/13/1999 14:15'!
processDialog: aDialog

	self lifespan: aDialog lifespan.
	process ifNotNil: [ process terminate ].
	process _ [
		Processor activeProcess contextAt: #netInterface put: self.
		[
			self postResponse: (aDialog begin: self getRequest).
		] on: Error do: self handlerBlock.
	] newProcess.

	process resume.
! !

!NetworkDialogInterface methodsFor: 'processing' stamp: 'svp 12/13/1999 10:11'!
processNetRequest: request

	| resp |
	self touch.
	self validateSequenceNumber: request ifOld: [
		^self branch: request
	].
	self postRequest: request.
	resp _ self getResponse.
	self incrementStep.
	(resp isKindOf: Exception) ifTrue: [
		^DialogProcessingError signalException: resp interface: self
	].
	^self formatResponse: resp.! !

!NetworkDialogInterface methodsFor: 'processing' stamp: 'svp 12/8/1999 14:05'!
validateSequenceNumber: request ifOld: oldBlock

	| seq seqNum |
	seq _ request formFields at: 'dlgstep' ifAbsent: [ '0' ].
	seq isPositiveInteger ifFalse: [ ^self error: 'Bad sequence number' ].

	((seqNum _ seq asNumber) = self step) ifFalse: [
		(seqNum > self step) ifTrue: [ ^self error: 'Bad sequence number' ].
		oldBlock value.
	].
! !

!NetworkDialogInterface methodsFor: 'initialize-finalize' stamp: 'svp 12/8/1999 15:32'!
destroy

	| tmp |
	self unregisterWithSession.
	super destroy.
	branchProcesses _ nil.

	"terminating the process must come last in case
	this is called in the currently executing process"
	process ifNotNil: [
		tmp _ process.
		process _ nil. 
		tmp terminate.
	].

! !

!NetworkDialogInterface methodsFor: 'initialize-finalize' stamp: 'svp 12/8/1999 13:54'!
initialize

	super initialize.
	step _ 0.
	responseQueue _ SharedQueue new.
	requestQueue _ SharedQueue new.
	branchProcesses _ OrderedCollection new.
	dialogStack _ OrderedCollection new.! !

!NetworkDialogInterface methodsFor: 'flow control' stamp: 'svp 12/13/1999 14:13'!
branch: request

	| tmp newStep newProc newDlgs |

	tmp _ self copyForBranch.
	newStep _ request formFields at: 'dlgstep' ifAbsent: [ '0' ].
	newStep isPositiveInteger ifTrue: [ 
		newStep _ newStep asNumber.
	] ifFalse: [
		newStep _ 0.
	].

	tmp step: newStep.
	tmp branchProcesses: (tmp branchProcesses copyFrom: 1 to: newStep).
	tmp resetId.
	tmp registerWithSession.

	(newStep = 0) ifTrue: [
		tmp dialogStack: (self dialogStack collect: [ :ea | ea copyForBranch ]).
		tmp processDialog: (tmp dialogStack last).		
	] ifFalse: [
		newProc _ (tmp branchProcesses at: newStep) key cloneForBranch.
		newDlgs _ (tmp branchProcesses at: newStep) value collect: [ :ea | ea copyForBranch ].
		tmp dialogStack: newDlgs.
		newProc replaceRefsTo: self with: tmp.
		newProc replaceRefsTo: self handlerBlock with: tmp handlerBlock.

		newDlgs with: (tmp branchProcesses at: newStep) value do: [ :nd :od |
			newProc replaceRefsTo: od with: nd.
		].
		newProc contextAt: #netInterface put: tmp.
		newProc resume.
	].

	^tmp processNetRequest: request.
! !

!NetworkDialogInterface methodsFor: 'flow control' stamp: 'svp 12/13/1999 14:16'!
copyForBranch

	| tmp |
	tmp _ self copy.
	tmp process: nil.
	tmp requestQueue: SharedQueue new.
	tmp responseQueue: SharedQueue new.
	tmp resetHandlerBlock.
	^tmp! !

!NetworkDialogInterface methodsFor: 'flow control' stamp: 'svp 12/8/1999 15:36'!
recordBranchProc: aProcessOrNil

	| newStack |

	aProcessOrNil == nil ifTrue: [ ^self ].

	newStack _ self dialogStack collect: [ :ea | ea copyForBranch ].
	newStack with: self dialogStack do: [ :od :nd |
		aProcessOrNil replaceRefsTo: od with: nd.
	].
	self branchProcesses add: (aProcessOrNil -> newStack).

	! !

!NetworkDialogInterface methodsFor: 'accessing' stamp: 'svp 12/2/1999 19:32'!
branchProcesses

	^branchProcesses! !

!NetworkDialogInterface methodsFor: 'accessing' stamp: 'svp 12/3/1999 14:55'!
branchProcesses: anOrderedCollection

	branchProcesses _ anOrderedCollection! !

!NetworkDialogInterface methodsFor: 'accessing' stamp: 'svp 12/6/1999 10:18'!
dialogStack

	^dialogStack! !

!NetworkDialogInterface methodsFor: 'accessing' stamp: 'svp 12/6/1999 10:36'!
dialogStack: anOrderedCollection

	dialogStack _ anOrderedCollection! !

!NetworkDialogInterface methodsFor: 'accessing' stamp: 'svp 12/9/1999 21:41'!
fullHttpUrl

	^(Processor activeProcess contextAt: #chango) 
		reference: '' address: ('dialog?dlgid=', self id printString) given: nil
! !

!NetworkDialogInterface methodsFor: 'accessing' stamp: 'svp 12/13/1999 14:15'!
handlerBlock

	handlerBlock ifNil: [
		self resetHandlerBlock.
	].
	^handlerBlock! !

!NetworkDialogInterface methodsFor: 'accessing' stamp: 'svp 11/30/1999 15:21'!
incrementStep

	step _ step + 1! !

!NetworkDialogInterface methodsFor: 'accessing' stamp: 'svp 12/6/1999 10:22'!
popDialog

	^self dialogStack removeLast! !

!NetworkDialogInterface methodsFor: 'accessing' stamp: 'svp 11/30/1999 13:27'!
process

	^process! !

!NetworkDialogInterface methodsFor: 'accessing' stamp: 'svp 12/8/1999 13:41'!
process: aProcess

	process _ aProcess.
! !

!NetworkDialogInterface methodsFor: 'accessing' stamp: 'svp 12/6/1999 10:22'!
pushDialog: aDialog

	self dialogStack add: aDialog! !

!NetworkDialogInterface methodsFor: 'accessing' stamp: 'svp 11/30/1999 13:43'!
registerWithSession

	self session addDialog: self.! !

!NetworkDialogInterface methodsFor: 'accessing' stamp: 'svp 11/30/1999 13:18'!
requestQueue

	^requestQueue! !

!NetworkDialogInterface methodsFor: 'accessing' stamp: 'svp 11/30/1999 18:25'!
requestQueue: aSharedQueue

	requestQueue _ aSharedQueue! !

!NetworkDialogInterface methodsFor: 'accessing' stamp: 'svp 12/13/1999 14:15'!
resetHandlerBlock

	handlerBlock _ [ :ex | 
		(Processor activeProcess contextAt: #netInterface) postResponse: ex.
		Processor activeProcess suspend.
	].! !

!NetworkDialogInterface methodsFor: 'accessing' stamp: 'svp 11/30/1999 13:18'!
responseQueue

	^responseQueue! !

!NetworkDialogInterface methodsFor: 'accessing' stamp: 'svp 11/30/1999 18:25'!
responseQueue: aSharedQueue

	responseQueue _ aSharedQueue! !

!NetworkDialogInterface methodsFor: 'accessing' stamp: 'svp 11/30/1999 13:44'!
session

	^session! !

!NetworkDialogInterface methodsFor: 'accessing' stamp: 'svp 11/30/1999 13:49'!
session: aSession

	session _ aSession.
	self registerWithSession.! !

!NetworkDialogInterface methodsFor: 'accessing' stamp: 'svp 11/30/1999 15:18'!
step

	^step! !

!NetworkDialogInterface methodsFor: 'accessing' stamp: 'svp 11/30/1999 18:46'!
step: aNumber

	step _ aNumber! !

!NetworkDialogInterface methodsFor: 'accessing' stamp: 'svp 12/8/1999 08:22'!
unregisterWithSession

	| tmp |
	(tmp _ self session) ifNotNil: [
		tmp removeDialog: self.
	]! !


!NetworkSession methodsFor: 'access' stamp: 'SVP 8/20/1999 10:46'!
at: key

	^data at: key ifAbsent: [
		self error: 'Internal key error. Please alert administrator about key', key printString
	].
! !

!NetworkSession methodsFor: 'access' stamp: 'SVP 9/3/1999 15:22'!
at: key ifAbsent: absBlock

	^data at: key ifAbsent: absBlock

! !

!NetworkSession methodsFor: 'access' stamp: 'SVP 9/3/1999 10:13'!
at: key ifAbsentPut: absBlock

	^data at: key ifAbsentPut: absBlock

! !

!NetworkSession methodsFor: 'access' stamp: 'SVP 8/20/1999 10:46'!
at: key put: value

	^data at: key put: value.
! !

!NetworkSession methodsFor: 'access' stamp: 'svp 12/9/1999 20:49'!
attemptCookieLoginFrom: request

	| uid pw chango acnt |
	uid _ request cookies at: 'UID' ifAbsent: [ ^self ].
	pw _ request cookies at: 'PW' ifAbsent: [ ^self ].
	chango _ Processor activeProcess contextAt: #chango ifAbsent: [ ^self ].

	(uid value isEmpty or: [ pw value isEmpty ]) ifTrue: [ ^self ].
	uid _ uid value.
	pw _ pw value.
	[
		uid _ uid asUnSafeString decryptUsing: Chango codeKey.
		acnt _ chango accountAt: uid asSymbol ifAbsent: [ ^self ].
		acnt verifyPassword: (pw asUnSafeString decryptUsing: Chango codeKey).
		self at: #changoAccount put: acnt.
	] on: Error do: [ :ex | ].! !

!NetworkSession methodsFor: 'dialogs' stamp: 'svp 12/6/1999 14:09'!
addDialog: aNetDialog

	self dialogsAt: aNetDialog id put: aNetDialog.
! !

!NetworkSession methodsFor: 'dialogs' stamp: 'svp 9/27/1999 10:39'!
dialogs

	^dialogs! !

!NetworkSession methodsFor: 'dialogs' stamp: 'svp 9/27/1999 17:04'!
dialogsAt: anId

	^dialogs at: anId! !

!NetworkSession methodsFor: 'dialogs' stamp: 'svp 9/27/1999 17:04'!
dialogsAt: anId ifAbsent: absBlock

	^dialogs at: anId ifAbsent: absBlock! !

!NetworkSession methodsFor: 'dialogs' stamp: 'svp 9/27/1999 17:04'!
dialogsAt: anId ifAbsentPut: absBlock

	^dialogs at: anId ifAbsentPut: absBlock! !

!NetworkSession methodsFor: 'dialogs' stamp: 'svp 9/27/1999 17:05'!
dialogsAt: anId put: aNetDialog

	^dialogs at: anId put: aNetDialog! !

!NetworkSession methodsFor: 'dialogs' stamp: 'svp 11/30/1999 14:18'!
removeDialog: aNetDialog

	self dialogs removeKey: aNetDialog id ifAbsent: []! !

!NetworkSession methodsFor: 'dialogs' stamp: 'svp 12/6/1999 14:19'!
resetDialogs

	dialogs _ Dictionary new.! !

!NetworkSession methodsFor: 'chango session' stamp: 'svp 10/28/1999 14:06'!
changoAccount

	^self at: #changoAccount ifAbsent: [ nil ]
! !

!NetworkSession methodsFor: 'chango session' stamp: 'svp 12/6/1999 14:18'!
changoAccount: aChangoAccount

	self at: #changoAccount put: aChangoAccount
! !

!NetworkSession methodsFor: 'chango session' stamp: 'svp 12/6/1999 14:18'!
changoLogout

	self changoAccount: nil.
	self resetDialogs.! !

!NetworkSession methodsFor: 'initialize-release' stamp: 'svp 12/13/1999 09:50'!
destroy

	self dialogs copy do: [ :ea | ea destroy ].
	super destroy.
! !

!NetworkSession methodsFor: 'initialize-release' stamp: 'svp 12/8/1999 09:29'!
initialize

	super initialize.
	data _ Dictionary new.
	self resetDialogs.



! !


!HttpSession methodsFor: 'converting' stamp: 'svp 11/9/1999 17:09'!
asCookieString

	^HttpCookie new
		domain: 'myswiki.net';
		name: 'SID';
		path: '/';
		value: self id asString;
		asHttpHeaderSetString! !

!HttpSession methodsFor: 'converting' stamp: 'svp 11/12/1999 16:26'!
asCookieStringForDomain: domainString

	^HttpCookie new
		domain: domainString;
		name: 'SID';
		path: '/';
		value: self id asString;
		asHttpHeaderSetString! !


!TerminalObject class methodsFor: 'store/recall' stamp: 'svp 12/8/1999 09:05'!
recall: id

	^self 
		recall: id 
		ifAbsent: [ self error: 'Non-existent instance' ]


! !

!TerminalObject class methodsFor: 'store/recall' stamp: 'svp 12/8/1999 09:05'!
recall: id ifAbsent: absBlock

	^self 
		recall: id 
		ifAbsent: absBlock 
		ifNotViable: [ self error: 'This object has expired.']

! !

!TerminalObject class methodsFor: 'store/recall' stamp: 'svp 12/14/1999 10:13'!
recall: id ifAbsent: absBlock ifNotViable: vBlock
	| anInstance done |
	"SVP: The done kludge is in this method because there is some problem with
	putting a block return inside a critical block.  I've modified #critical: to use
	TFEI's BlockContext>>ensure:...which I think is where the solution is hiding."

	done _ false.
	Mutex critical: [
		anInstance := Instances at: id ifAbsent: [ 
			done _ true.
		].
	].
	done ifTrue: [ ^absBlock value ].
	anInstance isViable ifFalse: [ ^vBlock value ].
	anInstance touch.
	^anInstance

! !

!TerminalObject class methodsFor: 'store/recall' stamp: 'svp 12/8/1999 09:03'!
recall: id ifAbsentOrNotViable: absBlock

	^self recall: id ifAbsent: absBlock ifNotViable: absBlock

! !

!TerminalObject class methodsFor: 'store/recall' stamp: 'svp 12/8/1999 09:00'!
retire: id

	Mutex critical: [
		Instances removeKey: id ifAbsent: [].
	].
! !

!TerminalObject class methodsFor: 'initialize-release' stamp: 'svp 12/14/1999 10:19'!
initialize
	" TerminalObject initialize "

	Undertaker _ nil.
	Instances := Dictionary new.
	RandomGenerator _ Random new.
	Mutex _ Semaphore forMutualExclusion.

! !

!TerminalObject class methodsFor: 'undertaking' stamp: 'svp 12/14/1999 09:18'!
clearAllInstances
	"  TerminalObject clearAllInstances  "

	Instances copy do: [ :ea | ea destroy ].
	self stopUndertaking.! !

!TerminalObject class methodsFor: 'undertaking' stamp: 'svp 12/8/1999 09:13'!
clearEvery: secs

	self stopUndertaking.
	Undertaker _ [ self undertakingLoop: secs ] newProcess.
	Undertaker resume.

	! !

!TerminalObject class methodsFor: 'undertaking' stamp: 'svp 12/14/1999 10:10'!
clearOld
	| totalSecs anInstance tmp |

	totalSecs _ Time totalSeconds.
	tmp _ Mutex critical: [ Instances keys ].
	tmp do: [ :s |
		Mutex critical: [ anInstance := Instances at: s ifAbsent: [ nil ] ].
		anInstance == nil ifFalse: [ 
			(anInstance isViableAsOf: totalSecs) ifFalse: [ 
				anInstance destroy
			].
		].
	].! !

!TerminalObject class methodsFor: 'undertaking' stamp: 'svp 12/8/1999 09:15'!
startUndertaking

	self clearEvery: 300 "every 5 minutes"

! !

!TerminalObject class methodsFor: 'undertaking' stamp: 'svp 12/14/1999 10:19'!
stopUndertaking

	Undertaker _ nil.

	! !

!TerminalObject class methodsFor: 'undertaking' stamp: 'svp 12/14/1999 10:18'!
undertakingLoop: secs
	" To be called on a background process only "

	[ true ] whileTrue: [
		self clearOld.
		Mutex critical: [ Instances isEmpty ifTrue: [ self stopUndertaking ] ].
		(Delay forSeconds: secs) wait.
		(Undertaker ~~ Processor activeProcess) ifTrue: [
			Processor activeProcess terminate.
		].
	].
! !

!TerminalObject class methodsFor: 'instance creation' stamp: 'svp 12/8/1999 08:40'!
new

	^super new initialize! !


!NetworkDialogInterface class methodsFor: 'instance creation' stamp: 'svp 11/30/1999 13:46'!
onSession: aSession

	^self new
		session: aSession;
		yourself! !


!NetworkSession class methodsFor: 'instance creation' stamp: 'SVP 8/20/1999 18:25'!
on: aNetworkRequest
	"Subclasses should override this method to find or create a network session
	based on the information contained in aNetworkRequest"

	self subclassResponsibility! !


!HttpSession class methodsFor: 'instance creation' stamp: 'svp 12/8/1999 22:00'!
on: anHttpRequest
	| sid ans |

	sid _ anHttpRequest cookies at: 'SID' ifAbsent: [ nil ].
	
	sid ifNotNil: [
		ans _ self recall: sid value asNumber ifAbsentOrNotViable: [ nil ].
	].

	ans ifNil: [ 
		ans _ self new.
		ans attemptCookieLoginFrom: anHttpRequest.
	].
	^ans
	! !


!Time class methodsFor: 'instance creation' stamp: 'ccn 10/7/2000 00:36'!
fromString: aString
	"Answer a new instance for the value given by aString.

	 Time fromString: '11:55:23 am'
	"

	^self readFrom: (ReadStream on: aString)! !

!Time class methodsFor: 'instance creation' stamp: 'ccn 10/7/2000 00:10'!
midnight
	"Answer a new instance at midnight."

	^self fromSeconds: 0! !

!Time class methodsFor: 'instance creation' stamp: 'ccn 10/7/2000 00:09'!
noon
	"Answer a new instance at noon."

	^self fromSeconds: 43200! !


!TimeStamp methodsFor: 'accessing' stamp: 'ccn 10/6/2000 22:51'!
date
	"Answer the date of the receiver."

	^date! !

!TimeStamp methodsFor: 'accessing' stamp: 'ccn 10/6/2000 22:52'!
date: aDate
	"Private - set the date of the receiver."

	date := aDate! !

!TimeStamp methodsFor: 'accessing' stamp: 'ccn 10/6/2000 22:53'!
time
	"Answer the time of the receiver."

	^time! !

!TimeStamp methodsFor: 'accessing' stamp: 'ccn 10/6/2000 22:54'!
time: aTime
	"Private - set the time of the receiver."

	time := aTime! !

!TimeStamp methodsFor: 'arithmetic' stamp: 'ccn 10/7/2000 00:00'!
minusDays: anInteger
	"Answer a TimeStamp which is anInteger days before the receiver."

	^self class date: (self date addDays: anInteger negated) time: self time! !

!TimeStamp methodsFor: 'arithmetic' stamp: 'ccn 10/7/2000 00:03'!
minusSeconds: anInteger
	"Answer a TimeStamp which is anInteger number of seconds before the receiver."

	^self class fromSeconds: ((self asSeconds) - anInteger)! !

!TimeStamp methodsFor: 'arithmetic' stamp: 'ccn 10/7/2000 00:00'!
plusDays: anInteger
	"Answer a TimeStamp which is anInteger days after the receiver."

	^self class date: (self date addDays: anInteger) time: self time! !

!TimeStamp methodsFor: 'arithmetic' stamp: 'ccn 10/7/2000 00:02'!
plusSeconds: anInteger
	"Answer a TimeStamp which is anInteger number of seconds after the receiver."

	^self class fromSeconds: ((self asSeconds) + anInteger)! !

!TimeStamp methodsFor: 'comparing' stamp: 'ccn 10/6/2000 23:22'!
< aTimeStamp
	"Answer true if the receiver is less than aTimeStamp, otherwise answer false."

	^self date < aTimeStamp date 
		or: [self date = aTimeStamp date and: [self time < aTimeStamp time]]! !

!TimeStamp methodsFor: 'comparing' stamp: 'ccn 10/6/2000 23:23'!
<= aTimeStamp
	"Answer true if the receiver is less than or equal to aTimeStamp, otherwise answer false."

	^self date < aTimeStamp date
		or: [self date = aTimeStamp date and: [self time <= aTimeStamp time]]! !

!TimeStamp methodsFor: 'comparing' stamp: 'ccn 10/6/2000 23:41'!
= aTimeStamp
	"ccn Note:  this does not take TimeZones into account.  Some day that should be fixed..."

	^self class = aTimeStamp class
		and: [self date = aTimeStamp date
		and: [self time = aTimeStamp time]]! !

!TimeStamp methodsFor: 'comparing' stamp: 'ccn 10/6/2000 23:23'!
> aTimeStamp
	"Answer true if the receiver is greater than aTimeStamp, otherwise answer false."

	^self date > aTimeStamp date
		or: [self date = aTimeStamp date and: [self time > aTimeStamp time]]! !

!TimeStamp methodsFor: 'comparing' stamp: 'ccn 10/6/2000 23:24'!
>= aTimeStamp
	"Answer true if the receiver is greater than or equal to aTimeStamp, otherwise answer false."

	^self date > aTimeStamp date
		or: [self date = aTimeStamp date and: [self time >= aTimeStamp time]]! !

!TimeStamp methodsFor: 'comparing' stamp: 'ccn 10/6/2000 23:06'!
hash
	"Answer the Integer hash value for the receiver."

	^self date hash bitXor: self time hash! !

!TimeStamp methodsFor: 'converting' stamp: 'ccn 10/6/2000 23:04'!
asDate
	"Answer the receiver as an instance of Date."

	^self date! !

!TimeStamp methodsFor: 'converting' stamp: 'ccn 10/6/2000 23:25'!
asSeconds
	"Return the number of seconds in the receiver."

	^(self date asSeconds + self time asSeconds)! !

!TimeStamp methodsFor: 'converting' stamp: 'ccn 10/6/2000 23:04'!
asTime
	"Answer the receiver as an instance of Time."

	^self time! !

!TimeStamp methodsFor: 'converting' stamp: 'ccn 10/6/2000 23:33'!
asTimeStamp
	"Answer the receiver as an instance of TimeStamp."

	^self! !

!TimeStamp methodsFor: 'converting' stamp: 'ccn 10/6/2000 23:34'!
dateAndTime
	"Answer a two element Array containing the receiver's date and time."

	^Array with: self date with: self time! !

!TimeStamp methodsFor: 'printing' stamp: 'ccn 10/6/2000 23:51'!
printOn: aStream
	"Print receiver's date and time on aStream."

	| dateString timeString |
	dateString _ (self date isNil)
		ifTrue: ['no date']
		ifFalse: [self date printString].
	timeString _ (self time isNil)
		ifTrue: ['no time']
		ifFalse: [self time printString].
	(self date isNil and: [self time isNil])
		ifTrue:
			[super printOn: aStream.
			aStream nextPutAll: ' '].
	aStream 
		nextPutAll: dateString;
		nextPutAll: ', ';
		nextPutAll: timeString! !


!TimeStamp class methodsFor: 'instance creation' stamp: 'ccn 10/6/2000 22:59'!
current
	"Answer the current date and time as a TimeStamp."

	| array |
	array _ Time dateAndTimeNow.
	^self date: array first time: array last! !

!TimeStamp class methodsFor: 'instance creation' stamp: 'ccn 10/6/2000 23:00'!
date: aDate time: aTime
	"Answer a new instance based on the given date and time."

	^self
		new date: aDate;
		time: aTime;
		yourself! !

!TimeStamp class methodsFor: 'instance creation' stamp: 'ccn 10/7/2000 00:07'!
fromSeconds: anInteger
	"Answer a new instance based on the given number of seconds."

	| date |
	date _ Date fromSeconds: anInteger.
	^self date: date time: (Time fromSeconds: (anInteger - date asSeconds))! !

!TimeStamp class methodsFor: 'instance creation' stamp: 'ccn 10/7/2000 00:36'!
fromString: aString
	"Answer a new instance for the value given by aString.

	 TimeStamp fromString: '1-10-2000 11:55:00 am'. 
	"

	| stream |
	stream := ReadStream on: aString withBlanksTrimmed.
	^self 
		date: (Date fromString: (stream upTo: $ )) 
		time: (Time fromString: (stream upTo: nil))! !

!TimeStamp class methodsFor: 'instance creation' stamp: 'ccn 10/7/2000 00:18'!
midnight
	"Answer a new instance that represents today at midnight."

	^self midnightOn: Date today! !

!TimeStamp class methodsFor: 'instance creation' stamp: 'ccn 10/7/2000 00:19'!
midnightOn: aDate
	"Answer a new instance that represents aDate at midnight."

	^self date: aDate time: Time midnight! !

!TimeStamp class methodsFor: 'instance creation' stamp: 'ccn 10/7/2000 00:16'!
noon
	"Answer a new instance that represents today at noon."

	^self noonOn: Date today! !

!TimeStamp class methodsFor: 'instance creation' stamp: 'ccn 10/7/2000 00:16'!
noonOn: aDate
	"Answer a new instance that represents aDate at noon."

	^self date: aDate time: Time noon! !


!Unauthorized methodsFor: 'comanche processing'!
asHttpResponseTo: request

	^(HttpResponse status: #unauthorized description: 'Unauthorized for: ', realm)
		fieldAt: 'WWW-Authenticate' put: 'Basic realm="', realm, '"';
		yourself! !

!Unauthorized methodsFor: 'exceptionSignaler'!
signalRealm: aString

	realm _ aString.
	self signal.! !


!UndefinedObject methodsFor: 'converting' stamp: 'SVP 8/23/1999 19:08'!
asHttpResponseTo: request

	^HttpResponse 
		status: #notFound 
		description: 'The object you requested was not found on this server.'! !


!WebBrowser methodsFor: 'testing' stamp: 'SVP 8/23/1999 18:58'!
isFramesCapable

	^false! !

!WebBrowser methodsFor: 'accessing' stamp: 'SVP 8/23/1999 18:55'!
headerString

	^headerString! !

!WebBrowser methodsFor: 'accessing' stamp: 'SVP 8/23/1999 18:55'!
headerString: aString

	headerString _ aString! !

!WebBrowser methodsFor: 'initialization' stamp: 'SVP 8/23/1999 18:58'!
initFromHeader: aString

	headerString _ aString! !


!InternetExplorer methodsFor: 'initialization' stamp: 'SVP 8/23/1999 19:03'!
initFromHeader: aString

	| tokens ver |
	super initFromHeader: aString.
	tokens _ (aString findTokens: ';').
	ver _ (((tokens at: 2) findTokens: ' ') at: 2) findTokens: '.'.
	majorVersion _ (ver at: 1) asNumber.
	minorVersion _ (ver at: 2) asNumber.
! !

!InternetExplorer methodsFor: 'accessing' stamp: 'SVP 8/23/1999 19:04'!
majorVersion

	^majorVersion! !

!InternetExplorer methodsFor: 'accessing' stamp: 'SVP 8/23/1999 19:04'!
minorVersion

	^minorVersion! !

!InternetExplorer methodsFor: 'testing' stamp: 'svp 11/23/1999 16:05'!
isFramesCapable

	^majorVersion >= 3.! !


!Netscape methodsFor: 'testing' stamp: 'svp 11/23/1999 16:05'!
isFramesCapable

	^majorVersion >= 3.! !

!Netscape methodsFor: 'initialization' stamp: 'SVP 8/24/1999 16:00'!
initFromHeader: aString

	| tokens ver |
	super initFromHeader: aString.
	tokens _ (aString findTokens: '/ ').
	ver _ (tokens at: 2) findTokens: '.'.
	majorVersion _ (ver at: 1) asNumber.
	minorVersion _ (ver at: 2) asNumber.
! !


!WebBrowser class methodsFor: 'instance creation' stamp: 'svp 11/23/1999 16:05'!
concreteInstanceFromHeader: aString

	| tmp |
	#(InternetExplorer Netscape WebBrowser) do: [ :ea |
		(tmp _ (Smalltalk at: ea) fromHeaderString: aString) notNil ifTrue: [
			^tmp
		].
	].! !

!WebBrowser class methodsFor: 'instance creation' stamp: 'SVP 8/23/1999 18:57'!
fromHeaderString: aString

	^self new
		initFromHeader: aString;
		yourself! !


!InternetExplorer class methodsFor: 'instance creation' stamp: 'SVP 8/24/1999 15:45'!
fromHeaderString: aString

	(aString findString: 'MSIE') > 0 ifTrue: [
		^super fromHeaderString: aString
	].
	^nil
! !


!Netscape class methodsFor: 'instance creation' stamp: 'svp 11/23/1999 16:04'!
fromHeaderString: aString

#todo. "Find out what Netscape's header string looks like"

	(((aString findString: 'Nav') > 0) or: [ (aString findString: '[en]') > 0 ]) ifTrue: [
		^super fromHeaderString: aString
	].
	^nil
! !


!WriteStream methodsFor: 'as yet unclassified' stamp: 'SVP 8/24/1999 15:49'!
mimeType

	^'text/html'! !

!WriteStream methodsFor: 'converting' stamp: 'bolot 1/3/2000 17:13'!
asHttpResponseTo: request

	^HttpResponse fromMIMEDocument: 
		(MIMEDocument contentType: self mimeType content: self contents)! !


!JdmWriteStream methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:47'!
close
"	super close.
	self breakDependents"! !

!JdmWriteStream methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:47'!
flush
"	super flush."
	self outputPacket flush! !

!JdmWriteStream methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:47'!
nextPutAllNullTerminated: aCollection2 
	self nextPutAll: aCollection2.
	self nextPut: self class null asCharacter! !

!JdmWriteStream methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:47'!
nextPutCommand: aCommand 
	self
		nextPut: aCommand command asCharacter;
		nextPutAllNullTerminated: aCommand message! !

!JdmWriteStream methodsFor: 'accessing' stamp: 'jb 3/2/1999 20:37'!
outputPacket
	^outputPacket! !

!JdmWriteStream methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:47'!
outputPacket: p
	outputPacket _ p! !

!JdmWriteStream methodsFor: 'accessing' stamp: 'bolot 12/16/1999 16:48'!
setWritePosition: aPosition 
	position _ (aPosition > writeLimit 
		ifTrue: [writeLimit]
		ifFalse: [aPosition])! !

!JdmWriteStream methodsFor: 'initialize'!
initialize! !


!JdmWriteStream class methodsFor: 'constants'!
null
	^0! !

!JdmWriteStream class methodsFor: 'instance creation' stamp: 'jb 3/2/1999 20:40'!
on: aCollection startingAt: aPosition 
outputPacket: op
	| ws |
	ws := (self
		on: aCollection)
		setWritePosition: aPosition.
	ws outputPacket: op.
	^ws! !

!JdmWriteStream class methodsFor: 'instance creation' stamp: 'jb 3/2/1999 20:40'!
xon: aCollection
 outputPacket: op
	| ws |
	ws := (super on: aCollection) initialize.
	ws outputPacket: op.
	^ws! !


!ReadWriteStream methodsFor: 'converting' stamp: 'SVP 8/23/1999 19:07'!
asHttpResponseTo: request

	^HttpResponse fromStream: self! !


!FileStream class methodsFor: 'exceptions' stamp: 'svp 12/13/1999 08:38'!
signalFileDoesNotExist: fileName

	FileDoesNotExist new signalFileName: fileName class: self! !


!StandardFileStream methodsFor: 'open/close' stamp: 'svp 12/10/1999 15:38'!
open: fileName forWrite: writeMode 
	"Open the file with the given name. If writeMode is true, allow writing, otherwise open the file in read-only mode."
	"Changed to do a GC and retry before failing ar 3/21/98 17:25"
	"SVP: Removed the retry with GC because of the performance hit...just need to be sure
	that we diligently close files, without relying on GC to clean up handles."

	fileID _ self primOpen: fileName writable: writeMode.
	fileID ifNil: [^ nil].  "allows sender to detect failure"
	self register.
	name _ fileName.
	rwmode _ writeMode.
	buffer1 _ String new: 1.
! !

!StandardFileStream methodsFor: 'access' stamp: 'SVP 8/24/1999 15:47'!
mimeType

	^MIMEDocument guessTypeFromName: self name.
! !


!StandardFileStream class methodsFor: 'file creation' stamp: 'TPR 8/13/1999 21:26'!
oldFileNamed: fileName
	"Open an existing file with the given name for reading and writing. If the name has no directory part, then the file will be created in the default directory. If the file already exists, its prior contents may be modified or replaced, but the file will not be truncated on close."

	| selection fullName newName |
	fullName _ self fullName: fileName.
	(self isAFileNamed: fullName) ifTrue:
		[^ self new open: fullName forWrite: true].

	"File does not exist..."
	selection _ (PopUpMenu labels:
'create a new file
choose another name
cancel')
			startUpWithCaption: (FileDirectory localNameFor: fullName) , '
does not exist.'.
	selection = 1 ifTrue:
		[^ self new open: fullName forWrite: true].
	selection = 2 ifTrue:
		[ newName _ FillInTheBlank request: 'Enter a new file name'
						initialAnswer:  fullName.
		^ self oldFileNamed:
			(self fullName: newName)].
	self halt! !


!XMLdocument methodsFor: 'accessing' stamp: 'bolot 5/3/1999 00:14'!
doctype
	^type! !

!XMLdocument methodsFor: 'accessing' stamp: 'bolot 5/3/1999 00:14'!
documentElement
	^root! !

!XMLdocument methodsFor: 'accessing' stamp: 'bolot 5/3/1999 00:14'!
implementation
	^implementation! !

!XMLdocument methodsFor: 'accessing' stamp: 'bolot 5/3/1999 00:15'!
root
	^root! !

!XMLdocument methodsFor: 'private' stamp: 'bolot 5/3/1999 04:02'!
privDocumentElement: elem
	root _ elem! !

!XMLdocument methodsFor: 'printing' stamp: 'bolot 12/16/1999 11:44'!
printXmlOn: stream
	self root printXmlOn: stream! !

!XMLdocument methodsFor: 'xml rpc' stamp: 'bolot 12/15/1999 17:42'!
asMessage
	"convert self (an XMLdocument) into a Message"
	"return nil if self is not an XML RPC message"

	| selector arguments |
	self isXMLrpc
		ifFalse: [^nil].

	selector _ self methodName asSymbol.
	arguments _ self params collect: [:elem |
		elem asXmlRpcParam].

	^Message selector: selector arguments: arguments! !

!XMLdocument methodsFor: 'xml rpc' stamp: 'bolot 1/15/2000 16:38'!
asSoapMessage
	^Message selector: self root name arguments: {self root asSoapDictionary}! !

!XMLdocument methodsFor: 'xml rpc' stamp: 'bolot 12/15/1999 17:41'!
isXMLrpc
	^self root name asLowercase = 'methodcall'
	and: [self root children size = 2
	and: [self root children first name asLowercase = 'methodname'
	and: [self root children second name asLowercase = 'params']]]! !

!XMLdocument methodsFor: 'xml rpc' stamp: 'bolot 12/15/1999 17:39'!
methodName
	"PRE: must be validated with isXMLrpc"
	^self root children first value! !

!XMLdocument methodsFor: 'xml rpc' stamp: 'bolot 12/15/1999 17:41'!
params
	"PRE: must be validated with isXMLrpc"
	^self root children second children! !


!XMLdocument class methodsFor: 'instance creation' stamp: 'bolot 5/3/1999 00:58'!
defaultDelimiters
	^Character separators! !


!XMLnode methodsFor: 'initialization' stamp: 'bolot 5/4/1999 00:28'!
initialize
	children _ OrderedCollection new.
	attributes _ Dictionary new.
	type _ self class defaultType! !

!XMLnode methodsFor: 'private accessing' stamp: 'bolot 5/2/1999 23:13'!
children
	^children! !

!XMLnode methodsFor: 'private accessing' stamp: 'bolot 5/3/1999 00:00'!
document
	^document! !

!XMLnode methodsFor: 'private accessing' stamp: 'bolot 5/2/1999 23:24'!
name
	^name! !

!XMLnode methodsFor: 'private accessing' stamp: 'bolot 5/2/1999 23:13'!
parent
	^parent! !

!XMLnode methodsFor: 'private accessing' stamp: 'bolot 12/16/1999 11:37'!
siblings
	parent ifNil: [^nil].
	^parent children select: [:elem | elem ~= self]! !

!XMLnode methodsFor: 'private accessing' stamp: 'bolot 5/2/1999 23:24'!
value
	^value! !

!XMLnode methodsFor: 'read-only attributes' stamp: 'bolot 5/2/1999 23:13'!
attributes
	^attributes! !

!XMLnode methodsFor: 'read-only attributes' stamp: 'bolot 5/2/1999 23:50'!
childNodes
	^children! !

!XMLnode methodsFor: 'read-only attributes' stamp: 'bolot 12/16/1999 11:37'!
firstChild
	children isEmptyOrNil ifTrue: [^nil].
	^children first! !

!XMLnode methodsFor: 'read-only attributes' stamp: 'bolot 12/15/1999 01:29'!
lastChild
	children isEmptyOrNil ifTrue: [^nil].
	^children last! !

!XMLnode methodsFor: 'read-only attributes' stamp: 'bolot 12/16/1999 11:37'!
nextSibling
	(parent isNil or: [parent lastChild = self]) ifTrue: [^nil].
	parent children after: self! !

!XMLnode methodsFor: 'read-only attributes' stamp: 'bolot 5/2/1999 23:49'!
nodeName
	^name! !

!XMLnode methodsFor: 'read-only attributes' stamp: 'bolot 5/2/1999 23:49'!
nodeType
	^type! !

!XMLnode methodsFor: 'read-only attributes' stamp: 'bolot 5/2/1999 23:49'!
nodeValue
	^value! !

!XMLnode methodsFor: 'read-only attributes' stamp: 'bolot 5/3/1999 00:00'!
ownerDocument
	^document! !

!XMLnode methodsFor: 'read-only attributes' stamp: 'bolot 5/2/1999 23:49'!
parentNode
	^parent! !

!XMLnode methodsFor: 'read-only attributes' stamp: 'bolot 12/16/1999 11:37'!
previousSibling
	(parent isNil or: [parent firstChild = self]) ifTrue: [^nil].
	parent children before: self! !

!XMLnode methodsFor: 'testing' stamp: 'bolot 12/16/1999 11:39'!
hasChildNodes
	^children isEmptyOrNil not! !

!XMLnode methodsFor: 'testing' stamp: 'bolot 12/16/1999 11:39'!
hasChildren
	^children isEmptyOrNil not! !

!XMLnode methodsFor: 'testing' stamp: 'bolot 5/2/1999 23:19'!
hasSiblings
	^parent isNil or: [parent children size = 0]! !

!XMLnode methodsFor: 'testing' stamp: 'bolot 5/3/1999 03:40'!
isClosing
	^type = #closingElementNode! !

!XMLnode methodsFor: 'private' stamp: 'bolot 5/2/1999 23:17'!
privAddAttribute: attribName value: attribValue
	attributes at: attribName put: attribValue! !

!XMLnode methodsFor: 'private' stamp: 'bolot 5/2/1999 23:15'!
privAddChild: elem
	children add: elem! !

!XMLnode methodsFor: 'private' stamp: 'bolot 5/3/1999 00:00'!
privDocument: doc
	document _ doc! !

!XMLnode methodsFor: 'private' stamp: 'bolot 5/2/1999 23:24'!
privName: string
	name _ string! !

!XMLnode methodsFor: 'private' stamp: 'bolot 5/2/1999 23:14'!
privParent: elem
	parent _ elem! !

!XMLnode methodsFor: 'private' stamp: 'bolot 5/3/1999 03:22'!
privType: t
	type _ t! !

!XMLnode methodsFor: 'private' stamp: 'bolot 5/2/1999 23:24'!
privValue: string
	value _ string! !

!XMLnode methodsFor: 'converting' stamp: 'bolot 5/5/1999 14:56'!
printHtmlOn: stream
	stream nextPutAll: '<B>', self nodeName, '</B>'; cr.
	self nodeValue ifNotNil: [stream nextPutAll: '<BR>', self nodeValue; cr].
	(attributes notNil and: [attributes size > 0])
		ifTrue: [stream nextPutAll: '<BR>Attributes: <UL>'; cr.
			attributes associationsDo: [:a |
				stream nextPutAll: '<LI>', a key, '=', a value].
			stream nextPutAll: '</UL>'; cr].
	(children notNil and: [children size > 0])
		ifTrue: [stream nextPutAll: '<BR>Children<UL>'; cr.
			children do: [:c | stream nextPutAll: '<LI>'.
				c printHtmlOn: stream].
			stream nextPutAll: '</UL>'; cr].! !

!XMLnode methodsFor: 'converting' stamp: 'bolot 5/4/1999 16:20'!
printOn: stream
	super printOn: stream.
	stream nextPutAll: ' <', name asString, '>'! !

!XMLnode methodsFor: 'converting' stamp: 'bolot 12/16/1999 11:45'!
printXmlOn: stream
	stream nextPutAll: '<', self nodeName.
	(attributes notNil and: [attributes size > 0])
		ifTrue: [attributes associationsDo: [:a |
				stream nextPutAll: ' ', a key, '=', a value]].
	stream nextPutAll: '>'; cr.
	self nodeValue ifNotNil: [stream nextPutAll: self nodeValue; cr].
	self hasChildNodes
		ifTrue: [children do: [:c | c printXmlOn: stream. stream cr]].
	stream nextPutAll: '</', self nodeName, '>'.! !

!XMLnode methodsFor: 'factory methods' stamp: 'bolot 5/3/1999 00:17'!
appendChild: node
	children add: node! !

!XMLnode methodsFor: 'factory methods' stamp: 'bolot 5/3/1999 00:17'!
removeChild: node
	children remove: node ifAbsent: []! !

!XMLnode methodsFor: 'xml rpc' stamp: 'bolot 1/15/2000 16:36'!
asSoapDictionary
	| dict |
	dict _ Dictionary new.
	self children do: [:child |
		dict at: child name put: child asSoapDictionary].
	dict addAll: attributes.
	self value isEmptyOrNil
		ifFalse: [dict at: #value put: self value].
	^dict! !

!XMLnode methodsFor: 'xml rpc' stamp: 'bolot 12/15/1999 17:18'!
asXmlRpcParam
	self isXmlRpcParam
		ifFalse: [^nil].

	^self children first asXmlRpcParamValue! !

!XMLnode methodsFor: 'xml rpc' stamp: 'bolot 12/15/1999 17:22'!
asXmlRpcParamValue
	self isXmlRpcParamValue
		ifFalse: [^nil].

	^self firstChild asXmlRpcParamValue2! !

!XMLnode methodsFor: 'xml rpc' stamp: 'bolot 12/15/1999 17:22'!
asXmlRpcParamValue2
	self isXmlRpcParamValue2
		ifFalse: [^nil].

	^self value! !

!XMLnode methodsFor: 'xml rpc' stamp: 'bolot 12/15/1999 17:16'!
isXmlRpcParam
	^self name asLowercase = 'param'! !

!XMLnode methodsFor: 'xml rpc' stamp: 'bolot 12/15/1999 17:19'!
isXmlRpcParamValue
	^self name asLowercase = 'value'
	and: [self children size = 1]! !

!XMLnode methodsFor: 'xml rpc' stamp: 'bolot 12/15/1999 17:42'!
isXmlRpcParamValue2
	^#('int' 'i4' 'boolean' 'string' 'double' 'dateTime.iso8601' 'base64' 'struct' 'array')
	includes: self name asLowercase! !


!XMLcomment methodsFor: 'accessing' stamp: 'bolot 5/3/1999 23:47'!
nodeType
	^#commentNode! !


!XMLelement methodsFor: 'initialization' stamp: 'bolot 5/5/1999 12:41'!
initialize
	super initialize.
	self makeStartTag! !

!XMLelement methodsFor: 'accessing' stamp: 'bolot 5/3/1999 00:28'!
getAttribute: attribName
	^attributes at: attribName ifAbsent: [nil]! !

!XMLelement methodsFor: 'accessing' stamp: 'bolot 5/5/1999 12:40'!
makeEmptyTag
	self privSpecialHandlingType: #emptyTag! !

!XMLelement methodsFor: 'accessing' stamp: 'bolot 5/5/1999 12:40'!
makeEndTag
	self privSpecialHandlingType: #endTag! !

!XMLelement methodsFor: 'accessing' stamp: 'bolot 5/5/1999 12:39'!
makeStartTag
	self privSpecialHandlingType: #startTag! !

!XMLelement methodsFor: 'accessing' stamp: 'bolot 5/3/1999 00:29'!
removeAttribute: attribName
	attributes removeKey: attribName ifAbsent: []! !

!XMLelement methodsFor: 'accessing' stamp: 'bolot 5/3/1999 00:28'!
setAttribute: attribName value: attribValue
	attributes at: attribName put: attribValue! !

!XMLelement methodsFor: 'accessing' stamp: 'bolot 5/3/1999 00:27'!
tagName
	^name! !

!XMLelement methodsFor: 'private' stamp: 'bolot 5/5/1999 12:38'!
privSpecialHandlingType: someType
	specialHandlingType _ someType! !

!XMLelement methodsFor: 'testing' stamp: 'bolot 5/5/1999 12:49'!
isEmptyTag
	^specialHandlingType = #emptyTag! !

!XMLelement methodsFor: 'testing' stamp: 'bolot 5/5/1999 12:36'!
isEndTag
	^specialHandlingType = #endTag! !

!XMLelement methodsFor: 'testing' stamp: 'bolot 5/5/1999 12:36'!
isStartTag
	^specialHandlingType = #startTag! !


!XMLnode class methodsFor: 'instance creation' stamp: 'bolot 5/4/1999 00:27'!
defaultType
	^nil! !

!XMLnode class methodsFor: 'instance creation' stamp: 'bolot 5/3/1999 03:35'!
fromTag: tag
	self subclassResponsibility! !


!XMLcomment class methodsFor: 'instance creation' stamp: 'bolot 5/4/1999 00:28'!
defaultType
	^#commentNode! !


!XMLelement class methodsFor: 'instance creation' stamp: 'bolot 5/4/1999 00:28'!
defaultType
	^#elementNode! !

!XMLelement class methodsFor: 'instance creation' stamp: 'bolot 5/5/1999 12:31'!
fromTag: string
	" Takes an input of the form: <tagstuff> OR tagstuff "
	" XMLelement fromTag: '<doc> ' "
	| elem tagstuff tmpString |
	tmpString _ string withBlanksTrimmed.
	(tmpString first = $< and: [tmpString last = $>])
		ifTrue: [tagstuff _ tmpString copyFrom: 2 to: tmpString size - 1]
		ifFalse: [tagstuff _ tmpString].
	[elem _ self privParseTag: tagstuff]
		ifError: [:err :msg | ^nil].
	^elem
! !

!XMLelement class methodsFor: 'instance creation' stamp: 'bolot 5/3/1999 01:35'!
privParseTag: string
	| delimiters elem pos endPos attribName attribValue |
	delimiters _ XMLdocument defaultDelimiters , '>'.
	elem _ self new initialize.
	pos _ 1.
	endPos _ string findDelimiters: delimiters startingAt: pos.
	endPos = 0 ifTrue: [self error: 'bad doc!!'].
	elem privName: (string copyFrom: pos to: endPos-1) withBlanksTrimmed.
	[(pos _ endPos+1) < string size] whileTrue: [
		endPos _ string indexOf: $= startingAt: pos.
		endPos = 0 ifTrue: [self error: 'bad doc!!'].
		attribName _ (string copyFrom: pos to: endPos-1) withBlanksTrimmed.
		pos _ string indexOf: $" startingAt: endPos.
		pos = 0 ifTrue: [self error: 'bad doc!!'].
		endPos _ string indexOf: $" startingAt: pos + 1.
		endPos = 0 ifTrue: [self error: 'bad doc!!'].
		attribValue _ (string copyFrom: pos+1 to: endPos-1) withBlanksTrimmed.
		elem setAttribute: attribName value: attribValue].
	
	^elem
! !


!XMLparser class methodsFor: 'parsing' stamp: 'bolot 5/4/1999 00:21'!
parse: string
	^self parseStream: (ReadStream on: string)! !

!XMLparser class methodsFor: 'parsing' stamp: 'bolot 12/15/1999 16:24'!
parseFileNamed: fileName
	^self parseStream: (FileStream readOnlyFileNamed: fileName)! !

!XMLparser class methodsFor: 'parsing' stamp: 'bolot 5/3/1999 03:42'!
parseStream: stream
	^self parseTokens: (XMLtokenizer on: stream)! !

!XMLparser class methodsFor: 'parsing' stamp: 'bolot 12/15/1999 03:04'!
parseTokens: tokenStream
	| doc token stack |
	doc _ XMLdocument new.
	stack _ OrderedCollection new.
	[(token _ tokenStream next) isNil
		or: [token nodeType = #elementNode]] whileFalse.
	token ifNil: [^nil].
	doc privDocumentElement: token.
	token privDocument: doc.
	stack add: token.
	[(token _ tokenStream next) notNil and: [stack isEmpty not]] whileTrue: [
		token nodeType caseOf:
		{
			[#elementNode] -> [
				token isEndTag
					ifTrue: [(stack last nodeName = token nodeName)
							ifFalse: [self error: 'Start and end tags do not match'].
						stack removeLast]
					ifFalse: [stack last appendChild: token.
						token privDocument: doc.
						token isEmptyTag ifFalse: [stack add: token]].
				].
			[#textNode] -> [token nodeValue isAllSeparators
					ifFalse: [stack last privValue: token nodeValue] ]
		}
		otherwise: [].
		].
	^doc! !


!XMLtext methodsFor: 'read-only attributes' stamp: 'bolot 5/3/1999 23:54'!
nodeType
	^#textNode! !

!XMLtext methodsFor: 'converting' stamp: 'bolot 5/5/1999 15:05'!
printOn: stream
	super printOn: stream.
	stream nextPutAll: ' <', value asString, '>'! !


!XMLtext class methodsFor: 'instance creation' stamp: 'bolot 5/4/1999 00:28'!
defaultType
	^#textNode! !


!XMLtoHTMLconverter class methodsFor: 'converting' stamp: 'bolot 5/5/1999 13:44'!
browseFile: string
	" XMLtoHTMLconverter browseFile: 'anind-s0001.xml' "
	self browseStream: (FileStream oldFileNamed: string)! !

!XMLtoHTMLconverter class methodsFor: 'converting' stamp: 'bolot 5/5/1999 13:45'!
browseStream: stream
	| htmldoc htmlstream |
	htmlstream _ XMLtoHTMLconverter convertStream: stream.
	htmlstream ifNil: [self error: 'Bad XML document'].
	htmldoc _ MIMEDocument contentType: 'text/html' content: htmlstream contents url: 'localdoc'.
	Scamper new stopEverything; displayTextHtmlPage: htmldoc; openAsMorph
! !

!XMLtoHTMLconverter class methodsFor: 'converting' stamp: 'bolot 5/5/1999 13:45'!
browseString: string
	self browseStream: (ReadStream on: string)! !

!XMLtoHTMLconverter class methodsFor: 'converting' stamp: 'bolot 5/5/1999 13:53'!
convertStream: stream
	| out doc |
	[doc _ XMLparser parseStream: stream] ifError: [:e :m | doc _ nil].
	(doc isNil or: [doc documentElement isNil])
		ifTrue: [^nil].

	out _ WriteStream on: String new.
	out nextPutAll:
'<HTML>
	<HEAD><TITLE>', doc documentElement nodeName, '</TITLE></HEAD>

<BODY>
<H3>Document: ', doc documentElement nodeName, '</H3>
'.

	doc documentElement printHtmlOn: out.

	out nextPutAll:
'</UL>
</BODY>
</HTML>
'.
	^out
! !


!XMLtokenizer methodsFor: 'initialization' stamp: 'bolot 12/15/1999 01:43'!
initialize: aStream
	inputStream _ aStream! !

!XMLtokenizer methodsFor: 'accessing' stamp: 'bolot 5/3/1999 01:46'!
contents
	^inputStream contents! !

!XMLtokenizer methodsFor: 'testing' stamp: 'bolot 5/3/1999 01:44'!
atEnd
	^inputStream atEnd! !

!XMLtokenizer methodsFor: 'tokenizing' stamp: 'bolot 12/15/1999 02:50'!
next 
	"return the next XMLnode, or nil if there are no more"
	| node |
	"branch, depending on what the first character is"
	inputStream skipSeparators.
	self atEnd ifTrue: [ ^nil ].
	inputStream peek = $<
		ifTrue: [ node _ self nextNode ]
		ifFalse: [ node _ self nextText ].
	^node! !

!XMLtokenizer methodsFor: 'tokenizing' stamp: 'bolot 5/4/1999 01:19'!
nextCommand
	| command string |
	inputStream next. " ignore ? "
	string _ inputStream upTo: $>.
	string _ (string copyFrom: 1 to: string size - 1) withBlanksTrimmed.
	" TODO: parse the command "
	command _ (XMLelement fromTag: string) privType: #processingInstructionNode.
	^command! !

!XMLtokenizer methodsFor: 'tokenizing' stamp: 'bolot 5/4/1999 00:29'!
nextComment
	| node string |
	inputStream next. " ignore !! "
	string _ inputStream upTo: $>.
	" TODO: strip the -- "
	node _ XMLcomment new initialize; privValue: string.
	^node! !

!XMLtokenizer methodsFor: 'tokenizing' stamp: 'bolot 5/3/1999 03:19'!
nextNode
	inputStream next. " ignore < "
	inputStream peek == $!! ifTrue: [^self nextComment].
	inputStream peek == $? ifTrue: [^self nextCommand].
	^self nextTag! !

!XMLtokenizer methodsFor: 'tokenizing' stamp: 'bolot 12/15/1999 03:03'!
nextTag
	| string tag end |
	(inputStream peek = $/)
		ifTrue: [inputStream next. end _ true].
	string _ (inputStream upTo: $>) withBlanksTrimmed.
	tag _ XMLelement fromTag: string.
	end ifNotNil: [tag makeEndTag].
	^tag! !

!XMLtokenizer methodsFor: 'tokenizing' stamp: 'bolot 5/4/1999 01:18'!
nextText
	| string node |
	string _ (inputStream upTo: $<) withBlanksTrimmed.
	inputStream position: inputStream position - 1.
	node _ XMLtext new initialize; privValue: string.
	^node! !


!XMLtokenizer class methodsFor: 'instance creation' stamp: 'bolot 12/15/1999 01:43'!
on: aStream
	^self basicNew initialize: aStream! !


!XmlRpcModule methodsFor: 'processing' stamp: 'bolot 1/9/2000 21:55'!
process: request
	| rawXml xmlDoc |
	(request contentType = MIMEDocument contentTypeXml
	and: [request url asLowercase beginsWith: '/', self name])
		ifFalse: [^nil].
	rawXml _ request stream upToEnd. "body"
	[xmlDoc _ XMLparser parseString: rawXml]
		ifError: [:err :rcvr | ^nil "return error here"].
	^self processXmlDocument: xmlDoc! !

!XmlRpcModule methodsFor: 'processing' stamp: 'bolot 1/9/2000 21:53'!
processXmlDocument: xmlDoc
	| message |
	message _ xmlDoc asMessage.
	^message sentTo: self. "somehow return the result of this"! !


!TimeStamp reorganize!
('accessing' date date: time time:)
('arithmetic' minusDays: minusSeconds: plusDays: plusSeconds:)
('comparing' < <= = > >= hash)
('converting' asDate asSeconds asTime asTimeStamp dateAndTime)
('printing' printOn:)
!

TerminalObject initialize!

!SocketStream reorganize!
('initialization' initialize initialize:)
('http' contentLength fastHeader: getSubHeader header: readHeader)
('network' localAddress localPort remoteAddress remotePort)
('stream in' next next: nextChunk putDataBack: upTo: upToAll: upToEnd)
('stream out' cr crlf flush nextPut: nextPutAll:)
('accessing' close header isBuffered setBuffered setUnBuffered)
('testing' atEnd isConnected isDataAvailable isOtherEndConnected status)
('private' inDataCount incInDataCountBy: incOutDataCountBy: outDataCount pvtGetData resetInStream resetOutStream resetStatus socket:)
!

HttpRequest initialize!

!HttpRequest reorganize!
('initialization' initializeFromStream: stream:)
('copying')
('accessing' addCookie: body body: contentLength contentType cookies destroy endOfRequestMarker formFields getFields header localAddress localPort machineName method newCookies operation postFields protocol referer remoteAddress responseHeader sessionClass simpleUrl stream timeTaken timeTaken: timestamp timestamp: url webBrowser)
('multipart support' multipartBoundary)
('converting' printHtmlOn: printHtmlString printOn: writeOn:)
('logging' printFullLogOn: printLogOn:)
('private' hostName networkHost privHeader: privOperation: privPostFields: privProperties privProperties: privResponseHeader: privStream: privUrl: pvtHeader: pvtMethod: pvtOperation: pvtProtocol: pvtReadRequestFrom: pvtRemoteAddress: pvtStream: pvtUrl:)
('authentication' user)
('response' redirectTo: responseHeaderAt:put:)
('serving')
('errors' badRequest unauthorizedFor:)
('defaults' defaultContentType defaultMethod defaultProtocol defaultUrl)
('testing' isFramesCapable isGetRequest isHeaderRequest isPostRequest)
('client side')
!

JdmStatement initialize!
HttpResponse initialize!

!HttpBadRequest reorganize!
('comanche processing' asHttpResponseTo:)
!

ComancheService initialize!
ComancheServer initialize!

!ComancheModule class reorganize!
('instance creation' defaultDirectory defaultTempDirectory newModuleNamed: newModuleNamed:workDir:tempDir:)
('web server packages' package:)
!


!ComancheModule reorganize!
('accessing' directory name)
('private' privName: privTempDirNamed: privWorkDirNamed: tempDir)
('initialization' initialize logToStream:)
('processing' filter: logRequest: process:)
('permissions' checkAuthorization: isAuthorized:toDo:)
('persistence' readFrom: writeOn:)
('http stuff')
('debugging' printDebugOn:)
!

Comanche initialize!

!Comanche class reorganize!
('initialize-release' initialize)
('version' ancientVersion serverName setVersion: version)
('accessing')
('management')
('preferences' allowUploads caseSensitiveFilenames indexFileNames preferenceAt:ifAbsent: preferences setPreference:toValue:)
('debugging' suppressErrors)
!

Object subclass: #AsyncFile
	instanceVariableNames: 'name writeable semaphore fileHandle position size '
	classVariableNames: 'Busy Error '
	poolDictionaries: ''
	category: 'System-Files'!
